#include "sbgssapi.h"

SB_PHP_METHOD(gss_OID_desc, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(gss_OID_desc));
		intern->len = sizeof(gss_OID_desc);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(gss_OID_desc, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(gss_OID_desc));
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(gss_OID_desc, get_length)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(gss_OID_desc, set_length)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

zend_class_entry *gss_OID_desc_ce_ptr = NULL;

static zend_function_entry gss_OID_desc_methods[] = {
	PHP_ME(gss_OID_desc, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(gss_OID_desc, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(gss_OID_desc, get_length, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(gss_OID_desc, set_length, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_gss_OID_desc(TSRMLS_D)
{
	zend_class_entry ce;
	if (gss_OID_desc_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "gss_OID_desc", gss_OID_desc_methods);
	gss_OID_desc_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(gss_OID_set_desc, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(gss_OID_set_desc));
		intern->len = sizeof(gss_OID_set_desc);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(gss_OID_set_desc, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(gss_OID_set_desc));
}

SB_PHP_METHOD(gss_OID_set_desc, get_count)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(gss_OID_set_desc, set_count)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

zend_class_entry *gss_OID_set_desc_ce_ptr = NULL;

static zend_function_entry gss_OID_set_desc_methods[] = {
	PHP_ME(gss_OID_set_desc, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(gss_OID_set_desc, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(gss_OID_set_desc, get_count, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(gss_OID_set_desc, set_count, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_gss_OID_set_desc(TSRMLS_D)
{
	zend_class_entry ce;
	if (gss_OID_set_desc_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "gss_OID_set_desc", gss_OID_set_desc_methods);
	gss_OID_set_desc_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(gss_buffer_desc, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(gss_buffer_desc));
		intern->len = sizeof(gss_buffer_desc);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(gss_buffer_desc, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(gss_buffer_desc));
}

SB_PHP_METHOD(gss_buffer_desc, get_length)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(gss_buffer_desc, set_length)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

zend_class_entry *gss_buffer_desc_ce_ptr = NULL;

static zend_function_entry gss_buffer_desc_methods[] = {
	PHP_ME(gss_buffer_desc, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(gss_buffer_desc, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(gss_buffer_desc, get_length, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(gss_buffer_desc, set_length, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_gss_buffer_desc(TSRMLS_D)
{
	zend_class_entry ce;
	if (gss_buffer_desc_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "gss_buffer_desc", gss_buffer_desc_methods);
	gss_buffer_desc_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(gss_channel_bindings_desc_t, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(gss_channel_bindings_desc_t));
		intern->len = sizeof(gss_channel_bindings_desc_t);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(gss_channel_bindings_desc_t, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(gss_channel_bindings_desc_t));
}

SB_PHP_METHOD(gss_channel_bindings_desc_t, get_initiator_addrtype)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(gss_channel_bindings_desc_t, set_initiator_addrtype)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(gss_channel_bindings_desc_t, get_acceptor_addrtype)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(gss_channel_bindings_desc_t, set_acceptor_addrtype)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

zend_class_entry *gss_channel_bindings_desc_t_ce_ptr = NULL;

static zend_function_entry gss_channel_bindings_desc_t_methods[] = {
	PHP_ME(gss_channel_bindings_desc_t, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(gss_channel_bindings_desc_t, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(gss_channel_bindings_desc_t, get_initiator_addrtype, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(gss_channel_bindings_desc_t, set_initiator_addrtype, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(gss_channel_bindings_desc_t, get_acceptor_addrtype, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(gss_channel_bindings_desc_t, set_acceptor_addrtype, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_gss_channel_bindings_desc_t(TSRMLS_D)
{
	zend_class_entry ce;
	if (gss_channel_bindings_desc_t_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "gss_channel_bindings_desc_t", gss_channel_bindings_desc_t_methods);
	gss_channel_bindings_desc_t_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

void SB_CALLBACK TSBGSSErrorEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcOperation, int32_t szOperation, uint32_t MajorStatus, uint32_t MinorStatus, const char * pcMajorErrorMsg, int32_t szMajorErrorMsg, const char * pcMinorErrorMsg, int32_t szMinorErrorMsg)
{
	zval *retval_ptr;
	zval **params[6];
	zval * zSender;
	zval * zOperation;
	zval * zMajorStatus;
	zval * zMinorStatus;
	zval * zMajorErrorMsg;
	zval * zMinorErrorMsg;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zOperation);
	ZVAL_STRINGL(zOperation, pcOperation, szOperation, 1);
	MAKE_STD_ZVAL(zMajorStatus);
	ZVAL_LONG(zMajorStatus, (long)MajorStatus);
	MAKE_STD_ZVAL(zMinorStatus);
	ZVAL_LONG(zMinorStatus, (long)MinorStatus);
	MAKE_STD_ZVAL(zMajorErrorMsg);
	ZVAL_STRINGL(zMajorErrorMsg, pcMajorErrorMsg, szMajorErrorMsg, 1);
	MAKE_STD_ZVAL(zMinorErrorMsg);
	ZVAL_STRINGL(zMinorErrorMsg, pcMinorErrorMsg, szMinorErrorMsg, 1);

	params[0] = &zSender;
	params[1] = &zOperation;
	params[2] = &zMajorStatus;
	params[3] = &zMinorStatus;
	params[4] = &zMajorErrorMsg;
	params[5] = &zMinorErrorMsg;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 6, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zOperation);
	zval_ptr_dtor(&zMajorStatus);
	zval_ptr_dtor(&zMinorStatus);
	zval_ptr_dtor(&zMajorErrorMsg);
	zval_ptr_dtor(&zMinorErrorMsg);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElGSSCustomContext_ce_ptr = NULL;

SB_PHP_METHOD(TElGSSCustomContext, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGSSCustomContext_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSCustomContext___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElGSSCustomContext_methods[] = {
	PHP_ME(TElGSSCustomContext, __construct, arginfo_TElGSSCustomContext___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGSSCustomContext(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGSSCustomContext_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGSSCustomContext", TElGSSCustomContext_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElGSSCustomContext_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGSSCustomName_ce_ptr = NULL;

SB_PHP_METHOD(TElGSSCustomName, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGSSCustomName_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSCustomName___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElGSSCustomName_methods[] = {
	PHP_ME(TElGSSCustomName, __construct, arginfo_TElGSSCustomName___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGSSCustomName(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGSSCustomName_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGSSCustomName", TElGSSCustomName_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElGSSCustomName_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGSSBaseMechanism_ce_ptr = NULL;

SB_PHP_METHOD(TElGSSBaseMechanism, Initialize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGSSBaseMechanism_Initialize(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSBaseMechanism, GetLastMajorStatus)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElGSSBaseMechanism_GetLastMajorStatus(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSBaseMechanism, GetLastMinorStatus)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElGSSBaseMechanism_GetLastMinorStatus(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSBaseMechanism, AcquireCred)
{
	SBArrayZValInfo aiMechOID;
	TElClassHandle hoCtx;
	zval *oCtx;
	zval *zaMechOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO", &zaMechOID, &oCtx, TElGSSCustomContext_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaMechOID)) || (IS_ARRAY == Z_TYPE_P(zaMechOID)) || (IS_NULL == Z_TYPE_P(zaMechOID))) && PZVAL_IS_REF(oCtx) && (IS_OBJECT == Z_TYPE_P(oCtx)))
	{
		uint32_t u4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaMechOID, &aiMechOID TSRMLS_CC)) RETURN_FALSE;
		hoCtx = SBGetObjectHandle(oCtx TSRMLS_CC);
		SBCheckError(TElGSSBaseMechanism_AcquireCred(SBGetObjectHandle(getThis() TSRMLS_CC), aiMechOID.data, aiMechOID.len, &hoCtx, &u4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiMechOID);
		SBUpdateObjectHandle(oCtx, hoCtx TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &TElGSSCustomContext)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSBaseMechanism, AcceptSecContext)
{
	SBArrayZValInfo aiInputToken;
	SBArrayZValInfo aiOutputToken;
	uint32_t _err;
	zval *oCtx;
	zval *oSourceName;
	zval *zaInputToken;
	zval *zaOutputToken;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!zz", &oCtx, TElGSSCustomContext_ce_ptr, &oSourceName, TElGSSCustomName_ce_ptr, &zaInputToken, &zaOutputToken) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaInputToken)) || (IS_ARRAY == Z_TYPE_P(zaInputToken)) || (IS_NULL == Z_TYPE_P(zaInputToken))) && PZVAL_IS_REF(zaOutputToken) && ((IS_STRING == Z_TYPE_P(zaOutputToken)) || (IS_ARRAY == Z_TYPE_P(zaOutputToken))))
	{
		uint32_t u4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaInputToken, &aiInputToken TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaOutputToken, &aiOutputToken TSRMLS_CC)) RETURN_FALSE;
		_err = TElGSSBaseMechanism_AcceptSecContext(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCtx TSRMLS_CC), SBGetObjectHandle(oSourceName TSRMLS_CC), aiInputToken.data, aiInputToken.len, aiOutputToken.data, &aiOutputToken.len, &u4OutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaOutputToken, &aiOutputToken TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(436118123, 4, aiOutputToken.data, &aiOutputToken.len) TSRMLS_CC);
			((char *)aiOutputToken.data)[aiOutputToken.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiOutputToken);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiInputToken);
		SBSetByteArrayToZVal(&aiOutputToken, zaOutputToken);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElGSSCustomContext, TElGSSCustomName, array of byte|string|NULL, &array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSBaseMechanism, InitSecContext)
{
	SBArrayZValInfo aiInputToken;
	SBArrayZValInfo aiOutputToken;
	uint32_t _err;
	zend_bool bDelegateCred;
	zval *oCtx;
	zval *oTargetName;
	zval *zaInputToken;
	zval *zaOutputToken;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!bzz", &oCtx, TElGSSCustomContext_ce_ptr, &oTargetName, TElGSSCustomName_ce_ptr, &bDelegateCred, &zaInputToken, &zaOutputToken) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaInputToken)) || (IS_ARRAY == Z_TYPE_P(zaInputToken)) || (IS_NULL == Z_TYPE_P(zaInputToken))) && PZVAL_IS_REF(zaOutputToken) && ((IS_STRING == Z_TYPE_P(zaOutputToken)) || (IS_ARRAY == Z_TYPE_P(zaOutputToken))))
	{
		uint32_t u4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaInputToken, &aiInputToken TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaOutputToken, &aiOutputToken TSRMLS_CC)) RETURN_FALSE;
		_err = TElGSSBaseMechanism_InitSecContext(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCtx TSRMLS_CC), SBGetObjectHandle(oTargetName TSRMLS_CC), (int8_t)bDelegateCred, aiInputToken.data, aiInputToken.len, aiOutputToken.data, &aiOutputToken.len, &u4OutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaOutputToken, &aiOutputToken TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-906180115, 5, aiOutputToken.data, &aiOutputToken.len) TSRMLS_CC);
			((char *)aiOutputToken.data)[aiOutputToken.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiOutputToken);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiInputToken);
		SBSetByteArrayToZVal(&aiOutputToken, zaOutputToken);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElGSSCustomContext, TElGSSCustomName, bool, array of byte|string|NULL, &array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSBaseMechanism, ReleaseContext)
{
	TElClassHandle hoCtx;
	zval *oCtx;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oCtx, TElGSSCustomContext_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oCtx) && (IS_OBJECT == Z_TYPE_P(oCtx)))
	{
		uint32_t u4OutResultRaw = 0;
		hoCtx = SBGetObjectHandle(oCtx TSRMLS_CC);
		SBCheckError(TElGSSBaseMechanism_ReleaseContext(SBGetObjectHandle(getThis() TSRMLS_CC), &hoCtx, &u4OutResultRaw) TSRMLS_CC);
		SBUpdateObjectHandle(oCtx, hoCtx TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&TElGSSCustomContext)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSBaseMechanism, ImportName)
{
	char *sInputName;
	int sInputName_len;
	SBArrayZValInfo aiMechOID;
	TElClassHandle hoOutputName;
	zval *oOutputName;
	zval *zaMechOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zsO", &zaMechOID, &sInputName, &sInputName_len, &oOutputName, TElGSSCustomName_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaMechOID)) || (IS_ARRAY == Z_TYPE_P(zaMechOID)) || (IS_NULL == Z_TYPE_P(zaMechOID))) && PZVAL_IS_REF(oOutputName) && (IS_OBJECT == Z_TYPE_P(oOutputName)))
	{
		uint32_t u4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaMechOID, &aiMechOID TSRMLS_CC)) RETURN_FALSE;
		hoOutputName = SBGetObjectHandle(oOutputName TSRMLS_CC);
		SBCheckError(TElGSSBaseMechanism_ImportName(SBGetObjectHandle(getThis() TSRMLS_CC), aiMechOID.data, aiMechOID.len, sInputName, (int32_t)sInputName_len, &hoOutputName, &u4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiMechOID);
		SBUpdateObjectHandle(oOutputName, hoOutputName TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, string, &TElGSSCustomName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSBaseMechanism, ReleaseName)
{
	TElClassHandle hoName;
	zval *oName;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oName, TElGSSCustomName_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oName) && (IS_OBJECT == Z_TYPE_P(oName)))
	{
		uint32_t u4OutResultRaw = 0;
		hoName = SBGetObjectHandle(oName TSRMLS_CC);
		SBCheckError(TElGSSBaseMechanism_ReleaseName(SBGetObjectHandle(getThis() TSRMLS_CC), &hoName, &u4OutResultRaw) TSRMLS_CC);
		SBUpdateObjectHandle(oName, hoName TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&TElGSSCustomName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSBaseMechanism, GetMIC)
{
	SBArrayZValInfo aiMessageBuffer;
	SBArrayZValInfo aiMessageToken;
	uint32_t _err;
	zval *oCtx;
	zval *zaMessageBuffer;
	zval *zaMessageToken;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zz", &oCtx, TElGSSCustomContext_ce_ptr, &zaMessageBuffer, &zaMessageToken) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaMessageBuffer)) || (IS_ARRAY == Z_TYPE_P(zaMessageBuffer)) || (IS_NULL == Z_TYPE_P(zaMessageBuffer))) && PZVAL_IS_REF(zaMessageToken) && ((IS_STRING == Z_TYPE_P(zaMessageToken)) || (IS_ARRAY == Z_TYPE_P(zaMessageToken))))
	{
		uint32_t u4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaMessageBuffer, &aiMessageBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaMessageToken, &aiMessageToken TSRMLS_CC)) RETURN_FALSE;
		_err = TElGSSBaseMechanism_GetMIC(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCtx TSRMLS_CC), aiMessageBuffer.data, aiMessageBuffer.len, aiMessageToken.data, &aiMessageToken.len, &u4OutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaMessageToken, &aiMessageToken TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(1248629905, 3, aiMessageToken.data, &aiMessageToken.len) TSRMLS_CC);
			((char *)aiMessageToken.data)[aiMessageToken.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiMessageToken);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiMessageBuffer);
		SBSetByteArrayToZVal(&aiMessageToken, zaMessageToken);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElGSSCustomContext, array of byte|string|NULL, &array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSBaseMechanism, VerifyMIC)
{
	SBArrayZValInfo aiMessageBuffer;
	SBArrayZValInfo aiMessageToken;
	zval *oCtx;
	zval *zaMessageBuffer;
	zval *zaMessageToken;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zz", &oCtx, TElGSSCustomContext_ce_ptr, &zaMessageBuffer, &zaMessageToken) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaMessageBuffer)) || (IS_ARRAY == Z_TYPE_P(zaMessageBuffer)) || (IS_NULL == Z_TYPE_P(zaMessageBuffer))) && ((IS_STRING == Z_TYPE_P(zaMessageToken)) || (IS_ARRAY == Z_TYPE_P(zaMessageToken)) || (IS_NULL == Z_TYPE_P(zaMessageToken))))
	{
		uint32_t u4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaMessageBuffer, &aiMessageBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaMessageToken, &aiMessageToken TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGSSBaseMechanism_VerifyMIC(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCtx TSRMLS_CC), aiMessageBuffer.data, aiMessageBuffer.len, aiMessageToken.data, aiMessageToken.len, &u4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiMessageBuffer);
		SBFreeArrayZValInfo(&aiMessageToken);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElGSSCustomContext, array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSBaseMechanism, IsMechSupported)
{
	SBArrayZValInfo aiOID;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaOID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGSSBaseMechanism_IsMechSupported(SBGetObjectHandle(getThis() TSRMLS_CC), aiOID.data, aiOID.len, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSBaseMechanism, IsIntegrityAvailable)
{
	zval *oCtx;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCtx, TElGSSCustomContext_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGSSBaseMechanism_IsIntegrityAvailable(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCtx TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElGSSCustomContext)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSBaseMechanism, IsMutualAvailable)
{
	zval *oCtx;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCtx, TElGSSCustomContext_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGSSBaseMechanism_IsMutualAvailable(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCtx TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElGSSCustomContext)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSBaseMechanism, GetMechOIDByHash)
{
	SBArrayZValInfo aiHash;
	uint32_t _err;
	zval *zaHash;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaHash) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHash)) || (IS_ARRAY == Z_TYPE_P(zaHash)) || (IS_NULL == Z_TYPE_P(zaHash))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaHash, &aiHash TSRMLS_CC)) RETURN_FALSE;
		_err = TElGSSBaseMechanism_GetMechOIDByHash(SBGetObjectHandle(getThis() TSRMLS_CC), aiHash.data, aiHash.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(709836803, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiHash);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSBaseMechanism, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElGSSBaseMechanism_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSBaseMechanism, get_Mechs)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElGSSBaseMechanism_get_Mechs(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(400171714, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSBaseMechanism, get_OnError)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBGSSErrorEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElGSSBaseMechanism_get_OnError(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSBaseMechanism, set_OnError)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElGSSBaseMechanism_set_OnError(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBGSSErrorEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBGSSErrorEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSBaseMechanism, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGSSBaseMechanism_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSBaseMechanism_Initialize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSBaseMechanism_GetLastMajorStatus, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSBaseMechanism_GetLastMinorStatus, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSBaseMechanism_AcquireCred, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, MechOID, 0, 1)
	ZEND_ARG_OBJ_INFO(1, Ctx, TElGSSCustomContext, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSBaseMechanism_AcceptSecContext, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, Ctx, TElGSSCustomContext, 1)
	ZEND_ARG_OBJ_INFO(0, SourceName, TElGSSCustomName, 1)
	ZEND_ARG_TYPE_INFO(0, InputToken, 0, 1)
	ZEND_ARG_INFO(1, OutputToken)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSBaseMechanism_InitSecContext, 0, 0, 5)
	ZEND_ARG_OBJ_INFO(0, Ctx, TElGSSCustomContext, 1)
	ZEND_ARG_OBJ_INFO(0, TargetName, TElGSSCustomName, 1)
	ZEND_ARG_INFO(0, DelegateCred)
	ZEND_ARG_TYPE_INFO(0, InputToken, 0, 1)
	ZEND_ARG_INFO(1, OutputToken)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSBaseMechanism_ReleaseContext, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, Ctx, TElGSSCustomContext, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSBaseMechanism_ImportName, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, MechOID, 0, 1)
	ZEND_ARG_INFO(0, InputName)
	ZEND_ARG_OBJ_INFO(1, OutputName, TElGSSCustomName, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSBaseMechanism_ReleaseName, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, Name, TElGSSCustomName, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSBaseMechanism_GetMIC, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Ctx, TElGSSCustomContext, 1)
	ZEND_ARG_TYPE_INFO(0, MessageBuffer, 0, 1)
	ZEND_ARG_INFO(1, MessageToken)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSBaseMechanism_VerifyMIC, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Ctx, TElGSSCustomContext, 1)
	ZEND_ARG_TYPE_INFO(0, MessageBuffer, 0, 1)
	ZEND_ARG_TYPE_INFO(0, MessageToken, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSBaseMechanism_IsMechSupported, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OID, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSBaseMechanism_IsIntegrityAvailable, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Ctx, TElGSSCustomContext, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSBaseMechanism_IsMutualAvailable, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Ctx, TElGSSCustomContext, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSBaseMechanism_GetMechOIDByHash, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Hash, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSBaseMechanism_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSBaseMechanism_get_Mechs, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSBaseMechanism_get_OnError, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSBaseMechanism_set_OnError, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSBaseMechanism___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElGSSBaseMechanism_methods[] = {
	PHP_ME(TElGSSBaseMechanism, Initialize, arginfo_TElGSSBaseMechanism_Initialize, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSBaseMechanism, GetLastMajorStatus, arginfo_TElGSSBaseMechanism_GetLastMajorStatus, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSBaseMechanism, GetLastMinorStatus, arginfo_TElGSSBaseMechanism_GetLastMinorStatus, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSBaseMechanism, AcquireCred, arginfo_TElGSSBaseMechanism_AcquireCred, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSBaseMechanism, AcceptSecContext, arginfo_TElGSSBaseMechanism_AcceptSecContext, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSBaseMechanism, InitSecContext, arginfo_TElGSSBaseMechanism_InitSecContext, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSBaseMechanism, ReleaseContext, arginfo_TElGSSBaseMechanism_ReleaseContext, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSBaseMechanism, ImportName, arginfo_TElGSSBaseMechanism_ImportName, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSBaseMechanism, ReleaseName, arginfo_TElGSSBaseMechanism_ReleaseName, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSBaseMechanism, GetMIC, arginfo_TElGSSBaseMechanism_GetMIC, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSBaseMechanism, VerifyMIC, arginfo_TElGSSBaseMechanism_VerifyMIC, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSBaseMechanism, IsMechSupported, arginfo_TElGSSBaseMechanism_IsMechSupported, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSBaseMechanism, IsIntegrityAvailable, arginfo_TElGSSBaseMechanism_IsIntegrityAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSBaseMechanism, IsMutualAvailable, arginfo_TElGSSBaseMechanism_IsMutualAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSBaseMechanism, GetMechOIDByHash, arginfo_TElGSSBaseMechanism_GetMechOIDByHash, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSBaseMechanism, get_Count, arginfo_TElGSSBaseMechanism_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSBaseMechanism, get_Mechs, arginfo_TElGSSBaseMechanism_get_Mechs, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSBaseMechanism, get_OnError, arginfo_TElGSSBaseMechanism_get_OnError, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSBaseMechanism, set_OnError, arginfo_TElGSSBaseMechanism_set_OnError, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSBaseMechanism, __construct, arginfo_TElGSSBaseMechanism___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGSSBaseMechanism(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGSSBaseMechanism_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGSSBaseMechanism", TElGSSBaseMechanism_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElGSSBaseMechanism_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGSSAPIContext_ce_ptr = NULL;

SB_PHP_METHOD(TElGSSAPIContext, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGSSAPIContext_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSAPIContext___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElGSSAPIContext_methods[] = {
	PHP_ME(TElGSSAPIContext, __construct, arginfo_TElGSSAPIContext___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGSSAPIContext(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGSSAPIContext_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGSSAPIContext", TElGSSAPIContext_methods);
	if (NULL == TElGSSCustomContext_ce_ptr)
		Register_TElGSSCustomContext(TSRMLS_C);
	TElGSSAPIContext_ce_ptr = zend_register_internal_class_ex(&ce, TElGSSCustomContext_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGSSAPIName_ce_ptr = NULL;

SB_PHP_METHOD(TElGSSAPIName, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGSSAPIName_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSAPIName___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElGSSAPIName_methods[] = {
	PHP_ME(TElGSSAPIName, __construct, arginfo_TElGSSAPIName___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGSSAPIName(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGSSAPIName_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGSSAPIName", TElGSSAPIName_methods);
	if (NULL == TElGSSCustomName_ce_ptr)
		Register_TElGSSCustomName(TSRMLS_C);
	TElGSSAPIName_ce_ptr = zend_register_internal_class_ex(&ce, TElGSSCustomName_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGSSAPIMechanism_ce_ptr = NULL;

SB_PHP_METHOD(TElGSSAPIMechanism, Initialize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGSSAPIMechanism_Initialize(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSAPIMechanism, AcquireCred)
{
	SBArrayZValInfo aiMechOID;
	TElClassHandle hoCtx;
	zval *oCtx;
	zval *zaMechOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO", &zaMechOID, &oCtx, TElGSSCustomContext_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaMechOID)) || (IS_ARRAY == Z_TYPE_P(zaMechOID)) || (IS_NULL == Z_TYPE_P(zaMechOID))) && PZVAL_IS_REF(oCtx) && (IS_OBJECT == Z_TYPE_P(oCtx)))
	{
		uint32_t u4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaMechOID, &aiMechOID TSRMLS_CC)) RETURN_FALSE;
		hoCtx = SBGetObjectHandle(oCtx TSRMLS_CC);
		SBCheckError(TElGSSAPIMechanism_AcquireCred(SBGetObjectHandle(getThis() TSRMLS_CC), aiMechOID.data, aiMechOID.len, &hoCtx, &u4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiMechOID);
		SBUpdateObjectHandle(oCtx, hoCtx TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &TElGSSCustomContext)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSAPIMechanism, AcceptSecContext)
{
	SBArrayZValInfo aiInputToken;
	SBArrayZValInfo aiOutputToken;
	uint32_t _err;
	zval *oCtx;
	zval *oSourceName;
	zval *zaInputToken;
	zval *zaOutputToken;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!zz", &oCtx, TElGSSCustomContext_ce_ptr, &oSourceName, TElGSSCustomName_ce_ptr, &zaInputToken, &zaOutputToken) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaInputToken)) || (IS_ARRAY == Z_TYPE_P(zaInputToken)) || (IS_NULL == Z_TYPE_P(zaInputToken))) && PZVAL_IS_REF(zaOutputToken) && ((IS_STRING == Z_TYPE_P(zaOutputToken)) || (IS_ARRAY == Z_TYPE_P(zaOutputToken))))
	{
		uint32_t u4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaInputToken, &aiInputToken TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaOutputToken, &aiOutputToken TSRMLS_CC)) RETURN_FALSE;
		_err = TElGSSAPIMechanism_AcceptSecContext(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCtx TSRMLS_CC), SBGetObjectHandle(oSourceName TSRMLS_CC), aiInputToken.data, aiInputToken.len, aiOutputToken.data, &aiOutputToken.len, &u4OutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaOutputToken, &aiOutputToken TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-314634640, 4, aiOutputToken.data, &aiOutputToken.len) TSRMLS_CC);
			((char *)aiOutputToken.data)[aiOutputToken.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiOutputToken);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiInputToken);
		SBSetByteArrayToZVal(&aiOutputToken, zaOutputToken);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElGSSCustomContext, TElGSSCustomName, array of byte|string|NULL, &array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSAPIMechanism, InitSecContext)
{
	SBArrayZValInfo aiInputToken;
	SBArrayZValInfo aiOutputToken;
	uint32_t _err;
	zend_bool bDelegateCred;
	zval *oCtx;
	zval *oTargetName;
	zval *zaInputToken;
	zval *zaOutputToken;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!bzz", &oCtx, TElGSSCustomContext_ce_ptr, &oTargetName, TElGSSCustomName_ce_ptr, &bDelegateCred, &zaInputToken, &zaOutputToken) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaInputToken)) || (IS_ARRAY == Z_TYPE_P(zaInputToken)) || (IS_NULL == Z_TYPE_P(zaInputToken))) && PZVAL_IS_REF(zaOutputToken) && ((IS_STRING == Z_TYPE_P(zaOutputToken)) || (IS_ARRAY == Z_TYPE_P(zaOutputToken))))
	{
		uint32_t u4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaInputToken, &aiInputToken TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaOutputToken, &aiOutputToken TSRMLS_CC)) RETURN_FALSE;
		_err = TElGSSAPIMechanism_InitSecContext(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCtx TSRMLS_CC), SBGetObjectHandle(oTargetName TSRMLS_CC), (int8_t)bDelegateCred, aiInputToken.data, aiInputToken.len, aiOutputToken.data, &aiOutputToken.len, &u4OutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaOutputToken, &aiOutputToken TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(1286171553, 5, aiOutputToken.data, &aiOutputToken.len) TSRMLS_CC);
			((char *)aiOutputToken.data)[aiOutputToken.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiOutputToken);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiInputToken);
		SBSetByteArrayToZVal(&aiOutputToken, zaOutputToken);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElGSSCustomContext, TElGSSCustomName, bool, array of byte|string|NULL, &array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSAPIMechanism, ReleaseContext)
{
	TElClassHandle hoCtx;
	zval *oCtx;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oCtx, TElGSSCustomContext_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oCtx) && (IS_OBJECT == Z_TYPE_P(oCtx)))
	{
		uint32_t u4OutResultRaw = 0;
		hoCtx = SBGetObjectHandle(oCtx TSRMLS_CC);
		SBCheckError(TElGSSAPIMechanism_ReleaseContext(SBGetObjectHandle(getThis() TSRMLS_CC), &hoCtx, &u4OutResultRaw) TSRMLS_CC);
		SBUpdateObjectHandle(oCtx, hoCtx TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&TElGSSCustomContext)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSAPIMechanism, ImportName)
{
	char *sInputName;
	int sInputName_len;
	SBArrayZValInfo aiMechOID;
	TElClassHandle hoOutputName;
	zval *oOutputName;
	zval *zaMechOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zsO", &zaMechOID, &sInputName, &sInputName_len, &oOutputName, TElGSSCustomName_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaMechOID)) || (IS_ARRAY == Z_TYPE_P(zaMechOID)) || (IS_NULL == Z_TYPE_P(zaMechOID))) && PZVAL_IS_REF(oOutputName) && (IS_OBJECT == Z_TYPE_P(oOutputName)))
	{
		uint32_t u4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaMechOID, &aiMechOID TSRMLS_CC)) RETURN_FALSE;
		hoOutputName = SBGetObjectHandle(oOutputName TSRMLS_CC);
		SBCheckError(TElGSSAPIMechanism_ImportName(SBGetObjectHandle(getThis() TSRMLS_CC), aiMechOID.data, aiMechOID.len, sInputName, (int32_t)sInputName_len, &hoOutputName, &u4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiMechOID);
		SBUpdateObjectHandle(oOutputName, hoOutputName TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, string, &TElGSSCustomName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSAPIMechanism, ReleaseName)
{
	TElClassHandle hoName;
	zval *oName;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oName, TElGSSCustomName_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oName) && (IS_OBJECT == Z_TYPE_P(oName)))
	{
		uint32_t u4OutResultRaw = 0;
		hoName = SBGetObjectHandle(oName TSRMLS_CC);
		SBCheckError(TElGSSAPIMechanism_ReleaseName(SBGetObjectHandle(getThis() TSRMLS_CC), &hoName, &u4OutResultRaw) TSRMLS_CC);
		SBUpdateObjectHandle(oName, hoName TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&TElGSSCustomName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSAPIMechanism, GetMIC)
{
	SBArrayZValInfo aiMessageBuffer;
	SBArrayZValInfo aiMessageToken;
	uint32_t _err;
	zval *oCtx;
	zval *zaMessageBuffer;
	zval *zaMessageToken;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zz", &oCtx, TElGSSCustomContext_ce_ptr, &zaMessageBuffer, &zaMessageToken) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaMessageBuffer)) || (IS_ARRAY == Z_TYPE_P(zaMessageBuffer)) || (IS_NULL == Z_TYPE_P(zaMessageBuffer))) && PZVAL_IS_REF(zaMessageToken) && ((IS_STRING == Z_TYPE_P(zaMessageToken)) || (IS_ARRAY == Z_TYPE_P(zaMessageToken))))
	{
		uint32_t u4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaMessageBuffer, &aiMessageBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaMessageToken, &aiMessageToken TSRMLS_CC)) RETURN_FALSE;
		_err = TElGSSAPIMechanism_GetMIC(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCtx TSRMLS_CC), aiMessageBuffer.data, aiMessageBuffer.len, aiMessageToken.data, &aiMessageToken.len, &u4OutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaMessageToken, &aiMessageToken TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(45356553, 3, aiMessageToken.data, &aiMessageToken.len) TSRMLS_CC);
			((char *)aiMessageToken.data)[aiMessageToken.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiMessageToken);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiMessageBuffer);
		SBSetByteArrayToZVal(&aiMessageToken, zaMessageToken);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElGSSCustomContext, array of byte|string|NULL, &array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSAPIMechanism, VerifyMIC)
{
	SBArrayZValInfo aiMessageBuffer;
	SBArrayZValInfo aiMessageToken;
	zval *oCtx;
	zval *zaMessageBuffer;
	zval *zaMessageToken;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zz", &oCtx, TElGSSCustomContext_ce_ptr, &zaMessageBuffer, &zaMessageToken) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaMessageBuffer)) || (IS_ARRAY == Z_TYPE_P(zaMessageBuffer)) || (IS_NULL == Z_TYPE_P(zaMessageBuffer))) && ((IS_STRING == Z_TYPE_P(zaMessageToken)) || (IS_ARRAY == Z_TYPE_P(zaMessageToken)) || (IS_NULL == Z_TYPE_P(zaMessageToken))))
	{
		uint32_t u4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaMessageBuffer, &aiMessageBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaMessageToken, &aiMessageToken TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGSSAPIMechanism_VerifyMIC(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCtx TSRMLS_CC), aiMessageBuffer.data, aiMessageBuffer.len, aiMessageToken.data, aiMessageToken.len, &u4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiMessageBuffer);
		SBFreeArrayZValInfo(&aiMessageToken);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElGSSCustomContext, array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSAPIMechanism, get_LibraryName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGSSAPIMechanism_get_LibraryName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(576732245, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSAPIMechanism, set_LibraryName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElGSSAPIMechanism_set_LibraryName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSAPIMechanism, get_KRB5CredentialCacheName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGSSAPIMechanism_get_KRB5CredentialCacheName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(133530866, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSAPIMechanism, set_KRB5CredentialCacheName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElGSSAPIMechanism_set_KRB5CredentialCacheName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSAPIMechanism, get_RequestFlags)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElGSSAPIMechanism_get_RequestFlags(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSAPIMechanism, set_RequestFlags)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElGSSAPIMechanism_set_RequestFlags(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSAPIMechanism, set_accept_sec_context)
{
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_NULL == Z_TYPE_P(zValue))))
	{
		SBCheckError(TElGSSAPIMechanism_set_accept_sec_context(SBGetObjectHandle(getThis() TSRMLS_CC), NULL) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSAPIMechanism, set_acquire_cred)
{
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_NULL == Z_TYPE_P(zValue))))
	{
		SBCheckError(TElGSSAPIMechanism_set_acquire_cred(SBGetObjectHandle(getThis() TSRMLS_CC), NULL) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSAPIMechanism, set_delete_sec_context)
{
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_NULL == Z_TYPE_P(zValue))))
	{
		SBCheckError(TElGSSAPIMechanism_set_delete_sec_context(SBGetObjectHandle(getThis() TSRMLS_CC), NULL) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSAPIMechanism, set_display_status)
{
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_NULL == Z_TYPE_P(zValue))))
	{
		SBCheckError(TElGSSAPIMechanism_set_display_status(SBGetObjectHandle(getThis() TSRMLS_CC), NULL) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSAPIMechanism, set_get_mic)
{
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_NULL == Z_TYPE_P(zValue))))
	{
		SBCheckError(TElGSSAPIMechanism_set_get_mic(SBGetObjectHandle(getThis() TSRMLS_CC), NULL) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSAPIMechanism, set_indicate_mechs)
{
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_NULL == Z_TYPE_P(zValue))))
	{
		SBCheckError(TElGSSAPIMechanism_set_indicate_mechs(SBGetObjectHandle(getThis() TSRMLS_CC), NULL) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSAPIMechanism, set_init_sec_context)
{
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_NULL == Z_TYPE_P(zValue))))
	{
		SBCheckError(TElGSSAPIMechanism_set_init_sec_context(SBGetObjectHandle(getThis() TSRMLS_CC), NULL) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSAPIMechanism, set_import_name)
{
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_NULL == Z_TYPE_P(zValue))))
	{
		SBCheckError(TElGSSAPIMechanism_set_import_name(SBGetObjectHandle(getThis() TSRMLS_CC), NULL) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSAPIMechanism, set_krb5_ccache_name)
{
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_NULL == Z_TYPE_P(zValue))))
	{
		SBCheckError(TElGSSAPIMechanism_set_krb5_ccache_name(SBGetObjectHandle(getThis() TSRMLS_CC), NULL) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSAPIMechanism, set_release_buffer)
{
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_NULL == Z_TYPE_P(zValue))))
	{
		SBCheckError(TElGSSAPIMechanism_set_release_buffer(SBGetObjectHandle(getThis() TSRMLS_CC), NULL) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSAPIMechanism, set_release_cred)
{
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_NULL == Z_TYPE_P(zValue))))
	{
		SBCheckError(TElGSSAPIMechanism_set_release_cred(SBGetObjectHandle(getThis() TSRMLS_CC), NULL) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSAPIMechanism, set_release_name)
{
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_NULL == Z_TYPE_P(zValue))))
	{
		SBCheckError(TElGSSAPIMechanism_set_release_name(SBGetObjectHandle(getThis() TSRMLS_CC), NULL) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSAPIMechanism, set_release_oid_set)
{
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_NULL == Z_TYPE_P(zValue))))
	{
		SBCheckError(TElGSSAPIMechanism_set_release_oid_set(SBGetObjectHandle(getThis() TSRMLS_CC), NULL) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSAPIMechanism, set_verify_mic)
{
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_NULL == Z_TYPE_P(zValue))))
	{
		SBCheckError(TElGSSAPIMechanism_set_verify_mic(SBGetObjectHandle(getThis() TSRMLS_CC), NULL) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSAPIMechanism, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGSSAPIMechanism_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSAPIMechanism_Initialize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSAPIMechanism_AcquireCred, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, MechOID, 0, 1)
	ZEND_ARG_OBJ_INFO(1, Ctx, TElGSSCustomContext, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSAPIMechanism_AcceptSecContext, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, Ctx, TElGSSCustomContext, 1)
	ZEND_ARG_OBJ_INFO(0, SourceName, TElGSSCustomName, 1)
	ZEND_ARG_TYPE_INFO(0, InputToken, 0, 1)
	ZEND_ARG_INFO(1, OutputToken)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSAPIMechanism_InitSecContext, 0, 0, 5)
	ZEND_ARG_OBJ_INFO(0, Ctx, TElGSSCustomContext, 1)
	ZEND_ARG_OBJ_INFO(0, TargetName, TElGSSCustomName, 1)
	ZEND_ARG_INFO(0, DelegateCred)
	ZEND_ARG_TYPE_INFO(0, InputToken, 0, 1)
	ZEND_ARG_INFO(1, OutputToken)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSAPIMechanism_ReleaseContext, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, Ctx, TElGSSCustomContext, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSAPIMechanism_ImportName, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, MechOID, 0, 1)
	ZEND_ARG_INFO(0, InputName)
	ZEND_ARG_OBJ_INFO(1, OutputName, TElGSSCustomName, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSAPIMechanism_ReleaseName, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, Name, TElGSSCustomName, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSAPIMechanism_GetMIC, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Ctx, TElGSSCustomContext, 1)
	ZEND_ARG_TYPE_INFO(0, MessageBuffer, 0, 1)
	ZEND_ARG_INFO(1, MessageToken)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSAPIMechanism_VerifyMIC, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Ctx, TElGSSCustomContext, 1)
	ZEND_ARG_TYPE_INFO(0, MessageBuffer, 0, 1)
	ZEND_ARG_TYPE_INFO(0, MessageToken, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSAPIMechanism_get_LibraryName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSAPIMechanism_set_LibraryName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSAPIMechanism_get_KRB5CredentialCacheName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSAPIMechanism_set_KRB5CredentialCacheName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSAPIMechanism_get_RequestFlags, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSAPIMechanism_set_RequestFlags, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSAPIMechanism_set_accept_sec_context, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSAPIMechanism_set_acquire_cred, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSAPIMechanism_set_delete_sec_context, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSAPIMechanism_set_display_status, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSAPIMechanism_set_get_mic, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSAPIMechanism_set_indicate_mechs, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSAPIMechanism_set_init_sec_context, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSAPIMechanism_set_import_name, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSAPIMechanism_set_krb5_ccache_name, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSAPIMechanism_set_release_buffer, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSAPIMechanism_set_release_cred, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSAPIMechanism_set_release_name, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSAPIMechanism_set_release_oid_set, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSAPIMechanism_set_verify_mic, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSAPIMechanism___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElGSSAPIMechanism_methods[] = {
	PHP_ME(TElGSSAPIMechanism, Initialize, arginfo_TElGSSAPIMechanism_Initialize, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSAPIMechanism, AcquireCred, arginfo_TElGSSAPIMechanism_AcquireCred, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSAPIMechanism, AcceptSecContext, arginfo_TElGSSAPIMechanism_AcceptSecContext, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSAPIMechanism, InitSecContext, arginfo_TElGSSAPIMechanism_InitSecContext, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSAPIMechanism, ReleaseContext, arginfo_TElGSSAPIMechanism_ReleaseContext, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSAPIMechanism, ImportName, arginfo_TElGSSAPIMechanism_ImportName, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSAPIMechanism, ReleaseName, arginfo_TElGSSAPIMechanism_ReleaseName, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSAPIMechanism, GetMIC, arginfo_TElGSSAPIMechanism_GetMIC, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSAPIMechanism, VerifyMIC, arginfo_TElGSSAPIMechanism_VerifyMIC, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSAPIMechanism, get_LibraryName, arginfo_TElGSSAPIMechanism_get_LibraryName, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSAPIMechanism, set_LibraryName, arginfo_TElGSSAPIMechanism_set_LibraryName, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSAPIMechanism, get_KRB5CredentialCacheName, arginfo_TElGSSAPIMechanism_get_KRB5CredentialCacheName, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSAPIMechanism, set_KRB5CredentialCacheName, arginfo_TElGSSAPIMechanism_set_KRB5CredentialCacheName, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSAPIMechanism, get_RequestFlags, arginfo_TElGSSAPIMechanism_get_RequestFlags, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSAPIMechanism, set_RequestFlags, arginfo_TElGSSAPIMechanism_set_RequestFlags, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSAPIMechanism, set_accept_sec_context, arginfo_TElGSSAPIMechanism_set_accept_sec_context, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSAPIMechanism, set_acquire_cred, arginfo_TElGSSAPIMechanism_set_acquire_cred, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSAPIMechanism, set_delete_sec_context, arginfo_TElGSSAPIMechanism_set_delete_sec_context, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSAPIMechanism, set_display_status, arginfo_TElGSSAPIMechanism_set_display_status, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSAPIMechanism, set_get_mic, arginfo_TElGSSAPIMechanism_set_get_mic, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSAPIMechanism, set_indicate_mechs, arginfo_TElGSSAPIMechanism_set_indicate_mechs, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSAPIMechanism, set_init_sec_context, arginfo_TElGSSAPIMechanism_set_init_sec_context, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSAPIMechanism, set_import_name, arginfo_TElGSSAPIMechanism_set_import_name, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSAPIMechanism, set_krb5_ccache_name, arginfo_TElGSSAPIMechanism_set_krb5_ccache_name, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSAPIMechanism, set_release_buffer, arginfo_TElGSSAPIMechanism_set_release_buffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSAPIMechanism, set_release_cred, arginfo_TElGSSAPIMechanism_set_release_cred, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSAPIMechanism, set_release_name, arginfo_TElGSSAPIMechanism_set_release_name, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSAPIMechanism, set_release_oid_set, arginfo_TElGSSAPIMechanism_set_release_oid_set, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSAPIMechanism, set_verify_mic, arginfo_TElGSSAPIMechanism_set_verify_mic, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSAPIMechanism, __construct, arginfo_TElGSSAPIMechanism___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGSSAPIMechanism(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGSSAPIMechanism_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGSSAPIMechanism", TElGSSAPIMechanism_methods);
	if (NULL == TElGSSBaseMechanism_ce_ptr)
		Register_TElGSSBaseMechanism(TSRMLS_C);
	TElGSSAPIMechanism_ce_ptr = zend_register_internal_class_ex(&ce, TElGSSBaseMechanism_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGSSMechanismCollection_ce_ptr = NULL;

SB_PHP_METHOD(TElGSSMechanismCollection, Initialize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGSSMechanismCollection_Initialize(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSMechanismCollection, GetMechByOID)
{
	SBArrayZValInfo aiOID;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaOID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGSSMechanismCollection_GetMechByOID(SBGetObjectHandle(getThis() TSRMLS_CC), aiOID.data, aiOID.len, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		SBInitObject(return_value, TElGSSBaseMechanism_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSMechanismCollection, RegisterMechanism)
{
	zval *oMech;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oMech, TElGSSBaseMechanism_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGSSMechanismCollection_RegisterMechanism(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oMech TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGSSBaseMechanism)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSMechanismCollection, UnregisterMechanism)
{
	zval *oMech;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oMech, TElGSSBaseMechanism_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGSSMechanismCollection_UnregisterMechanism(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oMech TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGSSBaseMechanism)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSMechanismCollection, AcquireCred)
{
	SBArrayZValInfo aiMechOID;
	TElClassHandle hoCtx;
	zval *oCtx;
	zval *zaMechOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO", &zaMechOID, &oCtx, TElGSSCustomContext_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaMechOID)) || (IS_ARRAY == Z_TYPE_P(zaMechOID)) || (IS_NULL == Z_TYPE_P(zaMechOID))) && PZVAL_IS_REF(oCtx) && (IS_OBJECT == Z_TYPE_P(oCtx)))
	{
		uint32_t u4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaMechOID, &aiMechOID TSRMLS_CC)) RETURN_FALSE;
		hoCtx = SBGetObjectHandle(oCtx TSRMLS_CC);
		SBCheckError(TElGSSMechanismCollection_AcquireCred(SBGetObjectHandle(getThis() TSRMLS_CC), aiMechOID.data, aiMechOID.len, &hoCtx, &u4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiMechOID);
		SBUpdateObjectHandle(oCtx, hoCtx TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &TElGSSCustomContext)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSMechanismCollection, AcceptSecContext)
{
	SBArrayZValInfo aiInputToken;
	SBArrayZValInfo aiOutputToken;
	uint32_t _err;
	zval *oCtx;
	zval *oSourceName;
	zval *zaInputToken;
	zval *zaOutputToken;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!zz", &oCtx, TElGSSCustomContext_ce_ptr, &oSourceName, TElGSSCustomName_ce_ptr, &zaInputToken, &zaOutputToken) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaInputToken)) || (IS_ARRAY == Z_TYPE_P(zaInputToken)) || (IS_NULL == Z_TYPE_P(zaInputToken))) && PZVAL_IS_REF(zaOutputToken) && ((IS_STRING == Z_TYPE_P(zaOutputToken)) || (IS_ARRAY == Z_TYPE_P(zaOutputToken))))
	{
		uint32_t u4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaInputToken, &aiInputToken TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaOutputToken, &aiOutputToken TSRMLS_CC)) RETURN_FALSE;
		_err = TElGSSMechanismCollection_AcceptSecContext(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCtx TSRMLS_CC), SBGetObjectHandle(oSourceName TSRMLS_CC), aiInputToken.data, aiInputToken.len, aiOutputToken.data, &aiOutputToken.len, &u4OutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaOutputToken, &aiOutputToken TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(697383276, 4, aiOutputToken.data, &aiOutputToken.len) TSRMLS_CC);
			((char *)aiOutputToken.data)[aiOutputToken.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiOutputToken);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiInputToken);
		SBSetByteArrayToZVal(&aiOutputToken, zaOutputToken);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElGSSCustomContext, TElGSSCustomName, array of byte|string|NULL, &array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSMechanismCollection, InitSecContext)
{
	SBArrayZValInfo aiInputToken;
	SBArrayZValInfo aiOutputToken;
	uint32_t _err;
	zend_bool bDelegateCred;
	zval *oCtx;
	zval *oTargetName;
	zval *zaInputToken;
	zval *zaOutputToken;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!bzz", &oCtx, TElGSSCustomContext_ce_ptr, &oTargetName, TElGSSCustomName_ce_ptr, &bDelegateCred, &zaInputToken, &zaOutputToken) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaInputToken)) || (IS_ARRAY == Z_TYPE_P(zaInputToken)) || (IS_NULL == Z_TYPE_P(zaInputToken))) && PZVAL_IS_REF(zaOutputToken) && ((IS_STRING == Z_TYPE_P(zaOutputToken)) || (IS_ARRAY == Z_TYPE_P(zaOutputToken))))
	{
		uint32_t u4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaInputToken, &aiInputToken TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaOutputToken, &aiOutputToken TSRMLS_CC)) RETURN_FALSE;
		_err = TElGSSMechanismCollection_InitSecContext(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCtx TSRMLS_CC), SBGetObjectHandle(oTargetName TSRMLS_CC), (int8_t)bDelegateCred, aiInputToken.data, aiInputToken.len, aiOutputToken.data, &aiOutputToken.len, &u4OutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaOutputToken, &aiOutputToken TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(1876605781, 5, aiOutputToken.data, &aiOutputToken.len) TSRMLS_CC);
			((char *)aiOutputToken.data)[aiOutputToken.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiOutputToken);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiInputToken);
		SBSetByteArrayToZVal(&aiOutputToken, zaOutputToken);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElGSSCustomContext, TElGSSCustomName, bool, array of byte|string|NULL, &array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSMechanismCollection, ReleaseContext)
{
	TElClassHandle hoCtx;
	zval *oCtx;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oCtx, TElGSSCustomContext_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oCtx) && (IS_OBJECT == Z_TYPE_P(oCtx)))
	{
		uint32_t u4OutResultRaw = 0;
		hoCtx = SBGetObjectHandle(oCtx TSRMLS_CC);
		SBCheckError(TElGSSMechanismCollection_ReleaseContext(SBGetObjectHandle(getThis() TSRMLS_CC), &hoCtx, &u4OutResultRaw) TSRMLS_CC);
		SBUpdateObjectHandle(oCtx, hoCtx TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&TElGSSCustomContext)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSMechanismCollection, ImportName)
{
	char *sInputName;
	int sInputName_len;
	SBArrayZValInfo aiMechOID;
	TElClassHandle hoOutputName;
	zval *oOutputName;
	zval *zaMechOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zsO", &zaMechOID, &sInputName, &sInputName_len, &oOutputName, TElGSSCustomName_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaMechOID)) || (IS_ARRAY == Z_TYPE_P(zaMechOID)) || (IS_NULL == Z_TYPE_P(zaMechOID))) && PZVAL_IS_REF(oOutputName) && (IS_OBJECT == Z_TYPE_P(oOutputName)))
	{
		uint32_t u4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaMechOID, &aiMechOID TSRMLS_CC)) RETURN_FALSE;
		hoOutputName = SBGetObjectHandle(oOutputName TSRMLS_CC);
		SBCheckError(TElGSSMechanismCollection_ImportName(SBGetObjectHandle(getThis() TSRMLS_CC), aiMechOID.data, aiMechOID.len, sInputName, (int32_t)sInputName_len, &hoOutputName, &u4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiMechOID);
		SBUpdateObjectHandle(oOutputName, hoOutputName TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, string, &TElGSSCustomName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSMechanismCollection, ReleaseName)
{
	TElClassHandle hoName;
	zval *oName;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oName, TElGSSCustomName_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oName) && (IS_OBJECT == Z_TYPE_P(oName)))
	{
		uint32_t u4OutResultRaw = 0;
		hoName = SBGetObjectHandle(oName TSRMLS_CC);
		SBCheckError(TElGSSMechanismCollection_ReleaseName(SBGetObjectHandle(getThis() TSRMLS_CC), &hoName, &u4OutResultRaw) TSRMLS_CC);
		SBUpdateObjectHandle(oName, hoName TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&TElGSSCustomName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSMechanismCollection, GetMIC)
{
	SBArrayZValInfo aiMessageBuffer;
	SBArrayZValInfo aiMessageToken;
	uint32_t _err;
	zval *oCtx;
	zval *zaMessageBuffer;
	zval *zaMessageToken;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zz", &oCtx, TElGSSCustomContext_ce_ptr, &zaMessageBuffer, &zaMessageToken) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaMessageBuffer)) || (IS_ARRAY == Z_TYPE_P(zaMessageBuffer)) || (IS_NULL == Z_TYPE_P(zaMessageBuffer))) && PZVAL_IS_REF(zaMessageToken) && ((IS_STRING == Z_TYPE_P(zaMessageToken)) || (IS_ARRAY == Z_TYPE_P(zaMessageToken))))
	{
		uint32_t u4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaMessageBuffer, &aiMessageBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaMessageToken, &aiMessageToken TSRMLS_CC)) RETURN_FALSE;
		_err = TElGSSMechanismCollection_GetMIC(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCtx TSRMLS_CC), aiMessageBuffer.data, aiMessageBuffer.len, aiMessageToken.data, &aiMessageToken.len, &u4OutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaMessageToken, &aiMessageToken TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(806168295, 3, aiMessageToken.data, &aiMessageToken.len) TSRMLS_CC);
			((char *)aiMessageToken.data)[aiMessageToken.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiMessageToken);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiMessageBuffer);
		SBSetByteArrayToZVal(&aiMessageToken, zaMessageToken);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElGSSCustomContext, array of byte|string|NULL, &array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSMechanismCollection, VerifyMIC)
{
	SBArrayZValInfo aiMessageBuffer;
	SBArrayZValInfo aiMessageToken;
	zval *oCtx;
	zval *zaMessageBuffer;
	zval *zaMessageToken;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zz", &oCtx, TElGSSCustomContext_ce_ptr, &zaMessageBuffer, &zaMessageToken) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaMessageBuffer)) || (IS_ARRAY == Z_TYPE_P(zaMessageBuffer)) || (IS_NULL == Z_TYPE_P(zaMessageBuffer))) && ((IS_STRING == Z_TYPE_P(zaMessageToken)) || (IS_ARRAY == Z_TYPE_P(zaMessageToken)) || (IS_NULL == Z_TYPE_P(zaMessageToken))))
	{
		uint32_t u4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaMessageBuffer, &aiMessageBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaMessageToken, &aiMessageToken TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGSSMechanismCollection_VerifyMIC(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCtx TSRMLS_CC), aiMessageBuffer.data, aiMessageBuffer.len, aiMessageToken.data, aiMessageToken.len, &u4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiMessageBuffer);
		SBFreeArrayZValInfo(&aiMessageToken);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElGSSCustomContext, array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSMechanismCollection, IsMechSupported)
{
	SBArrayZValInfo aiOID;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaOID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGSSMechanismCollection_IsMechSupported(SBGetObjectHandle(getThis() TSRMLS_CC), aiOID.data, aiOID.len, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiOID);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSMechanismCollection, IsIntegrityAvailable)
{
	zval *oCtx;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCtx, TElGSSCustomContext_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGSSMechanismCollection_IsIntegrityAvailable(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCtx TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElGSSCustomContext)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGSSMechanismCollection, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGSSMechanismCollection_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSMechanismCollection_Initialize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSMechanismCollection_GetMechByOID, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OID, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSMechanismCollection_RegisterMechanism, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Mech, TElGSSBaseMechanism, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSMechanismCollection_UnregisterMechanism, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Mech, TElGSSBaseMechanism, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSMechanismCollection_AcquireCred, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, MechOID, 0, 1)
	ZEND_ARG_OBJ_INFO(1, Ctx, TElGSSCustomContext, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSMechanismCollection_AcceptSecContext, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, Ctx, TElGSSCustomContext, 1)
	ZEND_ARG_OBJ_INFO(0, SourceName, TElGSSCustomName, 1)
	ZEND_ARG_TYPE_INFO(0, InputToken, 0, 1)
	ZEND_ARG_INFO(1, OutputToken)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSMechanismCollection_InitSecContext, 0, 0, 5)
	ZEND_ARG_OBJ_INFO(0, Ctx, TElGSSCustomContext, 1)
	ZEND_ARG_OBJ_INFO(0, TargetName, TElGSSCustomName, 1)
	ZEND_ARG_INFO(0, DelegateCred)
	ZEND_ARG_TYPE_INFO(0, InputToken, 0, 1)
	ZEND_ARG_INFO(1, OutputToken)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSMechanismCollection_ReleaseContext, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, Ctx, TElGSSCustomContext, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSMechanismCollection_ImportName, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, MechOID, 0, 1)
	ZEND_ARG_INFO(0, InputName)
	ZEND_ARG_OBJ_INFO(1, OutputName, TElGSSCustomName, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSMechanismCollection_ReleaseName, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, Name, TElGSSCustomName, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSMechanismCollection_GetMIC, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Ctx, TElGSSCustomContext, 1)
	ZEND_ARG_TYPE_INFO(0, MessageBuffer, 0, 1)
	ZEND_ARG_INFO(1, MessageToken)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSMechanismCollection_VerifyMIC, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Ctx, TElGSSCustomContext, 1)
	ZEND_ARG_TYPE_INFO(0, MessageBuffer, 0, 1)
	ZEND_ARG_TYPE_INFO(0, MessageToken, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSMechanismCollection_IsMechSupported, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OID, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSMechanismCollection_IsIntegrityAvailable, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Ctx, TElGSSCustomContext, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGSSMechanismCollection___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElGSSMechanismCollection_methods[] = {
	PHP_ME(TElGSSMechanismCollection, Initialize, arginfo_TElGSSMechanismCollection_Initialize, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSMechanismCollection, GetMechByOID, arginfo_TElGSSMechanismCollection_GetMechByOID, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSMechanismCollection, RegisterMechanism, arginfo_TElGSSMechanismCollection_RegisterMechanism, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSMechanismCollection, UnregisterMechanism, arginfo_TElGSSMechanismCollection_UnregisterMechanism, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSMechanismCollection, AcquireCred, arginfo_TElGSSMechanismCollection_AcquireCred, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSMechanismCollection, AcceptSecContext, arginfo_TElGSSMechanismCollection_AcceptSecContext, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSMechanismCollection, InitSecContext, arginfo_TElGSSMechanismCollection_InitSecContext, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSMechanismCollection, ReleaseContext, arginfo_TElGSSMechanismCollection_ReleaseContext, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSMechanismCollection, ImportName, arginfo_TElGSSMechanismCollection_ImportName, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSMechanismCollection, ReleaseName, arginfo_TElGSSMechanismCollection_ReleaseName, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSMechanismCollection, GetMIC, arginfo_TElGSSMechanismCollection_GetMIC, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSMechanismCollection, VerifyMIC, arginfo_TElGSSMechanismCollection_VerifyMIC, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSMechanismCollection, IsMechSupported, arginfo_TElGSSMechanismCollection_IsMechSupported, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSMechanismCollection, IsIntegrityAvailable, arginfo_TElGSSMechanismCollection_IsIntegrityAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElGSSMechanismCollection, __construct, arginfo_TElGSSMechanismCollection___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGSSMechanismCollection(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGSSMechanismCollection_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGSSMechanismCollection", TElGSSMechanismCollection_methods);
	if (NULL == TElGSSBaseMechanism_ce_ptr)
		Register_TElGSSBaseMechanism(TSRMLS_C);
	TElGSSMechanismCollection_ce_ptr = zend_register_internal_class_ex(&ce, TElGSSBaseMechanism_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBGSSAPI_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_NULL_CONSTANT(SBGSSAPI, GSS_C_NO_NAME, SB_GSS_C_NO_NAME);
	SB_REGISTER_NULL_CONSTANT(SBGSSAPI, GSS_C_NO_BUFFER, SB_GSS_C_NO_BUFFER);
	SB_REGISTER_NULL_CONSTANT(SBGSSAPI, GSS_C_NO_OID, SB_GSS_C_NO_OID);
	SB_REGISTER_NULL_CONSTANT(SBGSSAPI, GSS_C_NO_OID_SET, SB_GSS_C_NO_OID_SET);
	SB_REGISTER_NULL_CONSTANT(SBGSSAPI, GSS_C_NO_CONTEXT, SB_GSS_C_NO_CONTEXT);
	SB_REGISTER_NULL_CONSTANT(SBGSSAPI, GSS_C_NO_CREDENTIAL, SB_GSS_C_NO_CREDENTIAL);
	SB_REGISTER_NULL_CONSTANT(SBGSSAPI, GSS_C_NO_CHANNEL_BINDINGS, SB_GSS_C_NO_CHANNEL_BINDINGS);
	SB_REGISTER_NULL_CONSTANT(SBGSSAPI, GSS_C_NULL_OID, SB_GSS_C_NULL_OID);
	SB_REGISTER_NULL_CONSTANT(SBGSSAPI, GSS_C_NULL_OID_SET, SB_GSS_C_NULL_OID_SET);
	SB_REGISTER_STRING_CONSTANT(SBGSSAPI, GSS_C_NT_HOSTBASED_SERVICE_OID, SB_GSS_C_NT_HOSTBASED_SERVICE_OID, SB_GSS_C_NT_HOSTBASED_SERVICE_OID);
	SB_REGISTER_STRING_CONSTANT(SBGSSAPI, GSS_KRB5_NT_PRINCIPAL_NAME_OID, SB_GSS_KRB5_NT_PRINCIPAL_NAME_OID, SB_GSS_KRB5_NT_PRINCIPAL_NAME_OID);
}

