#include "sbdefs.h"
#ifdef SB_WINDOWS
#include "sbpgpsfx.h"

SB_PHP_METHOD(SBPGPSFX__IMAGE_DATA_DIRECTORY, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SBPGPSFX__IMAGE_DATA_DIRECTORY));
		intern->len = sizeof(SBPGPSFX__IMAGE_DATA_DIRECTORY);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DATA_DIRECTORY, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SBPGPSFX__IMAGE_DATA_DIRECTORY));
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(SBPGPSFX__IMAGE_DATA_DIRECTORY, get_VirtualAddress)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DATA_DIRECTORY, set_VirtualAddress)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DATA_DIRECTORY, get_Size)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DATA_DIRECTORY, set_Size)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

zend_class_entry *SBPGPSFX__IMAGE_DATA_DIRECTORY_ce_ptr = NULL;

static zend_function_entry SBPGPSFX__IMAGE_DATA_DIRECTORY_methods[] = {
	PHP_ME(SBPGPSFX__IMAGE_DATA_DIRECTORY, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DATA_DIRECTORY, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SBPGPSFX__IMAGE_DATA_DIRECTORY, get_VirtualAddress, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DATA_DIRECTORY, set_VirtualAddress, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DATA_DIRECTORY, get_Size, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DATA_DIRECTORY, set_Size, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SBPGPSFX__IMAGE_DATA_DIRECTORY(TSRMLS_D)
{
	zend_class_entry ce;
	if (SBPGPSFX__IMAGE_DATA_DIRECTORY_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SBPGPSFX__IMAGE_DATA_DIRECTORY", SBPGPSFX__IMAGE_DATA_DIRECTORY_methods);
	SBPGPSFX__IMAGE_DATA_DIRECTORY_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SBPGPSFX__IMAGE_OPTIONAL_HEADER));
		intern->len = sizeof(SBPGPSFX__IMAGE_OPTIONAL_HEADER);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SBPGPSFX__IMAGE_OPTIONAL_HEADER));
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_Magic)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_Magic)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_MajorLinkerVersion)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 2);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_MajorLinkerVersion)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 2);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_MinorLinkerVersion)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 3);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_MinorLinkerVersion)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 3);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_SizeOfCode)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_SizeOfCode)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_SizeOfInitializedData)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_SizeOfInitializedData)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_SizeOfUninitializedData)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_SizeOfUninitializedData)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_AddressOfEntryPoint)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_AddressOfEntryPoint)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_BaseOfCode)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_BaseOfCode)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_BaseOfData)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_BaseOfData)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_ImageBase)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 28);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_ImageBase)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 28);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_SectionAlignment)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 32);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_SectionAlignment)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 32);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_FileAlignment)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 36);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_FileAlignment)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 36);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_MajorOperatingSystemVersion)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 40);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_MajorOperatingSystemVersion)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 40);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_MinorOperatingSystemVersion)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 42);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_MinorOperatingSystemVersion)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 42);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_MajorImageVersion)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 44);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_MajorImageVersion)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 44);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_MinorImageVersion)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 46);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_MinorImageVersion)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 46);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_MajorSubsystemVersion)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 48);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_MajorSubsystemVersion)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 48);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_MinorSubsystemVersion)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 50);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_MinorSubsystemVersion)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 50);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_Win32VersionValue)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 52);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_Win32VersionValue)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 52);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_SizeOfImage)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 56);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_SizeOfImage)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 56);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_SizeOfHeaders)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 60);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_SizeOfHeaders)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 60);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_CheckSum)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 64);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_CheckSum)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 64);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_Subsystem)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 68);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_Subsystem)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 68);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_DllCharacteristics)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 70);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_DllCharacteristics)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 70);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_SizeOfStackReserve)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 72);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_SizeOfStackReserve)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 72);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_SizeOfStackCommit)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 76);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_SizeOfStackCommit)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 76);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_SizeOfHeapReserve)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 80);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_SizeOfHeapReserve)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 80);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_SizeOfHeapCommit)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 84);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_SizeOfHeapCommit)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 84);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_LoaderFlags)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 88);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_LoaderFlags)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 88);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_NumberOfRvaAndSizes)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 92);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_NumberOfRvaAndSizes)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 92);
}

zend_class_entry *SBPGPSFX__IMAGE_OPTIONAL_HEADER_ce_ptr = NULL;

static zend_function_entry SBPGPSFX__IMAGE_OPTIONAL_HEADER_methods[] = {
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_Magic, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_Magic, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_MajorLinkerVersion, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_MajorLinkerVersion, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_MinorLinkerVersion, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_MinorLinkerVersion, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_SizeOfCode, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_SizeOfCode, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_SizeOfInitializedData, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_SizeOfInitializedData, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_SizeOfUninitializedData, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_SizeOfUninitializedData, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_AddressOfEntryPoint, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_AddressOfEntryPoint, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_BaseOfCode, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_BaseOfCode, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_BaseOfData, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_BaseOfData, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_ImageBase, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_ImageBase, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_SectionAlignment, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_SectionAlignment, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_FileAlignment, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_FileAlignment, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_MajorOperatingSystemVersion, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_MajorOperatingSystemVersion, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_MinorOperatingSystemVersion, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_MinorOperatingSystemVersion, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_MajorImageVersion, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_MajorImageVersion, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_MinorImageVersion, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_MinorImageVersion, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_MajorSubsystemVersion, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_MajorSubsystemVersion, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_MinorSubsystemVersion, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_MinorSubsystemVersion, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_Win32VersionValue, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_Win32VersionValue, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_SizeOfImage, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_SizeOfImage, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_SizeOfHeaders, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_SizeOfHeaders, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_CheckSum, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_CheckSum, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_Subsystem, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_Subsystem, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_DllCharacteristics, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_DllCharacteristics, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_SizeOfStackReserve, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_SizeOfStackReserve, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_SizeOfStackCommit, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_SizeOfStackCommit, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_SizeOfHeapReserve, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_SizeOfHeapReserve, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_SizeOfHeapCommit, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_SizeOfHeapCommit, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_LoaderFlags, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_LoaderFlags, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, get_NumberOfRvaAndSizes, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_OPTIONAL_HEADER, set_NumberOfRvaAndSizes, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SBPGPSFX__IMAGE_OPTIONAL_HEADER(TSRMLS_D)
{
	zend_class_entry ce;
	if (SBPGPSFX__IMAGE_OPTIONAL_HEADER_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SBPGPSFX__IMAGE_OPTIONAL_HEADER", SBPGPSFX__IMAGE_OPTIONAL_HEADER_methods);
	SBPGPSFX__IMAGE_OPTIONAL_HEADER_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DOS_HEADER, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SBPGPSFX__IMAGE_DOS_HEADER));
		intern->len = sizeof(SBPGPSFX__IMAGE_DOS_HEADER);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DOS_HEADER, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SBPGPSFX__IMAGE_DOS_HEADER));
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DOS_HEADER, get_e_magic)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DOS_HEADER, set_e_magic)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DOS_HEADER, get_e_cblp)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 2);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DOS_HEADER, set_e_cblp)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 2);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DOS_HEADER, get_e_cp)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DOS_HEADER, set_e_cp)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DOS_HEADER, get_e_crlc)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 6);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DOS_HEADER, set_e_crlc)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 6);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DOS_HEADER, get_e_cparhdr)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DOS_HEADER, set_e_cparhdr)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DOS_HEADER, get_e_minalloc)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 10);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DOS_HEADER, set_e_minalloc)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 10);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DOS_HEADER, get_e_maxalloc)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DOS_HEADER, set_e_maxalloc)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DOS_HEADER, get_e_ss)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 14);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DOS_HEADER, set_e_ss)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 14);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DOS_HEADER, get_e_sp)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DOS_HEADER, set_e_sp)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DOS_HEADER, get_e_csum)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 18);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DOS_HEADER, set_e_csum)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 18);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DOS_HEADER, get_e_ip)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DOS_HEADER, set_e_ip)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DOS_HEADER, get_e_cs)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 22);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DOS_HEADER, set_e_cs)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 22);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DOS_HEADER, get_e_lfarlc)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DOS_HEADER, set_e_lfarlc)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DOS_HEADER, get_e_ovno)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 26);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DOS_HEADER, set_e_ovno)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 26);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DOS_HEADER, get_e_oemid)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 36);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DOS_HEADER, set_e_oemid)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 36);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DOS_HEADER, get_e_oeminfo)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 38);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DOS_HEADER, set_e_oeminfo)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 38);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DOS_HEADER, get__lfanew)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 60);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_DOS_HEADER, set__lfanew)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 60);
}

zend_class_entry *SBPGPSFX__IMAGE_DOS_HEADER_ce_ptr = NULL;

static zend_function_entry SBPGPSFX__IMAGE_DOS_HEADER_methods[] = {
	PHP_ME(SBPGPSFX__IMAGE_DOS_HEADER, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DOS_HEADER, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SBPGPSFX__IMAGE_DOS_HEADER, get_e_magic, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DOS_HEADER, set_e_magic, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DOS_HEADER, get_e_cblp, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DOS_HEADER, set_e_cblp, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DOS_HEADER, get_e_cp, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DOS_HEADER, set_e_cp, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DOS_HEADER, get_e_crlc, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DOS_HEADER, set_e_crlc, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DOS_HEADER, get_e_cparhdr, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DOS_HEADER, set_e_cparhdr, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DOS_HEADER, get_e_minalloc, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DOS_HEADER, set_e_minalloc, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DOS_HEADER, get_e_maxalloc, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DOS_HEADER, set_e_maxalloc, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DOS_HEADER, get_e_ss, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DOS_HEADER, set_e_ss, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DOS_HEADER, get_e_sp, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DOS_HEADER, set_e_sp, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DOS_HEADER, get_e_csum, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DOS_HEADER, set_e_csum, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DOS_HEADER, get_e_ip, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DOS_HEADER, set_e_ip, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DOS_HEADER, get_e_cs, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DOS_HEADER, set_e_cs, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DOS_HEADER, get_e_lfarlc, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DOS_HEADER, set_e_lfarlc, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DOS_HEADER, get_e_ovno, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DOS_HEADER, set_e_ovno, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DOS_HEADER, get_e_oemid, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DOS_HEADER, set_e_oemid, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DOS_HEADER, get_e_oeminfo, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DOS_HEADER, set_e_oeminfo, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DOS_HEADER, get__lfanew, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_DOS_HEADER, set__lfanew, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SBPGPSFX__IMAGE_DOS_HEADER(TSRMLS_D)
{
	zend_class_entry ce;
	if (SBPGPSFX__IMAGE_DOS_HEADER_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SBPGPSFX__IMAGE_DOS_HEADER", SBPGPSFX__IMAGE_DOS_HEADER_methods);
	SBPGPSFX__IMAGE_DOS_HEADER_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_FILE_HEADER, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SBPGPSFX__IMAGE_FILE_HEADER));
		intern->len = sizeof(SBPGPSFX__IMAGE_FILE_HEADER);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_FILE_HEADER, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SBPGPSFX__IMAGE_FILE_HEADER));
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_FILE_HEADER, get_Machine)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_FILE_HEADER, set_Machine)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_FILE_HEADER, get_NumberOfSections)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 2);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_FILE_HEADER, set_NumberOfSections)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 2);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_FILE_HEADER, get_TimeDateStamp)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_FILE_HEADER, set_TimeDateStamp)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_FILE_HEADER, get_PointerToSymbolTable)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_FILE_HEADER, set_PointerToSymbolTable)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_FILE_HEADER, get_NumberOfSymbols)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_FILE_HEADER, set_NumberOfSymbols)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_FILE_HEADER, get_SizeOfOptionalHeader)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_FILE_HEADER, set_SizeOfOptionalHeader)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_FILE_HEADER, get_Characteristics)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 18);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_FILE_HEADER, set_Characteristics)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 18);
}

zend_class_entry *SBPGPSFX__IMAGE_FILE_HEADER_ce_ptr = NULL;

static zend_function_entry SBPGPSFX__IMAGE_FILE_HEADER_methods[] = {
	PHP_ME(SBPGPSFX__IMAGE_FILE_HEADER, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_FILE_HEADER, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SBPGPSFX__IMAGE_FILE_HEADER, get_Machine, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_FILE_HEADER, set_Machine, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_FILE_HEADER, get_NumberOfSections, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_FILE_HEADER, set_NumberOfSections, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_FILE_HEADER, get_TimeDateStamp, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_FILE_HEADER, set_TimeDateStamp, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_FILE_HEADER, get_PointerToSymbolTable, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_FILE_HEADER, set_PointerToSymbolTable, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_FILE_HEADER, get_NumberOfSymbols, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_FILE_HEADER, set_NumberOfSymbols, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_FILE_HEADER, get_SizeOfOptionalHeader, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_FILE_HEADER, set_SizeOfOptionalHeader, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_FILE_HEADER, get_Characteristics, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_FILE_HEADER, set_Characteristics, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SBPGPSFX__IMAGE_FILE_HEADER(TSRMLS_D)
{
	zend_class_entry ce;
	if (SBPGPSFX__IMAGE_FILE_HEADER_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SBPGPSFX__IMAGE_FILE_HEADER", SBPGPSFX__IMAGE_FILE_HEADER_methods);
	SBPGPSFX__IMAGE_FILE_HEADER_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_NT_HEADERS, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SBPGPSFX__IMAGE_NT_HEADERS));
		intern->len = sizeof(SBPGPSFX__IMAGE_NT_HEADERS);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_NT_HEADERS, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SBPGPSFX__IMAGE_NT_HEADERS));
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_NT_HEADERS, get_Signature)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_NT_HEADERS, set_Signature)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

zend_class_entry *SBPGPSFX__IMAGE_NT_HEADERS_ce_ptr = NULL;

static zend_function_entry SBPGPSFX__IMAGE_NT_HEADERS_methods[] = {
	PHP_ME(SBPGPSFX__IMAGE_NT_HEADERS, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_NT_HEADERS, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SBPGPSFX__IMAGE_NT_HEADERS, get_Signature, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_NT_HEADERS, set_Signature, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SBPGPSFX__IMAGE_NT_HEADERS(TSRMLS_D)
{
	zend_class_entry ce;
	if (SBPGPSFX__IMAGE_NT_HEADERS_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SBPGPSFX__IMAGE_NT_HEADERS", SBPGPSFX__IMAGE_NT_HEADERS_methods);
	SBPGPSFX__IMAGE_NT_HEADERS_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SBPGPSFX_TISHMisc, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SBPGPSFX_TISHMisc));
		intern->len = sizeof(SBPGPSFX_TISHMisc);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SBPGPSFX_TISHMisc, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SBPGPSFX_TISHMisc));
}

zend_class_entry *SBPGPSFX_TISHMisc_ce_ptr = NULL;

static zend_function_entry SBPGPSFX_TISHMisc_methods[] = {
	PHP_ME(SBPGPSFX_TISHMisc, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX_TISHMisc, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_SBPGPSFX_TISHMisc(TSRMLS_D)
{
	zend_class_entry ce;
	if (SBPGPSFX_TISHMisc_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SBPGPSFX_TISHMisc", SBPGPSFX_TISHMisc_methods);
	SBPGPSFX_TISHMisc_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_SECTION_HEADER, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SBPGPSFX__IMAGE_SECTION_HEADER));
		intern->len = sizeof(SBPGPSFX__IMAGE_SECTION_HEADER);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_SECTION_HEADER, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SBPGPSFX__IMAGE_SECTION_HEADER));
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_SECTION_HEADER, get_VirtualAddress)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_SECTION_HEADER, set_VirtualAddress)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_SECTION_HEADER, get_SizeOfRawData)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_SECTION_HEADER, set_SizeOfRawData)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_SECTION_HEADER, get_PointerToRawData)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_SECTION_HEADER, set_PointerToRawData)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_SECTION_HEADER, get_PointerToRelocations)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_SECTION_HEADER, set_PointerToRelocations)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_SECTION_HEADER, get_PointerToLinenumbers)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 28);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_SECTION_HEADER, set_PointerToLinenumbers)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 28);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_SECTION_HEADER, get_NumberOfRelocations)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 32);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_SECTION_HEADER, set_NumberOfRelocations)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 32);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_SECTION_HEADER, get_NumberOfLinenumbers)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 34);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_SECTION_HEADER, set_NumberOfLinenumbers)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 34);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_SECTION_HEADER, get_Characteristics)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 36);
}

SB_PHP_METHOD(SBPGPSFX__IMAGE_SECTION_HEADER, set_Characteristics)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 36);
}

zend_class_entry *SBPGPSFX__IMAGE_SECTION_HEADER_ce_ptr = NULL;

static zend_function_entry SBPGPSFX__IMAGE_SECTION_HEADER_methods[] = {
	PHP_ME(SBPGPSFX__IMAGE_SECTION_HEADER, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_SECTION_HEADER, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SBPGPSFX__IMAGE_SECTION_HEADER, get_VirtualAddress, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_SECTION_HEADER, set_VirtualAddress, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_SECTION_HEADER, get_SizeOfRawData, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_SECTION_HEADER, set_SizeOfRawData, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_SECTION_HEADER, get_PointerToRawData, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_SECTION_HEADER, set_PointerToRawData, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_SECTION_HEADER, get_PointerToRelocations, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_SECTION_HEADER, set_PointerToRelocations, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_SECTION_HEADER, get_PointerToLinenumbers, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_SECTION_HEADER, set_PointerToLinenumbers, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_SECTION_HEADER, get_NumberOfRelocations, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_SECTION_HEADER, set_NumberOfRelocations, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_SECTION_HEADER, get_NumberOfLinenumbers, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_SECTION_HEADER, set_NumberOfLinenumbers, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_SECTION_HEADER, get_Characteristics, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SBPGPSFX__IMAGE_SECTION_HEADER, set_Characteristics, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SBPGPSFX__IMAGE_SECTION_HEADER(TSRMLS_D)
{
	zend_class_entry ce;
	if (SBPGPSFX__IMAGE_SECTION_HEADER_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SBPGPSFX__IMAGE_SECTION_HEADER", SBPGPSFX__IMAGE_SECTION_HEADER_methods);
	SBPGPSFX__IMAGE_SECTION_HEADER_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TSBPGPSFXCommandLineSwitch_ce_ptr = NULL;

zend_class_entry *TSBPGPSFXCommandLineSwitches_ce_ptr = NULL;

zend_class_entry *TSBPGPSFXTempFileLocation_ce_ptr = NULL;

zend_class_entry *TSBPGPSFXFileAction_ce_ptr = NULL;

void SB_CALLBACK TSBPGPSFXExtractingEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcFolder, int32_t szFolder, const char * pcFileName, int32_t szFileName)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zFolder;
	zval * zFileName;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zFolder);
	ZVAL_STRINGL(zFolder, pcFolder, szFolder, 1);
	MAKE_STD_ZVAL(zFileName);
	ZVAL_STRINGL(zFileName, pcFileName, szFileName, 1);

	params[0] = &zSender;
	params[1] = &zFolder;
	params[2] = &zFileName;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zFolder);
	zval_ptr_dtor(&zFileName);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBPGPSFXErrorEventRaw(void * _ObjectData, TObjectHandle Sender, TElClassHandle Error)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zError;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zError);
	SBInitObject(zError, TObject_ce_ptr, Error TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zError;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zError);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBPGPSFXFileErrorEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcOriginalFileName, int32_t szOriginalFileName, TElClassHandle Error, char * pcActualFileName, int32_t * szActualFileName, TSBPGPSFXFileActionRaw * Action)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zOriginalFileName;
	zval * zError;
	zval * zActualFileName;
	zval * zAction;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zOriginalFileName);
	ZVAL_STRINGL(zOriginalFileName, pcOriginalFileName, szOriginalFileName, 1);
	MAKE_STD_ZVAL(zError);
	SBInitObject(zError, TObject_ce_ptr, Error TSRMLS_CC);
	MAKE_STD_ZVAL(zActualFileName);
	ZVAL_STRINGL(zActualFileName, pcActualFileName, *szActualFileName, 1);
	MAKE_STD_ZVAL(zAction);
	ZVAL_LONG(zAction, (long)*Action);

	params[0] = &zSender;
	params[1] = &zOriginalFileName;
	params[2] = &zError;
	params[3] = &zActualFileName;
	params[4] = &zAction;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zOriginalFileName);
	zval_ptr_dtor(&zError);
	SBCheckError(SBSetEventReturnStringA(4, Z_STRVAL_P(zActualFileName), (int32_t)Z_STRLEN_P(zActualFileName)) TSRMLS_CC);
	zval_ptr_dtor(&zActualFileName);
	*Action = (TSBPGPSFXFileActionRaw)Z_LVAL_P(zAction);
	zval_ptr_dtor(&zAction);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBPGPSFXFileExistsEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcOriginalFileName, int32_t szOriginalFileName, int64_t OriginalTimeStamp, char * pcActualFileName, int32_t * szActualFileName, int64_t ActualTimeStamp, TSBPGPSFXFileActionRaw * Action)
{
	zval *retval_ptr;
	zval **params[6];
	zval * zSender;
	zval * zOriginalFileName;
	zval * zOriginalTimeStamp;
	zval * zActualFileName;
	zval * zActualTimeStamp;
	zval * zAction;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zOriginalFileName);
	ZVAL_STRINGL(zOriginalFileName, pcOriginalFileName, szOriginalFileName, 1);
	MAKE_STD_ZVAL(zOriginalTimeStamp);
	object_init_ex(zOriginalTimeStamp, php_date_get_date_ce());
	SBSetDateTime(zOriginalTimeStamp, OriginalTimeStamp TSRMLS_CC);
	MAKE_STD_ZVAL(zActualFileName);
	ZVAL_STRINGL(zActualFileName, pcActualFileName, *szActualFileName, 1);
	MAKE_STD_ZVAL(zActualTimeStamp);
	object_init_ex(zActualTimeStamp, php_date_get_date_ce());
	SBSetDateTime(zActualTimeStamp, ActualTimeStamp TSRMLS_CC);
	MAKE_STD_ZVAL(zAction);
	ZVAL_LONG(zAction, (long)*Action);

	params[0] = &zSender;
	params[1] = &zOriginalFileName;
	params[2] = &zOriginalTimeStamp;
	params[3] = &zActualFileName;
	params[4] = &zActualTimeStamp;
	params[5] = &zAction;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 6, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zOriginalFileName);
	zval_ptr_dtor(&zOriginalTimeStamp);
	SBCheckError(SBSetEventReturnStringA(4, Z_STRVAL_P(zActualFileName), (int32_t)Z_STRLEN_P(zActualFileName)) TSRMLS_CC);
	zval_ptr_dtor(&zActualFileName);
	zval_ptr_dtor(&zActualTimeStamp);
	*Action = (TSBPGPSFXFileActionRaw)Z_LVAL_P(zAction);
	zval_ptr_dtor(&zAction);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBPGPSFXFileEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcOriginalFileName, int32_t szOriginalFileName, TSBPGPSFXFileActionRaw OriginalFileAction, const char * pcActualFileName, int32_t szActualFileName, TSBPGPSFXFileActionRaw ActualFileAction, int64_t TimeStamp)
{
	zval *retval_ptr;
	zval **params[6];
	zval * zSender;
	zval * zOriginalFileName;
	zval * zOriginalFileAction;
	zval * zActualFileName;
	zval * zActualFileAction;
	zval * zTimeStamp;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zOriginalFileName);
	ZVAL_STRINGL(zOriginalFileName, pcOriginalFileName, szOriginalFileName, 1);
	MAKE_STD_ZVAL(zOriginalFileAction);
	ZVAL_LONG(zOriginalFileAction, (long)OriginalFileAction);
	MAKE_STD_ZVAL(zActualFileName);
	ZVAL_STRINGL(zActualFileName, pcActualFileName, szActualFileName, 1);
	MAKE_STD_ZVAL(zActualFileAction);
	ZVAL_LONG(zActualFileAction, (long)ActualFileAction);
	MAKE_STD_ZVAL(zTimeStamp);
	object_init_ex(zTimeStamp, php_date_get_date_ce());
	SBSetDateTime(zTimeStamp, TimeStamp TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zOriginalFileName;
	params[2] = &zOriginalFileAction;
	params[3] = &zActualFileName;
	params[4] = &zActualFileAction;
	params[5] = &zTimeStamp;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 6, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zOriginalFileName);
	zval_ptr_dtor(&zOriginalFileAction);
	zval_ptr_dtor(&zActualFileName);
	zval_ptr_dtor(&zActualFileAction);
	zval_ptr_dtor(&zTimeStamp);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBPGPSFXKeyPassphraseEventRaw(void * _ObjectData, TObjectHandle Sender, TElPGPCustomSecretKeyHandle Key, int32_t Attempt, char * pcPassphrase, int32_t * szPassphrase, int8_t * Cancel)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zKey;
	zval * zAttempt;
	zval * zPassphrase;
	zval * zCancel;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zKey);
	SBInitObject(zKey, TElPGPCustomSecretKey_ce_ptr, Key TSRMLS_CC);
	MAKE_STD_ZVAL(zAttempt);
	ZVAL_LONG(zAttempt, (long)Attempt);
	MAKE_STD_ZVAL(zPassphrase);
	ZVAL_STRINGL(zPassphrase, pcPassphrase, *szPassphrase, 1);
	MAKE_STD_ZVAL(zCancel);
	ZVAL_BOOL(zCancel, (zend_bool)*Cancel);

	params[0] = &zSender;
	params[1] = &zKey;
	params[2] = &zAttempt;
	params[3] = &zPassphrase;
	params[4] = &zCancel;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zKey);
	zval_ptr_dtor(&zAttempt);
	SBCheckError(SBSetEventReturnStringA(4, Z_STRVAL_P(zPassphrase), (int32_t)Z_STRLEN_P(zPassphrase)) TSRMLS_CC);
	zval_ptr_dtor(&zPassphrase);
	*Cancel = (int8_t)Z_BVAL_P(zCancel);
	zval_ptr_dtor(&zCancel);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBPGPSFXPassphraseEventRaw(void * _ObjectData, TObjectHandle Sender, int32_t Attempt, char * pcPassphrase, int32_t * szPassphrase, int8_t * Cancel)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zAttempt;
	zval * zPassphrase;
	zval * zCancel;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zAttempt);
	ZVAL_LONG(zAttempt, (long)Attempt);
	MAKE_STD_ZVAL(zPassphrase);
	ZVAL_STRINGL(zPassphrase, pcPassphrase, *szPassphrase, 1);
	MAKE_STD_ZVAL(zCancel);
	ZVAL_BOOL(zCancel, (zend_bool)*Cancel);

	params[0] = &zSender;
	params[1] = &zAttempt;
	params[2] = &zPassphrase;
	params[3] = &zCancel;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zAttempt);
	SBCheckError(SBSetEventReturnStringA(3, Z_STRVAL_P(zPassphrase), (int32_t)Z_STRLEN_P(zPassphrase)) TSRMLS_CC);
	zval_ptr_dtor(&zPassphrase);
	*Cancel = (int8_t)Z_BVAL_P(zCancel);
	zval_ptr_dtor(&zCancel);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBPGPSFXStartEventRaw(void * _ObjectData, TObjectHandle Sender, int8_t HelpRequested, int8_t * Abort)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zHelpRequested;
	zval * zAbort;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zHelpRequested);
	ZVAL_BOOL(zHelpRequested, (zend_bool)HelpRequested);
	MAKE_STD_ZVAL(zAbort);
	ZVAL_BOOL(zAbort, (zend_bool)*Abort);

	params[0] = &zSender;
	params[1] = &zHelpRequested;
	params[2] = &zAbort;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zHelpRequested);
	*Abort = (int8_t)Z_BVAL_P(zAbort);
	zval_ptr_dtor(&zAbort);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBPGPSFXTargetFolderEventRaw(void * _ObjectData, TObjectHandle Sender, char * pcFolder, int32_t * szFolder, int8_t * Abort)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zFolder;
	zval * zAbort;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zFolder);
	ZVAL_STRINGL(zFolder, pcFolder, *szFolder, 1);
	MAKE_STD_ZVAL(zAbort);
	ZVAL_BOOL(zAbort, (zend_bool)*Abort);

	params[0] = &zSender;
	params[1] = &zFolder;
	params[2] = &zAbort;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	SBCheckError(SBSetEventReturnStringA(2, Z_STRVAL_P(zFolder), (int32_t)Z_STRLEN_P(zFolder)) TSRMLS_CC);
	zval_ptr_dtor(&zFolder);
	*Abort = (int8_t)Z_BVAL_P(zAbort);
	zval_ptr_dtor(&zAbort);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElPGPSFXStub_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPSFXStub, Execute)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPSFXStub_Execute(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, get_Copyright)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPGPSFXStub_get_Copyright(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(95460200, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, get_Evaluation)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPSFXStub_get_Evaluation(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, get_Title)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPGPSFXStub_get_Title(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-785770764, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, get_UsedSwitches)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPSFXCommandLineSwitchesRaw fOutResultRaw = 0;
		SBCheckError(TElPGPSFXStub_get_UsedSwitches(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, get_Extract)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPGPSFXStub_get_Extract(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(592446391, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, set_Extract)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPGPSFXStub_set_Extract(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, get_KeyPassphrase)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPGPSFXStub_get_KeyPassphrase(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-208562108, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, set_KeyPassphrase)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPGPSFXStub_set_KeyPassphrase(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, get_Overwrite)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPSFXStub_get_Overwrite(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, set_Overwrite)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPSFXStub_set_Overwrite(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, get_Passphrase)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPGPSFXStub_get_Passphrase(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(133167020, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, set_Passphrase)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPGPSFXStub_set_Passphrase(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, get_PublicKeys)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPGPSFXStub_get_PublicKeys(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(6035757, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, set_PublicKeys)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPGPSFXStub_set_PublicKeys(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, get_SecretKeys)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPGPSFXStub_get_SecretKeys(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(434277563, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, set_SecretKeys)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPGPSFXStub_set_SecretKeys(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, get_Silent)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPSFXStub_get_Silent(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, set_Silent)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPSFXStub_set_Silent(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, get_SupportedSwitches)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPSFXCommandLineSwitchesRaw fOutResultRaw = 0;
		SBCheckError(TElPGPSFXStub_get_SupportedSwitches(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, set_SupportedSwitches)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElPGPSFXStub_set_SupportedSwitches(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPGPSFXCommandLineSwitchesRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, get_Target)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPGPSFXStub_get_Target(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-198749494, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, set_Target)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPGPSFXStub_set_Target(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, get_TempFileLocation)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPSFXTempFileLocationRaw fOutResultRaw = 0;
		SBCheckError(TElPGPSFXStub_get_TempFileLocation(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, set_TempFileLocation)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElPGPSFXStub_set_TempFileLocation(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPGPSFXTempFileLocationRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, get_UseCommandLine)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPSFXStub_get_UseCommandLine(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, set_UseCommandLine)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPSFXStub_set_UseCommandLine(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, get_OnAbort)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPSFXStub_get_OnAbort(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, set_OnAbort)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPSFXStub_set_OnAbort(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, get_OnCommandLine)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPSFXStub_get_OnCommandLine(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, set_OnCommandLine)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPSFXStub_set_OnCommandLine(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, get_OnEncrypted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPEncryptedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPSFXStub_get_OnEncrypted(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, set_OnEncrypted)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPSFXStub_set_OnEncrypted(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPEncryptedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPEncryptedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, get_OnError)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPSFXErrorEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPSFXStub_get_OnError(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, set_OnError)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPSFXStub_set_OnError(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPSFXErrorEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPSFXErrorEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, get_OnExtracting)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPSFXExtractingEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPSFXStub_get_OnExtracting(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, set_OnExtracting)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPSFXStub_set_OnExtracting(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPSFXExtractingEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPSFXExtractingEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, get_OnFileError)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPSFXFileErrorEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPSFXStub_get_OnFileError(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, set_OnFileError)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPSFXStub_set_OnFileError(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPSFXFileErrorEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPSFXFileErrorEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, get_OnFileExists)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPSFXFileExistsEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPSFXStub_get_OnFileExists(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, set_OnFileExists)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPSFXStub_set_OnFileExists(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPSFXFileExistsEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPSFXFileExistsEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, get_OnFileFinish)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPSFXFileEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPSFXStub_get_OnFileFinish(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, set_OnFileFinish)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPSFXStub_set_OnFileFinish(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPSFXFileEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPSFXFileEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, get_OnFileProgress)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBProgressEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPSFXStub_get_OnFileProgress(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, set_OnFileProgress)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPSFXStub_set_OnFileProgress(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBProgressEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBProgressEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, get_OnFileStart)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPSFXFileEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPSFXStub_get_OnFileStart(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, set_OnFileStart)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPSFXStub_set_OnFileStart(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPSFXFileEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPSFXFileEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, get_OnFinish)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPSFXStub_get_OnFinish(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, set_OnFinish)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPSFXStub_set_OnFinish(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, get_OnKeyPassphrase)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPSFXKeyPassphraseEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPSFXStub_get_OnKeyPassphrase(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, set_OnKeyPassphrase)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPSFXStub_set_OnKeyPassphrase(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPSFXKeyPassphraseEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPSFXKeyPassphraseEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, get_OnOutputStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPCreateOutputStreamEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPSFXStub_get_OnOutputStream(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, set_OnOutputStream)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPSFXStub_set_OnOutputStream(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPCreateOutputStreamEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPCreateOutputStreamEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, get_OnPassphrase)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPSFXPassphraseEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPSFXStub_get_OnPassphrase(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, set_OnPassphrase)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPSFXStub_set_OnPassphrase(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPSFXPassphraseEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPSFXPassphraseEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, get_OnProgress)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPProgressEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPSFXStub_get_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, set_OnProgress)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPSFXStub_set_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPProgressEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPProgressEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, get_OnSigned)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPSignedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPSFXStub_get_OnSigned(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, set_OnSigned)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPSFXStub_set_OnSigned(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPSignedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPSignedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, get_OnStart)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPSFXStartEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPSFXStub_get_OnStart(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, set_OnStart)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPSFXStub_set_OnStart(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPSFXStartEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPSFXStartEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, get_OnTargetFolder)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPSFXTargetFolderEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPSFXStub_get_OnTargetFolder(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, set_OnTargetFolder)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPSFXStub_set_OnTargetFolder(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPSFXTargetFolderEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPSFXTargetFolderEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXStub, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPSFXStub_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_Execute, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_get_Copyright, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_get_Evaluation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_get_Title, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_get_UsedSwitches, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_get_Extract, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_set_Extract, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_get_KeyPassphrase, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_set_KeyPassphrase, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_get_Overwrite, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_set_Overwrite, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_get_Passphrase, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_set_Passphrase, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_get_PublicKeys, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_set_PublicKeys, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_get_SecretKeys, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_set_SecretKeys, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_get_Silent, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_set_Silent, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_get_SupportedSwitches, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_set_SupportedSwitches, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_get_Target, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_set_Target, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_get_TempFileLocation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_set_TempFileLocation, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_get_UseCommandLine, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_set_UseCommandLine, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_get_OnAbort, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_set_OnAbort, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_get_OnCommandLine, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_set_OnCommandLine, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_get_OnEncrypted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_set_OnEncrypted, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_get_OnError, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_set_OnError, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_get_OnExtracting, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_set_OnExtracting, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_get_OnFileError, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_set_OnFileError, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_get_OnFileExists, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_set_OnFileExists, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_get_OnFileFinish, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_set_OnFileFinish, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_get_OnFileProgress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_set_OnFileProgress, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_get_OnFileStart, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_set_OnFileStart, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_get_OnFinish, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_set_OnFinish, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_get_OnKeyPassphrase, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_set_OnKeyPassphrase, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_get_OnOutputStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_set_OnOutputStream, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_get_OnPassphrase, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_set_OnPassphrase, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_get_OnProgress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_set_OnProgress, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_get_OnSigned, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_set_OnSigned, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_get_OnStart, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_set_OnStart, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_get_OnTargetFolder, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub_set_OnTargetFolder, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXStub___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPSFXStub_methods[] = {
	PHP_ME(TElPGPSFXStub, Execute, arginfo_TElPGPSFXStub_Execute, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, get_Copyright, arginfo_TElPGPSFXStub_get_Copyright, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, get_Evaluation, arginfo_TElPGPSFXStub_get_Evaluation, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, get_Title, arginfo_TElPGPSFXStub_get_Title, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, get_UsedSwitches, arginfo_TElPGPSFXStub_get_UsedSwitches, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, get_Extract, arginfo_TElPGPSFXStub_get_Extract, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, set_Extract, arginfo_TElPGPSFXStub_set_Extract, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, get_KeyPassphrase, arginfo_TElPGPSFXStub_get_KeyPassphrase, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, set_KeyPassphrase, arginfo_TElPGPSFXStub_set_KeyPassphrase, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, get_Overwrite, arginfo_TElPGPSFXStub_get_Overwrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, set_Overwrite, arginfo_TElPGPSFXStub_set_Overwrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, get_Passphrase, arginfo_TElPGPSFXStub_get_Passphrase, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, set_Passphrase, arginfo_TElPGPSFXStub_set_Passphrase, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, get_PublicKeys, arginfo_TElPGPSFXStub_get_PublicKeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, set_PublicKeys, arginfo_TElPGPSFXStub_set_PublicKeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, get_SecretKeys, arginfo_TElPGPSFXStub_get_SecretKeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, set_SecretKeys, arginfo_TElPGPSFXStub_set_SecretKeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, get_Silent, arginfo_TElPGPSFXStub_get_Silent, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, set_Silent, arginfo_TElPGPSFXStub_set_Silent, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, get_SupportedSwitches, arginfo_TElPGPSFXStub_get_SupportedSwitches, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, set_SupportedSwitches, arginfo_TElPGPSFXStub_set_SupportedSwitches, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, get_Target, arginfo_TElPGPSFXStub_get_Target, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, set_Target, arginfo_TElPGPSFXStub_set_Target, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, get_TempFileLocation, arginfo_TElPGPSFXStub_get_TempFileLocation, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, set_TempFileLocation, arginfo_TElPGPSFXStub_set_TempFileLocation, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, get_UseCommandLine, arginfo_TElPGPSFXStub_get_UseCommandLine, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, set_UseCommandLine, arginfo_TElPGPSFXStub_set_UseCommandLine, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, get_OnAbort, arginfo_TElPGPSFXStub_get_OnAbort, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, set_OnAbort, arginfo_TElPGPSFXStub_set_OnAbort, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, get_OnCommandLine, arginfo_TElPGPSFXStub_get_OnCommandLine, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, set_OnCommandLine, arginfo_TElPGPSFXStub_set_OnCommandLine, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, get_OnEncrypted, arginfo_TElPGPSFXStub_get_OnEncrypted, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, set_OnEncrypted, arginfo_TElPGPSFXStub_set_OnEncrypted, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, get_OnError, arginfo_TElPGPSFXStub_get_OnError, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, set_OnError, arginfo_TElPGPSFXStub_set_OnError, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, get_OnExtracting, arginfo_TElPGPSFXStub_get_OnExtracting, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, set_OnExtracting, arginfo_TElPGPSFXStub_set_OnExtracting, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, get_OnFileError, arginfo_TElPGPSFXStub_get_OnFileError, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, set_OnFileError, arginfo_TElPGPSFXStub_set_OnFileError, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, get_OnFileExists, arginfo_TElPGPSFXStub_get_OnFileExists, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, set_OnFileExists, arginfo_TElPGPSFXStub_set_OnFileExists, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, get_OnFileFinish, arginfo_TElPGPSFXStub_get_OnFileFinish, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, set_OnFileFinish, arginfo_TElPGPSFXStub_set_OnFileFinish, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, get_OnFileProgress, arginfo_TElPGPSFXStub_get_OnFileProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, set_OnFileProgress, arginfo_TElPGPSFXStub_set_OnFileProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, get_OnFileStart, arginfo_TElPGPSFXStub_get_OnFileStart, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, set_OnFileStart, arginfo_TElPGPSFXStub_set_OnFileStart, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, get_OnFinish, arginfo_TElPGPSFXStub_get_OnFinish, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, set_OnFinish, arginfo_TElPGPSFXStub_set_OnFinish, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, get_OnKeyPassphrase, arginfo_TElPGPSFXStub_get_OnKeyPassphrase, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, set_OnKeyPassphrase, arginfo_TElPGPSFXStub_set_OnKeyPassphrase, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, get_OnOutputStream, arginfo_TElPGPSFXStub_get_OnOutputStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, set_OnOutputStream, arginfo_TElPGPSFXStub_set_OnOutputStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, get_OnPassphrase, arginfo_TElPGPSFXStub_get_OnPassphrase, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, set_OnPassphrase, arginfo_TElPGPSFXStub_set_OnPassphrase, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, get_OnProgress, arginfo_TElPGPSFXStub_get_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, set_OnProgress, arginfo_TElPGPSFXStub_set_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, get_OnSigned, arginfo_TElPGPSFXStub_get_OnSigned, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, set_OnSigned, arginfo_TElPGPSFXStub_set_OnSigned, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, get_OnStart, arginfo_TElPGPSFXStub_get_OnStart, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, set_OnStart, arginfo_TElPGPSFXStub_set_OnStart, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, get_OnTargetFolder, arginfo_TElPGPSFXStub_get_OnTargetFolder, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, set_OnTargetFolder, arginfo_TElPGPSFXStub_set_OnTargetFolder, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXStub, __construct, arginfo_TElPGPSFXStub___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPSFXStub(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPSFXStub_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPSFXStub", TElPGPSFXStub_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElPGPSFXStub_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPSFXMaker_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPSFXMaker, Execute)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPSFXMaker_Execute(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXMaker, Update)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPGPSFXMaker_Update(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXMaker, get_Copyright)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPGPSFXMaker_get_Copyright(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1654230653, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXMaker, set_Copyright)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPGPSFXMaker_set_Copyright(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXMaker, get_Title)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPGPSFXMaker_get_Title(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-419151119, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXMaker, set_Title)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPGPSFXMaker_set_Title(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXMaker, get_OnProgress)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBProgressEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPSFXMaker_get_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXMaker, set_OnProgress)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPSFXMaker_set_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBProgressEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBProgressEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSFXMaker, __construct)
{
	zval *oAOutput;
	zval *oAStub;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oAStub, TStream_ce_ptr, &oAOutput, TStream_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPSFXMaker_Create(SBGetObjectHandle(oAStub TSRMLS_CC), SBGetObjectHandle(oAOutput TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, TStream)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXMaker_Execute, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXMaker_Update, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXMaker_get_Copyright, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXMaker_set_Copyright, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXMaker_get_Title, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXMaker_set_Title, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXMaker_get_OnProgress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXMaker_set_OnProgress, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSFXMaker___construct, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, AStub, TStream, 1)
	ZEND_ARG_OBJ_INFO(0, AOutput, TStream, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPSFXMaker_methods[] = {
	PHP_ME(TElPGPSFXMaker, Execute, arginfo_TElPGPSFXMaker_Execute, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXMaker, Update, arginfo_TElPGPSFXMaker_Update, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXMaker, get_Copyright, arginfo_TElPGPSFXMaker_get_Copyright, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXMaker, set_Copyright, arginfo_TElPGPSFXMaker_set_Copyright, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXMaker, get_Title, arginfo_TElPGPSFXMaker_get_Title, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXMaker, set_Title, arginfo_TElPGPSFXMaker_set_Title, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXMaker, get_OnProgress, arginfo_TElPGPSFXMaker_get_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXMaker, set_OnProgress, arginfo_TElPGPSFXMaker_set_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSFXMaker, __construct, arginfo_TElPGPSFXMaker___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPSFXMaker(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPSFXMaker_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPSFXMaker", TElPGPSFXMaker_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElPGPSFXMaker_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBPGPSFX_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_SIZEOF_SHORT_NAME, SB_IMAGE_SIZEOF_SHORT_NAME, SB_IMAGE_SIZEOF_SHORT_NAME);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_NUMBEROF_DIRECTORY_ENTRIES, SB_IMAGE_NUMBEROF_DIRECTORY_ENTRIES, SB_IMAGE_NUMBEROF_DIRECTORY_ENTRIES);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_SIZEOF_FILE_HEADER, SB_IMAGE_SIZEOF_FILE_HEADER, SB_IMAGE_SIZEOF_FILE_HEADER);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_FILE_RELOCS_STRIPPED, SB_IMAGE_FILE_RELOCS_STRIPPED, SB_IMAGE_FILE_RELOCS_STRIPPED);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_FILE_EXECUTABLE_IMAGE, SB_IMAGE_FILE_EXECUTABLE_IMAGE, SB_IMAGE_FILE_EXECUTABLE_IMAGE);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_FILE_LINE_NUMS_STRIPPED, SB_IMAGE_FILE_LINE_NUMS_STRIPPED, SB_IMAGE_FILE_LINE_NUMS_STRIPPED);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_FILE_LOCAL_SYMS_STRIPPED, SB_IMAGE_FILE_LOCAL_SYMS_STRIPPED, SB_IMAGE_FILE_LOCAL_SYMS_STRIPPED);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_FILE_AGGRESIVE_WS_TRIM, SB_IMAGE_FILE_AGGRESIVE_WS_TRIM, SB_IMAGE_FILE_AGGRESIVE_WS_TRIM);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_FILE_BYTES_REVERSED_LO, SB_IMAGE_FILE_BYTES_REVERSED_LO, SB_IMAGE_FILE_BYTES_REVERSED_LO);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_FILE_32BIT_MACHINE, SB_IMAGE_FILE_32BIT_MACHINE, SB_IMAGE_FILE_32BIT_MACHINE);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_FILE_DEBUG_STRIPPED, SB_IMAGE_FILE_DEBUG_STRIPPED, SB_IMAGE_FILE_DEBUG_STRIPPED);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_FILE_REMOVABLE_RUN_FROM_SWAP, SB_IMAGE_FILE_REMOVABLE_RUN_FROM_SWAP, SB_IMAGE_FILE_REMOVABLE_RUN_FROM_SWAP);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_FILE_NET_RUN_FROM_SWAP, SB_IMAGE_FILE_NET_RUN_FROM_SWAP, SB_IMAGE_FILE_NET_RUN_FROM_SWAP);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_FILE_SYSTEM, SB_IMAGE_FILE_SYSTEM, SB_IMAGE_FILE_SYSTEM);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_FILE_DLL, SB_IMAGE_FILE_DLL, SB_IMAGE_FILE_DLL);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_FILE_UP_SYSTEM_ONLY, SB_IMAGE_FILE_UP_SYSTEM_ONLY, SB_IMAGE_FILE_UP_SYSTEM_ONLY);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_FILE_BYTES_REVERSED_HI, SB_IMAGE_FILE_BYTES_REVERSED_HI, SB_IMAGE_FILE_BYTES_REVERSED_HI);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_FILE_MACHINE_UNKNOWN, SB_IMAGE_FILE_MACHINE_UNKNOWN, SB_IMAGE_FILE_MACHINE_UNKNOWN);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_FILE_MACHINE_I386, SB_IMAGE_FILE_MACHINE_I386, SB_IMAGE_FILE_MACHINE_I386);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_FILE_MACHINE_R3000, SB_IMAGE_FILE_MACHINE_R3000, SB_IMAGE_FILE_MACHINE_R3000);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_FILE_MACHINE_R4000, SB_IMAGE_FILE_MACHINE_R4000, SB_IMAGE_FILE_MACHINE_R4000);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_FILE_MACHINE_R10000, SB_IMAGE_FILE_MACHINE_R10000, SB_IMAGE_FILE_MACHINE_R10000);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_FILE_MACHINE_ALPHA, SB_IMAGE_FILE_MACHINE_ALPHA, SB_IMAGE_FILE_MACHINE_ALPHA);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_FILE_MACHINE_POWERPC, SB_IMAGE_FILE_MACHINE_POWERPC, SB_IMAGE_FILE_MACHINE_POWERPC);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_SIZEOF_SECTION_HEADER, SB_IMAGE_SIZEOF_SECTION_HEADER, SB_IMAGE_SIZEOF_SECTION_HEADER);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_SCN_TYPE_NO_PAD, SB_IMAGE_SCN_TYPE_NO_PAD, SB_IMAGE_SCN_TYPE_NO_PAD);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_SCN_CNT_CODE, SB_IMAGE_SCN_CNT_CODE, SB_IMAGE_SCN_CNT_CODE);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_SCN_CNT_INITIALIZED_DATA, SB_IMAGE_SCN_CNT_INITIALIZED_DATA, SB_IMAGE_SCN_CNT_INITIALIZED_DATA);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_SCN_CNT_UNINITIALIZED_DATA, SB_IMAGE_SCN_CNT_UNINITIALIZED_DATA, SB_IMAGE_SCN_CNT_UNINITIALIZED_DATA);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_SCN_LNK_OTHER, SB_IMAGE_SCN_LNK_OTHER, SB_IMAGE_SCN_LNK_OTHER);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_SCN_LNK_INFO, SB_IMAGE_SCN_LNK_INFO, SB_IMAGE_SCN_LNK_INFO);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_SCN_LNK_REMOVE, SB_IMAGE_SCN_LNK_REMOVE, SB_IMAGE_SCN_LNK_REMOVE);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_SCN_LNK_COMDAT, SB_IMAGE_SCN_LNK_COMDAT, SB_IMAGE_SCN_LNK_COMDAT);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_SCN_MEM_FARDATA, SB_IMAGE_SCN_MEM_FARDATA, SB_IMAGE_SCN_MEM_FARDATA);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_SCN_MEM_PURGEABLE, SB_IMAGE_SCN_MEM_PURGEABLE, SB_IMAGE_SCN_MEM_PURGEABLE);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_SCN_MEM_16BIT, SB_IMAGE_SCN_MEM_16BIT, SB_IMAGE_SCN_MEM_16BIT);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_SCN_MEM_LOCKED, SB_IMAGE_SCN_MEM_LOCKED, SB_IMAGE_SCN_MEM_LOCKED);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_SCN_MEM_PRELOAD, SB_IMAGE_SCN_MEM_PRELOAD, SB_IMAGE_SCN_MEM_PRELOAD);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_SCN_ALIGN_1BYTES, SB_IMAGE_SCN_ALIGN_1BYTES, SB_IMAGE_SCN_ALIGN_1BYTES);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_SCN_ALIGN_2BYTES, SB_IMAGE_SCN_ALIGN_2BYTES, SB_IMAGE_SCN_ALIGN_2BYTES);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_SCN_ALIGN_4BYTES, SB_IMAGE_SCN_ALIGN_4BYTES, SB_IMAGE_SCN_ALIGN_4BYTES);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_SCN_ALIGN_8BYTES, SB_IMAGE_SCN_ALIGN_8BYTES, SB_IMAGE_SCN_ALIGN_8BYTES);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_SCN_ALIGN_16BYTES, SB_IMAGE_SCN_ALIGN_16BYTES, SB_IMAGE_SCN_ALIGN_16BYTES);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_SCN_ALIGN_32BYTES, SB_IMAGE_SCN_ALIGN_32BYTES, SB_IMAGE_SCN_ALIGN_32BYTES);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_SCN_ALIGN_64BYTES, SB_IMAGE_SCN_ALIGN_64BYTES, SB_IMAGE_SCN_ALIGN_64BYTES);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_SCN_LNK_NRELOC_OVFL, SB_IMAGE_SCN_LNK_NRELOC_OVFL, SB_IMAGE_SCN_LNK_NRELOC_OVFL);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_SCN_MEM_DISCARDABLE, SB_IMAGE_SCN_MEM_DISCARDABLE, SB_IMAGE_SCN_MEM_DISCARDABLE);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_SCN_MEM_NOT_CACHED, SB_IMAGE_SCN_MEM_NOT_CACHED, SB_IMAGE_SCN_MEM_NOT_CACHED);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_SCN_MEM_NOT_PAGED, SB_IMAGE_SCN_MEM_NOT_PAGED, SB_IMAGE_SCN_MEM_NOT_PAGED);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_SCN_MEM_SHARED, SB_IMAGE_SCN_MEM_SHARED, SB_IMAGE_SCN_MEM_SHARED);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_SCN_MEM_EXECUTE, SB_IMAGE_SCN_MEM_EXECUTE, SB_IMAGE_SCN_MEM_EXECUTE);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_SCN_MEM_READ, SB_IMAGE_SCN_MEM_READ, SB_IMAGE_SCN_MEM_READ);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_SCN_MEM_WRITE, SB_IMAGE_SCN_MEM_WRITE, SB_IMAGE_SCN_MEM_WRITE);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_NT_OPTIONAL_HDR_MAGIC, SB_IMAGE_NT_OPTIONAL_HDR_MAGIC, SB_IMAGE_NT_OPTIONAL_HDR_MAGIC);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_SUBSYSTEM_WINDOWS_GUI, SB_IMAGE_SUBSYSTEM_WINDOWS_GUI, SB_IMAGE_SUBSYSTEM_WINDOWS_GUI);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, IMAGE_SUBSYSTEM_WINDOWS_CUI, SB_IMAGE_SUBSYSTEM_WINDOWS_CUI, SB_IMAGE_SUBSYSTEM_WINDOWS_CUI);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, PGPSFXStubAllSwitches, SB_PGPSFXStubAllSwitches, 1023);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, SB_PGPSFX_ERROR_BASE, SB_PGPSFX_ERROR_BASE, SB_PGPSFX_ERROR_BASE);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, SB_PGPSFX_OK, SB_PGPSFX_OK, SB_PGPSFX_OK);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, SB_PGPSFX_USER_ABORT, SB_PGPSFX_USER_ABORT, SB_PGPSFX_USER_ABORT);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, SB_PGPSFX_INTERNAL_ERROR, SB_PGPSFX_INTERNAL_ERROR, SB_PGPSFX_INTERNAL_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, SB_PGPSFX_INVALID_PARAMETER_TARGET, SB_PGPSFX_INVALID_PARAMETER_TARGET, SB_PGPSFX_INVALID_PARAMETER_TARGET);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, SB_PGPSFX_INVALID_PARAMETER_PUBLIC, SB_PGPSFX_INVALID_PARAMETER_PUBLIC, SB_PGPSFX_INVALID_PARAMETER_PUBLIC);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, SB_PGPSFX_INVALID_PARAMETER_SECRET, SB_PGPSFX_INVALID_PARAMETER_SECRET, SB_PGPSFX_INVALID_PARAMETER_SECRET);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, SB_PGPSFX_INVALID_PARAMETER_KEYPASS, SB_PGPSFX_INVALID_PARAMETER_KEYPASS, SB_PGPSFX_INVALID_PARAMETER_KEYPASS);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, SB_PGPSFX_INVALID_PARAMETER_PASS, SB_PGPSFX_INVALID_PARAMETER_PASS, SB_PGPSFX_INVALID_PARAMETER_PASS);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, SB_PGPSFX_INVALID_PARAMETER_EXTRACT, SB_PGPSFX_INVALID_PARAMETER_EXTRACT, SB_PGPSFX_INVALID_PARAMETER_EXTRACT);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, SB_PGPSFX_INVALID_PARAMETER_TEMP, SB_PGPSFX_INVALID_PARAMETER_TEMP, SB_PGPSFX_INVALID_PARAMETER_TEMP);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, SB_PGPSFX_TARGET_FOLDER_FAILURE, SB_PGPSFX_TARGET_FOLDER_FAILURE, SB_PGPSFX_TARGET_FOLDER_FAILURE);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, SB_PGPSFX_INPUT_STREAM_FAILURE, SB_PGPSFX_INPUT_STREAM_FAILURE, SB_PGPSFX_INPUT_STREAM_FAILURE);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, SB_PGPSFX_PACKET_FILE_ALREADY_EXISTS, SB_PGPSFX_PACKET_FILE_ALREADY_EXISTS, SB_PGPSFX_PACKET_FILE_ALREADY_EXISTS);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, SB_PGPSFX_PACKET_FILE_FAILURE, SB_PGPSFX_PACKET_FILE_FAILURE, SB_PGPSFX_PACKET_FILE_FAILURE);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, SB_PGPSFX_PUBLIC_KEY_NOT_FOUND, SB_PGPSFX_PUBLIC_KEY_NOT_FOUND, SB_PGPSFX_PUBLIC_KEY_NOT_FOUND);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, SB_PGPSFX_NO_PUBLIC_KEYS, SB_PGPSFX_NO_PUBLIC_KEYS, SB_PGPSFX_NO_PUBLIC_KEYS);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, SB_PGPSFX_SECRET_KEY_NOT_FOUND, SB_PGPSFX_SECRET_KEY_NOT_FOUND, SB_PGPSFX_SECRET_KEY_NOT_FOUND);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, SB_PGPSFX_NO_SECRET_KEYS, SB_PGPSFX_NO_SECRET_KEYS, SB_PGPSFX_NO_SECRET_KEYS);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, SB_PGPSFX_INVALID_METHOD, SB_PGPSFX_INVALID_METHOD, SB_PGPSFX_INVALID_METHOD);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, SB_PGPSFX_INVALID_PASSPHRASE, SB_PGPSFX_INVALID_PASSPHRASE, SB_PGPSFX_INVALID_PASSPHRASE);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, SB_PGPSFX_NO_PGP_DATA, SB_PGPSFX_NO_PGP_DATA, SB_PGPSFX_NO_PGP_DATA);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, SB_PGPSFX_MAKER_ERROR_BASE, SB_PGPSFX_MAKER_ERROR_BASE, SB_PGPSFX_MAKER_ERROR_BASE);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, SB_PGPSFX_NO_STUB, SB_PGPSFX_NO_STUB, SB_PGPSFX_NO_STUB);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, SB_PGPSFX_INVALID_DOS_SIGNATURE, SB_PGPSFX_INVALID_DOS_SIGNATURE, SB_PGPSFX_INVALID_DOS_SIGNATURE);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, SB_PGPSFX_INVALID_PE_SIGNATURE, SB_PGPSFX_INVALID_PE_SIGNATURE, SB_PGPSFX_INVALID_PE_SIGNATURE);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, SB_PGPSFX_INVALID_MACHINE_SPECIFIER, SB_PGPSFX_INVALID_MACHINE_SPECIFIER, SB_PGPSFX_INVALID_MACHINE_SPECIFIER);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, SB_PGPSFX_INVALID_CHARACTERISTICS, SB_PGPSFX_INVALID_CHARACTERISTICS, SB_PGPSFX_INVALID_CHARACTERISTICS);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, SB_PGPSFX_INVALID_OPTIONAL_SIGNATURE, SB_PGPSFX_INVALID_OPTIONAL_SIGNATURE, SB_PGPSFX_INVALID_OPTIONAL_SIGNATURE);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, SB_PGPSFX_INVALID_SUBSYSTEM, SB_PGPSFX_INVALID_SUBSYSTEM, SB_PGPSFX_INVALID_SUBSYSTEM);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, SB_PGPSFX_NO_SECTIONS, SB_PGPSFX_NO_SECTIONS, SB_PGPSFX_NO_SECTIONS);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, SB_PGPSFX_TITLE_TOO_LONG, SB_PGPSFX_TITLE_TOO_LONG, SB_PGPSFX_TITLE_TOO_LONG);
	SB_REGISTER_LONG_CONSTANT(SBPGPSFX, SB_PGPSFX_COPYRIGHT_TOO_LONG, SB_PGPSFX_COPYRIGHT_TOO_LONG, SB_PGPSFX_COPYRIGHT_TOO_LONG);
	SB_REGISTER_STRING_CONSTANT(SBPGPSFX, SErrUserAbort, SB_SErrUserAbort, SB_SErrUserAbort);
	SB_REGISTER_STRING_CONSTANT(SBPGPSFX, SErrInternalError, SB_SErrInternalError, SB_SErrInternalError);
	SB_REGISTER_STRING_CONSTANT(SBPGPSFX, SErrInvalidParamTarget, SB_SErrInvalidParamTarget, SB_SErrInvalidParamTarget);
	SB_REGISTER_STRING_CONSTANT(SBPGPSFX, SErrInvalidParamPublic, SB_SErrInvalidParamPublic, SB_SErrInvalidParamPublic);
	SB_REGISTER_STRING_CONSTANT(SBPGPSFX, SErrInvalidParamSecret, SB_SErrInvalidParamSecret, SB_SErrInvalidParamSecret);
	SB_REGISTER_STRING_CONSTANT(SBPGPSFX, SErrInvalidParamKeyPass, SB_SErrInvalidParamKeyPass, SB_SErrInvalidParamKeyPass);
	SB_REGISTER_STRING_CONSTANT(SBPGPSFX, SErrInvalidParamPass, SB_SErrInvalidParamPass, SB_SErrInvalidParamPass);
	SB_REGISTER_STRING_CONSTANT(SBPGPSFX, SErrInvalidParamTemp, SB_SErrInvalidParamTemp, SB_SErrInvalidParamTemp);
	SB_REGISTER_STRING_CONSTANT(SBPGPSFX, SErrTargetFolderFailure, SB_SErrTargetFolderFailure, SB_SErrTargetFolderFailure);
	SB_REGISTER_STRING_CONSTANT(SBPGPSFX, SErrInputStreamFailure, SB_SErrInputStreamFailure, SB_SErrInputStreamFailure);
	SB_REGISTER_STRING_CONSTANT(SBPGPSFX, SErrNoPGPData, SB_SErrNoPGPData, SB_SErrNoPGPData);
	SB_REGISTER_STRING_CONSTANT(SBPGPSFX, SErrPacketFileAlreadyExists, SB_SErrPacketFileAlreadyExists, SB_SErrPacketFileAlreadyExists);
	SB_REGISTER_STRING_CONSTANT(SBPGPSFX, SErrPacketFileFailure, SB_SErrPacketFileFailure, SB_SErrPacketFileFailure);
	SB_REGISTER_STRING_CONSTANT(SBPGPSFX, SErrNoStubStreamSpecified, SB_SErrNoStubStreamSpecified, SB_SErrNoStubStreamSpecified);
	SB_REGISTER_STRING_CONSTANT(SBPGPSFX, SErrInvalidDOSSignature, SB_SErrInvalidDOSSignature, SB_SErrInvalidDOSSignature);
	SB_REGISTER_STRING_CONSTANT(SBPGPSFX, SErrInvalidPESignature, SB_SErrInvalidPESignature, SB_SErrInvalidPESignature);
	SB_REGISTER_STRING_CONSTANT(SBPGPSFX, SErrInvalidMachineSpecifier, SB_SErrInvalidMachineSpecifier, SB_SErrInvalidMachineSpecifier);
	SB_REGISTER_STRING_CONSTANT(SBPGPSFX, SErrInvalidCharacteristics, SB_SErrInvalidCharacteristics, SB_SErrInvalidCharacteristics);
	SB_REGISTER_STRING_CONSTANT(SBPGPSFX, SErrInvalidOptionalSignature, SB_SErrInvalidOptionalSignature, SB_SErrInvalidOptionalSignature);
	SB_REGISTER_STRING_CONSTANT(SBPGPSFX, SErrInvalidSubsystem, SB_SErrInvalidSubsystem, SB_SErrInvalidSubsystem);
	SB_REGISTER_STRING_CONSTANT(SBPGPSFX, SErrNoSections, SB_SErrNoSections, SB_SErrNoSections);
	SB_REGISTER_STRING_CONSTANT(SBPGPSFX, SErrTitleTooLong, SB_SErrTitleTooLong, SB_SErrTitleTooLong);
	SB_REGISTER_STRING_CONSTANT(SBPGPSFX, SErrCopyrightTooLong, SB_SErrCopyrightTooLong, SB_SErrCopyrightTooLong);
}

void Register_SBPGPSFX_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBPGPSFXCommandLineSwitch", NULL);
	TSBPGPSFXCommandLineSwitch_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPGPSFXCommandLineSwitch_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSFXCommandLineSwitch_ce_ptr, "clsHelp", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSFXCommandLineSwitch_ce_ptr, "clsSilent", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSFXCommandLineSwitch_ce_ptr, "clsOverwrite", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSFXCommandLineSwitch_ce_ptr, "clsTarget", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSFXCommandLineSwitch_ce_ptr, "clsPublic", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSFXCommandLineSwitch_ce_ptr, "clsSecret", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSFXCommandLineSwitch_ce_ptr, "clsKeyPass", 6)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSFXCommandLineSwitch_ce_ptr, "clsPass", 7)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSFXCommandLineSwitch_ce_ptr, "clsExtract", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSFXCommandLineSwitch_ce_ptr, "clsTempFile", 9)
	
	INIT_CLASS_ENTRY(ce, "TSBPGPSFXCommandLineSwitches", NULL);
	TSBPGPSFXCommandLineSwitches_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TSBPGPSFXCommandLineSwitches_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSFXCommandLineSwitches_ce_ptr, "clsHelp", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSFXCommandLineSwitches_ce_ptr, "clsSilent", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSFXCommandLineSwitches_ce_ptr, "clsOverwrite", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSFXCommandLineSwitches_ce_ptr, "clsTarget", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSFXCommandLineSwitches_ce_ptr, "clsPublic", 16)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSFXCommandLineSwitches_ce_ptr, "clsSecret", 32)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSFXCommandLineSwitches_ce_ptr, "clsKeyPass", 64)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSFXCommandLineSwitches_ce_ptr, "clsPass", 128)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSFXCommandLineSwitches_ce_ptr, "clsExtract", 256)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSFXCommandLineSwitches_ce_ptr, "clsTempFile", 512)
	
	INIT_CLASS_ENTRY(ce, "TSBPGPSFXTempFileLocation", NULL);
	TSBPGPSFXTempFileLocation_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPGPSFXTempFileLocation_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSFXTempFileLocation_ce_ptr, "tflNone", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSFXTempFileLocation_ce_ptr, "tflSystem", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSFXTempFileLocation_ce_ptr, "tflTarget", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBPGPSFXFileAction", NULL);
	TSBPGPSFXFileAction_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPGPSFXFileAction_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSFXFileAction_ce_ptr, "faNewFile", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSFXFileAction_ce_ptr, "faOverwrite", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSFXFileAction_ce_ptr, "faRename", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSFXFileAction_ce_ptr, "faSkip", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPSFXFileAction_ce_ptr, "faRetry", 4)
}

void Register_SBPGPSFX_Aliases(TSRMLS_D)
{
	if (NULL == SBPGPSFX__IMAGE_DATA_DIRECTORY_ce_ptr)
		Register_SBPGPSFX__IMAGE_DATA_DIRECTORY(TSRMLS_C);
	zend_register_class_alias("SBPGPSFX_TImageDataDirectory", SBPGPSFX__IMAGE_DATA_DIRECTORY_ce_ptr);
	if (NULL == SBPGPSFX__IMAGE_DATA_DIRECTORY_ce_ptr)
		Register_SBPGPSFX__IMAGE_DATA_DIRECTORY(TSRMLS_C);
	zend_register_class_alias("SBPGPSFX_IMAGE_DATA_DIRECTORY", SBPGPSFX__IMAGE_DATA_DIRECTORY_ce_ptr);
	if (NULL == SBPGPSFX__IMAGE_OPTIONAL_HEADER_ce_ptr)
		Register_SBPGPSFX__IMAGE_OPTIONAL_HEADER(TSRMLS_C);
	zend_register_class_alias("SBPGPSFX_TImageOptionalHeader", SBPGPSFX__IMAGE_OPTIONAL_HEADER_ce_ptr);
	if (NULL == SBPGPSFX__IMAGE_OPTIONAL_HEADER_ce_ptr)
		Register_SBPGPSFX__IMAGE_OPTIONAL_HEADER(TSRMLS_C);
	zend_register_class_alias("SBPGPSFX_IMAGE_OPTIONAL_HEADER", SBPGPSFX__IMAGE_OPTIONAL_HEADER_ce_ptr);
	if (NULL == SBPGPSFX__IMAGE_DOS_HEADER_ce_ptr)
		Register_SBPGPSFX__IMAGE_DOS_HEADER(TSRMLS_C);
	zend_register_class_alias("SBPGPSFX_TImageDosHeader", SBPGPSFX__IMAGE_DOS_HEADER_ce_ptr);
	if (NULL == SBPGPSFX__IMAGE_DOS_HEADER_ce_ptr)
		Register_SBPGPSFX__IMAGE_DOS_HEADER(TSRMLS_C);
	zend_register_class_alias("SBPGPSFX_IMAGE_DOS_HEADER", SBPGPSFX__IMAGE_DOS_HEADER_ce_ptr);
	if (NULL == SBPGPSFX__IMAGE_FILE_HEADER_ce_ptr)
		Register_SBPGPSFX__IMAGE_FILE_HEADER(TSRMLS_C);
	zend_register_class_alias("SBPGPSFX_TImageFileHeader", SBPGPSFX__IMAGE_FILE_HEADER_ce_ptr);
	if (NULL == SBPGPSFX__IMAGE_FILE_HEADER_ce_ptr)
		Register_SBPGPSFX__IMAGE_FILE_HEADER(TSRMLS_C);
	zend_register_class_alias("SBPGPSFX_IMAGE_FILE_HEADER", SBPGPSFX__IMAGE_FILE_HEADER_ce_ptr);
	if (NULL == SBPGPSFX__IMAGE_NT_HEADERS_ce_ptr)
		Register_SBPGPSFX__IMAGE_NT_HEADERS(TSRMLS_C);
	zend_register_class_alias("SBPGPSFX_TImageNtHeaders", SBPGPSFX__IMAGE_NT_HEADERS_ce_ptr);
	if (NULL == SBPGPSFX__IMAGE_NT_HEADERS_ce_ptr)
		Register_SBPGPSFX__IMAGE_NT_HEADERS(TSRMLS_C);
	zend_register_class_alias("SBPGPSFX_IMAGE_NT_HEADERS", SBPGPSFX__IMAGE_NT_HEADERS_ce_ptr);
	if (NULL == SBPGPSFX__IMAGE_SECTION_HEADER_ce_ptr)
		Register_SBPGPSFX__IMAGE_SECTION_HEADER(TSRMLS_C);
	zend_register_class_alias("SBPGPSFX_TImageSectionHeader", SBPGPSFX__IMAGE_SECTION_HEADER_ce_ptr);
	if (NULL == SBPGPSFX__IMAGE_SECTION_HEADER_ce_ptr)
		Register_SBPGPSFX__IMAGE_SECTION_HEADER(TSRMLS_C);
	zend_register_class_alias("SBPGPSFX_IMAGE_SECTION_HEADER", SBPGPSFX__IMAGE_SECTION_HEADER_ce_ptr);
}
#endif
