#include "sbrabbit.h"

SB_PHP_METHOD(UInt32Array8, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(UInt32Array8));
		intern->len = sizeof(UInt32Array8);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(UInt32Array8, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(UInt32Array8));
}

zend_class_entry *UInt32Array8_ce_ptr = NULL;

static zend_function_entry UInt32Array8_methods[] = {
	PHP_ME(UInt32Array8, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(UInt32Array8, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_UInt32Array8(TSRMLS_D)
{
	zend_class_entry ce;
	if (UInt32Array8_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "UInt32Array8", UInt32Array8_methods);
	UInt32Array8_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(Rabbit_Instance, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(Rabbit_Instance));
		intern->len = sizeof(Rabbit_Instance);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(Rabbit_Instance, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(Rabbit_Instance));
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(Rabbit_Instance, get_Carry)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 96);
}

SB_PHP_METHOD(Rabbit_Instance, set_Carry)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 96);
}

zend_class_entry *Rabbit_Instance_ce_ptr = NULL;

static zend_function_entry Rabbit_Instance_methods[] = {
	PHP_ME(Rabbit_Instance, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(Rabbit_Instance, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(Rabbit_Instance, get_Carry, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(Rabbit_Instance, set_Carry, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_Rabbit_Instance(TSRMLS_D)
{
	zend_class_entry ce;
	if (Rabbit_Instance_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "Rabbit_Instance", Rabbit_Instance_methods);
	Rabbit_Instance_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(Rabbit_Context, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(Rabbit_Context));
		intern->len = sizeof(Rabbit_Context);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(Rabbit_Context, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(Rabbit_Context));
}

zend_class_entry *Rabbit_Context_ce_ptr = NULL;

static zend_function_entry Rabbit_Context_methods[] = {
	PHP_ME(Rabbit_Context, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(Rabbit_Context, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_Rabbit_Context(TSRMLS_D)
{
	zend_class_entry ce;
	if (Rabbit_Context_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "Rabbit_Context", Rabbit_Context_methods);
	Rabbit_Context_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBRabbit, Rabbit_Init)
{
	SBArrayZValInfo aiKey;
	zval *oContext;
	zval *zaKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Oz", &oContext, Rabbit_Context_ce_ptr, &zaKey) == SUCCESS) && PZVAL_IS_REF(oContext) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))))
	{
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBRabbit_Rabbit_Init((Rabbit_Context *)SBGetStructPointer(oContext TSRMLS_CC), aiKey.data, aiKey.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKey);
	}
	else
	{
		SBErrorExpectsArguments("(&Rabbit_Context, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRabbit, Rabbit_IVInit)
{
	SBArrayZValInfo aiIV_Key;
	zval *oContext;
	zval *zaIV_Key;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Oz", &oContext, Rabbit_Context_ce_ptr, &zaIV_Key) == SUCCESS) && PZVAL_IS_REF(oContext) && ((IS_STRING == Z_TYPE_P(zaIV_Key)) || (IS_ARRAY == Z_TYPE_P(zaIV_Key)) || (IS_NULL == Z_TYPE_P(zaIV_Key))))
	{
		if (!SBGetByteArrayFromZVal(zaIV_Key, &aiIV_Key TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBRabbit_Rabbit_IVInit((Rabbit_Context *)SBGetStructPointer(oContext TSRMLS_CC), aiIV_Key.data, aiIV_Key.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiIV_Key);
	}
	else
	{
		SBErrorExpectsArguments("(&Rabbit_Context, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRabbit, Rabbit_Cipher)
{
	SBArrayZValInfo aiDst;
	SBArrayZValInfo aiSrc;
	uint32_t _err;
	zval *oContext;
	zval *zaDst;
	zval *zaSrc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozz", &oContext, Rabbit_Context_ce_ptr, &zaSrc, &zaDst) == SUCCESS) && PZVAL_IS_REF(oContext) && ((IS_STRING == Z_TYPE_P(zaSrc)) || (IS_ARRAY == Z_TYPE_P(zaSrc)) || (IS_NULL == Z_TYPE_P(zaSrc))) && PZVAL_IS_REF(zaDst) && ((IS_STRING == Z_TYPE_P(zaDst)) || (IS_ARRAY == Z_TYPE_P(zaDst))))
	{
		if (!SBGetByteArrayFromZVal(zaSrc, &aiSrc TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaDst, &aiDst TSRMLS_CC)) RETURN_FALSE;
		_err = SBRabbit_Rabbit_Cipher((Rabbit_Context *)SBGetStructPointer(oContext TSRMLS_CC), aiSrc.data, aiSrc.len, aiDst.data, &aiDst.len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaDst, &aiDst TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(2036673116, 2, aiDst.data, &aiDst.len) TSRMLS_CC);
			((char *)aiDst.data)[aiDst.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiDst);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiSrc);
		SBSetByteArrayToZVal(&aiDst, zaDst);
	}
	else
	{
		SBErrorExpectsArguments("(&Rabbit_Context, array of byte|string|NULL, &array of byte|string)" TSRMLS_CC);
	}
}

