#include "sbzcompressunit.h"

SB_PHP_METHOD(internal_state_s, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(internal_state_s));
		intern->len = sizeof(internal_state_s);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(internal_state_s, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(internal_state_s));
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(internal_state_s, get_status)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(internal_state_s, set_status)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(internal_state_s, get_pending_buf_size)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(internal_state_s, set_pending_buf_size)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(internal_state_s, get_pending)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(internal_state_s, set_pending)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(internal_state_s, get_wrap)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(internal_state_s, set_wrap)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(internal_state_s, get_data_type)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 28);
}

SB_PHP_METHOD(internal_state_s, set_data_type)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 28);
}

SB_PHP_METHOD(internal_state_s, get_method)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 29);
}

SB_PHP_METHOD(internal_state_s, set_method)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 29);
}

SB_PHP_METHOD(internal_state_s, get_last_flush)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 32);
}

SB_PHP_METHOD(internal_state_s, set_last_flush)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 32);
}

SB_PHP_METHOD(internal_state_s, get_w_size)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 36);
}

SB_PHP_METHOD(internal_state_s, set_w_size)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 36);
}

SB_PHP_METHOD(internal_state_s, get_w_bits)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 40);
}

SB_PHP_METHOD(internal_state_s, set_w_bits)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 40);
}

SB_PHP_METHOD(internal_state_s, get_w_mask)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 44);
}

SB_PHP_METHOD(internal_state_s, set_w_mask)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 44);
}

SB_PHP_METHOD(internal_state_s, get_window_size)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 52);
}

SB_PHP_METHOD(internal_state_s, set_window_size)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 52);
}

SB_PHP_METHOD(internal_state_s, get_ins_h)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 64);
}

SB_PHP_METHOD(internal_state_s, set_ins_h)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 64);
}

SB_PHP_METHOD(internal_state_s, get_hash_size)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 68);
}

SB_PHP_METHOD(internal_state_s, set_hash_size)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 68);
}

SB_PHP_METHOD(internal_state_s, get_hash_bits)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 72);
}

SB_PHP_METHOD(internal_state_s, set_hash_bits)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 72);
}

SB_PHP_METHOD(internal_state_s, get_hash_mask)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 76);
}

SB_PHP_METHOD(internal_state_s, set_hash_mask)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 76);
}

SB_PHP_METHOD(internal_state_s, get_hash_shift)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 80);
}

SB_PHP_METHOD(internal_state_s, set_hash_shift)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 80);
}

SB_PHP_METHOD(internal_state_s, get_block_start)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 84);
}

SB_PHP_METHOD(internal_state_s, set_block_start)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 84);
}

SB_PHP_METHOD(internal_state_s, get_match_length)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 88);
}

SB_PHP_METHOD(internal_state_s, set_match_length)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 88);
}

SB_PHP_METHOD(internal_state_s, get_prev_match)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 92);
}

SB_PHP_METHOD(internal_state_s, set_prev_match)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 92);
}

SB_PHP_METHOD(internal_state_s, get_match_available)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 96);
}

SB_PHP_METHOD(internal_state_s, set_match_available)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 96);
}

SB_PHP_METHOD(internal_state_s, get_strstart)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 100);
}

SB_PHP_METHOD(internal_state_s, set_strstart)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 100);
}

SB_PHP_METHOD(internal_state_s, get_match_start)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 104);
}

SB_PHP_METHOD(internal_state_s, set_match_start)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 104);
}

SB_PHP_METHOD(internal_state_s, get_lookahead)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 108);
}

SB_PHP_METHOD(internal_state_s, set_lookahead)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 108);
}

SB_PHP_METHOD(internal_state_s, get_prev_length)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 112);
}

SB_PHP_METHOD(internal_state_s, set_prev_length)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 112);
}

SB_PHP_METHOD(internal_state_s, get_max_chain_length)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 116);
}

SB_PHP_METHOD(internal_state_s, set_max_chain_length)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 116);
}

SB_PHP_METHOD(internal_state_s, get_max_lazy_match)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 120);
}

SB_PHP_METHOD(internal_state_s, set_max_lazy_match)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 120);
}

SB_PHP_METHOD(internal_state_s, get_level)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 124);
}

SB_PHP_METHOD(internal_state_s, set_level)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 124);
}

SB_PHP_METHOD(internal_state_s, get_strategy)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 128);
}

SB_PHP_METHOD(internal_state_s, set_strategy)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 128);
}

SB_PHP_METHOD(internal_state_s, get_good_match)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 132);
}

SB_PHP_METHOD(internal_state_s, set_good_match)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 132);
}

SB_PHP_METHOD(internal_state_s, get_nice_match)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 136);
}

SB_PHP_METHOD(internal_state_s, set_nice_match)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 136);
}

SB_PHP_METHOD(internal_state_s, get_heap_len)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 7964);
}

SB_PHP_METHOD(internal_state_s, set_heap_len)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 7964);
}

SB_PHP_METHOD(internal_state_s, get_heap_max)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 7968);
}

SB_PHP_METHOD(internal_state_s, set_heap_max)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 7968);
}

SB_PHP_METHOD(internal_state_s, get_lit_bufsize)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8552);
}

SB_PHP_METHOD(internal_state_s, set_lit_bufsize)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8552);
}

SB_PHP_METHOD(internal_state_s, get_last_lit)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8556);
}

SB_PHP_METHOD(internal_state_s, set_last_lit)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8556);
}

SB_PHP_METHOD(internal_state_s, get_opt_len)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8564);
}

SB_PHP_METHOD(internal_state_s, set_opt_len)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8564);
}

SB_PHP_METHOD(internal_state_s, get_static_len)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8568);
}

SB_PHP_METHOD(internal_state_s, set_static_len)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8568);
}

SB_PHP_METHOD(internal_state_s, get_matches)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8572);
}

SB_PHP_METHOD(internal_state_s, set_matches)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8572);
}

SB_PHP_METHOD(internal_state_s, get_last_eob_len)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8576);
}

SB_PHP_METHOD(internal_state_s, set_last_eob_len)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8576);
}

SB_PHP_METHOD(internal_state_s, get_bi_buf)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8580);
}

SB_PHP_METHOD(internal_state_s, set_bi_buf)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8580);
}

SB_PHP_METHOD(internal_state_s, get_bi_valid)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8584);
}

SB_PHP_METHOD(internal_state_s, set_bi_valid)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8584);
}

zend_class_entry *internal_state_s_ce_ptr = NULL;

static zend_function_entry internal_state_s_methods[] = {
	PHP_ME(internal_state_s, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(internal_state_s, get_status, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_status, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_pending_buf_size, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_pending_buf_size, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_pending, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_pending, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_wrap, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_wrap, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_data_type, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_data_type, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_method, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_method, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_last_flush, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_last_flush, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_w_size, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_w_size, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_w_bits, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_w_bits, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_w_mask, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_w_mask, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_window_size, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_window_size, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_ins_h, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_ins_h, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_hash_size, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_hash_size, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_hash_bits, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_hash_bits, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_hash_mask, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_hash_mask, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_hash_shift, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_hash_shift, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_block_start, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_block_start, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_match_length, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_match_length, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_prev_match, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_prev_match, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_match_available, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_match_available, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_strstart, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_strstart, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_match_start, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_match_start, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_lookahead, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_lookahead, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_prev_length, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_prev_length, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_max_chain_length, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_max_chain_length, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_max_lazy_match, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_max_lazy_match, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_level, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_level, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_strategy, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_strategy, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_good_match, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_good_match, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_nice_match, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_nice_match, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_heap_len, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_heap_len, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_heap_max, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_heap_max, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_lit_bufsize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_lit_bufsize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_last_lit, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_last_lit, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_opt_len, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_opt_len, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_static_len, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_static_len, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_matches, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_matches, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_last_eob_len, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_last_eob_len, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_bi_buf, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_bi_buf, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, get_bi_valid, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(internal_state_s, set_bi_valid, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_internal_state_s(TSRMLS_D)
{
	zend_class_entry ce;
	if (internal_state_s_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "internal_state_s", internal_state_s_methods);
	internal_state_s_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(config_s, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(config_s));
		intern->len = sizeof(config_s);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(config_s, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(config_s));
}

SB_PHP_METHOD(config_s, get_good_length)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(config_s, set_good_length)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(config_s, get_max_lazy)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 2);
}

SB_PHP_METHOD(config_s, set_max_lazy)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 2);
}

SB_PHP_METHOD(config_s, get_nice_length)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(config_s, set_nice_length)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(config_s, get_max_chain)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 6);
}

SB_PHP_METHOD(config_s, set_max_chain)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 6);
}

zend_class_entry *config_s_ce_ptr = NULL;

static zend_function_entry config_s_methods[] = {
	PHP_ME(config_s, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(config_s, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(config_s, get_good_length, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(config_s, set_good_length, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(config_s, get_max_lazy, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(config_s, set_max_lazy, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(config_s, get_nice_length, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(config_s, set_nice_length, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(config_s, get_max_chain, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(config_s, set_max_chain, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_config_s(TSRMLS_D)
{
	zend_class_entry ce;
	if (config_s_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "config_s", config_s_methods);
	config_s_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBZCompressUnit, deflateInit_)
{
	long l4level;
	long l4recsize;
	SBArrayZValInfo aiversion;
	zval *ostrm;
	zval *zaversion;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Olzl", &ostrm, TZStreamRec_ce_ptr, &l4level, &zaversion, &l4recsize) == SUCCESS) && PZVAL_IS_REF(ostrm) && ((IS_STRING == Z_TYPE_P(zaversion)) || (IS_ARRAY == Z_TYPE_P(zaversion)) || (IS_NULL == Z_TYPE_P(zaversion))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaversion, &aiversion TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBZCompressUnit_deflateInit_((TZStreamRec *)SBGetStructPointer(ostrm TSRMLS_CC), (int32_t)l4level, aiversion.data, aiversion.len, (int32_t)l4recsize, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiversion);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&TZStreamRec, integer, array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBZCompressUnit, deflateInit2_)
{
	long l4level;
	long l4memLevel;
	long l4method;
	long l4recsize;
	long l4strategy;
	long l4windowBits;
	SBArrayZValInfo aiversion;
	zval *ostrm;
	zval *zaversion;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Olllllzl", &ostrm, TZStreamRec_ce_ptr, &l4level, &l4method, &l4windowBits, &l4memLevel, &l4strategy, &zaversion, &l4recsize) == SUCCESS) && PZVAL_IS_REF(ostrm) && ((IS_STRING == Z_TYPE_P(zaversion)) || (IS_ARRAY == Z_TYPE_P(zaversion)) || (IS_NULL == Z_TYPE_P(zaversion))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaversion, &aiversion TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBZCompressUnit_deflateInit2_((TZStreamRec *)SBGetStructPointer(ostrm TSRMLS_CC), (int32_t)l4level, (int32_t)l4method, (int32_t)l4windowBits, (int32_t)l4memLevel, (int32_t)l4strategy, aiversion.data, aiversion.len, (int32_t)l4recsize, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiversion);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&TZStreamRec, integer, integer, integer, integer, integer, array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBZCompressUnit, deflateEnd)
{
	zval *ostrm;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &ostrm, TZStreamRec_ce_ptr) == SUCCESS) && PZVAL_IS_REF(ostrm))
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBZCompressUnit_deflateEnd((TZStreamRec *)SBGetStructPointer(ostrm TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&TZStreamRec)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBZCompressUnit, deflate)
{
	long l4flush;
	zval *ostrm;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ol", &ostrm, TZStreamRec_ce_ptr, &l4flush) == SUCCESS) && PZVAL_IS_REF(ostrm))
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBZCompressUnit_deflate((TZStreamRec *)SBGetStructPointer(ostrm TSRMLS_CC), (int32_t)l4flush, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&TZStreamRec, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBZCompressUnit, deflateReset)
{
	zval *ostrm;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &ostrm, TZStreamRec_ce_ptr) == SUCCESS) && PZVAL_IS_REF(ostrm))
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBZCompressUnit_deflateReset((TZStreamRec *)SBGetStructPointer(ostrm TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&TZStreamRec)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBZCompressUnit, CompressBuf)
{
	int32_t l4OutBytesRaw = 0;
	long l4InBytes;
	SBArrayZValInfo piInBuf;
	SBArrayZValInfo piOutBuf;
	zval *zl4OutBytes;
	zval *zpInBuf;
	zval *zpOutBuf;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzz", &zpInBuf, &l4InBytes, &zpOutBuf, &zl4OutBytes) == SUCCESS) && ((Z_TYPE_P(zpInBuf) == IS_STRING) || (Z_TYPE_P(zpInBuf) == IS_ARRAY) || (Z_TYPE_P(zpInBuf) == IS_NULL) || ((Z_TYPE_P(zpInBuf) == IS_OBJECT) && (Z_OBJCE_P(zpInBuf) == TSBPointer_ce_ptr))) && (Z_TYPE_P(zpOutBuf) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuf) == TSBPointer_ce_ptr) && PZVAL_IS_REF(zl4OutBytes) && (IS_LONG == Z_TYPE_P(zl4OutBytes)))
	{
		if (!SBGetPointerFromZVal(zpInBuf, &piInBuf TSRMLS_CC)) RETURN_FALSE;
		SBInitPointerZValInfo(zpOutBuf, &piOutBuf TSRMLS_CC);
		SBCheckError(SBZCompressUnit_CompressBuf(piInBuf.data, (int32_t)l4InBytes, &piOutBuf.data, &l4OutBytesRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuf);
		SBSetPointerToZVal(&piOutBuf, zpOutBuf);
		ZVAL_LONG(zl4OutBytes, (long)l4OutBytesRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer, &integer)" TSRMLS_CC);
	}
}

void Register_SBZCompressUnit_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBZCompressUnit, Z_BINARY, SB_Z_BINARY, SB_Z_BINARY);
	SB_REGISTER_LONG_CONSTANT(SBZCompressUnit, Z_TEXT, SB_Z_TEXT, SB_Z_TEXT);
	SB_REGISTER_LONG_CONSTANT(SBZCompressUnit, Z_ASCII, SB_Z_ASCII, SB_Z_ASCII);
	SB_REGISTER_LONG_CONSTANT(SBZCompressUnit, Z_UNKNOWN, SB_Z_UNKNOWN, SB_Z_UNKNOWN);
	SB_REGISTER_LONG_CONSTANT(SBZCompressUnit, MAX_MEM_LEVEL, SB_MAX_MEM_LEVEL, SB_MAX_MEM_LEVEL);
	SB_REGISTER_LONG_CONSTANT(SBZCompressUnit, DEF_MEM_LEVEL, SB_DEF_MEM_LEVEL, SB_DEF_MEM_LEVEL);
	SB_REGISTER_LONG_CONSTANT(SBZCompressUnit, Z_NO_COMPRESSION, SB_Z_NO_COMPRESSION, SB_Z_NO_COMPRESSION);
	SB_REGISTER_LONG_CONSTANT(SBZCompressUnit, Z_BEST_SPEED, SB_Z_BEST_SPEED, SB_Z_BEST_SPEED);
	SB_REGISTER_LONG_CONSTANT(SBZCompressUnit, Z_BEST_COMPRESSION, SB_Z_BEST_COMPRESSION, SB_Z_BEST_COMPRESSION);
	SB_REGISTER_LONG_CONSTANT(SBZCompressUnit, Z_DEFAULT_COMPRESSION, SB_Z_DEFAULT_COMPRESSION, SB_Z_DEFAULT_COMPRESSION);
	SB_REGISTER_LONG_CONSTANT(SBZCompressUnit, Z_FILTERED, SB_Z_FILTERED, SB_Z_FILTERED);
	SB_REGISTER_LONG_CONSTANT(SBZCompressUnit, Z_DEFAULT_STRATEGY, SB_Z_DEFAULT_STRATEGY, SB_Z_DEFAULT_STRATEGY);
	SB_REGISTER_LONG_CONSTANT(SBZCompressUnit, Z_HUFFMAN_ONLY, SB_Z_HUFFMAN_ONLY, SB_Z_HUFFMAN_ONLY);
	SB_REGISTER_LONG_CONSTANT(SBZCompressUnit, need_more, SB_need_more, SB_need_more);
	SB_REGISTER_LONG_CONSTANT(SBZCompressUnit, block_done, SB_block_done, SB_block_done);
	SB_REGISTER_LONG_CONSTANT(SBZCompressUnit, finish_started, SB_finish_started, SB_finish_started);
	SB_REGISTER_LONG_CONSTANT(SBZCompressUnit, finish_done, SB_finish_done, SB_finish_done);
	SB_REGISTER_LONG_CONSTANT(SBZCompressUnit, Buf_size, SB_Buf_size, SB_Buf_size);
	SB_REGISTER_LONG_CONSTANT(SBZCompressUnit, MIN_MATCH, SB_MIN_MATCH, SB_MIN_MATCH);
	SB_REGISTER_LONG_CONSTANT(SBZCompressUnit, MAX_MATCH, SB_MAX_MATCH, SB_MAX_MATCH);
	SB_REGISTER_LONG_CONSTANT(SBZCompressUnit, DIST_CODE_LEN, SB_DIST_CODE_LEN, SB_DIST_CODE_LEN);
	SB_REGISTER_LONG_CONSTANT(SBZCompressUnit, END_BLOCK, SB_END_BLOCK, SB_END_BLOCK);
	SB_REGISTER_LONG_CONSTANT(SBZCompressUnit, MAX_BL_BITS, SB_MAX_BL_BITS, SB_MAX_BL_BITS);
	SB_REGISTER_LONG_CONSTANT(SBZCompressUnit, TOO_FAR, SB_TOO_FAR, SB_TOO_FAR);
}

void Register_SBZCompressUnit_Aliases(TSRMLS_D)
{
	if (NULL == config_s_ce_ptr)
		Register_config_s(TSRMLS_C);
	zend_register_class_alias("config", config_s_ce_ptr);
}

