#ifndef __INC_CSISO_8859_8I
#define __INC_CSISO_8859_8I

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbchsconvbase.h"
#include "csiso_8859_8.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
typedef TElClassHandle TPlISO_8859_8iHandle;

#ifdef SB_USE_CLASS_TPLISO_8859_8I
SB_IMPORT uint32_t SB_APIENTRY TPlISO_8859_8i_GetCategory(TPlISO_8859_8iHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TPlISO_8859_8i_GetDescription(TPlISO_8859_8iHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TPlISO_8859_8i_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TPlISO_8859_8i_Create(TPlTableCharsetHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TPlISO_8859_8i_CreateForFinalize(TPlTableCharsetHandle * OutResult);
#endif /* SB_USE_CLASS_TPLISO_8859_8I */

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TPlISO_8859_8i_ce_ptr;

void Register_TPlISO_8859_8i(TSRMLS_D);

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_CSISO_8859_8I */

