#ifndef __INC_CSMACCROATIAN
#define __INC_CSMACCROATIAN

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbchsconvbase.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
typedef TElClassHandle TPlMacCroatianHandle;

#ifdef SB_USE_CLASS_TPLMACCROATIAN
SB_IMPORT uint32_t SB_APIENTRY TPlMacCroatian_GetCategory(TPlMacCroatianHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TPlMacCroatian_GetDescription(TPlMacCroatianHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TPlMacCroatian_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TPlMacCroatian_Create(TPlTableCharsetHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TPlMacCroatian_CreateForFinalize(TPlTableCharsetHandle * OutResult);
#endif /* SB_USE_CLASS_TPLMACCROATIAN */

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TPlMacCroatian_ce_ptr;

void Register_TPlMacCroatian(TSRMLS_D);

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_CSMACCROATIAN */

