#include "sbdefs.h"

#ifdef MACOS
#include "sbapplecommon.h"

SB_PHP_METHOD(__SB_CFError, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(__SB_CFError));
		intern->len = sizeof(__SB_CFError);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(__SB_CFError, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(__SB_CFError));
}

zend_class_entry *__SB_CFError_ce_ptr = NULL;

static zend_function_entry __SB_CFError_methods[] = {
	PHP_ME(__SB_CFError, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(__SB_CFError, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register___SB_CFError(TSRMLS_D)
{
	zend_class_entry ce;
	if (__SB_CFError_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "__SB_CFError", __SB_CFError_methods);
	__SB_CFError_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(__SB_CFNull, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(__SB_CFNull));
		intern->len = sizeof(__SB_CFNull);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(__SB_CFNull, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(__SB_CFNull));
}

zend_class_entry *__SB_CFNull_ce_ptr = NULL;

static zend_function_entry __SB_CFNull_methods[] = {
	PHP_ME(__SB_CFNull, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(__SB_CFNull, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register___SB_CFNull(TSRMLS_D)
{
	zend_class_entry ce;
	if (__SB_CFNull_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "__SB_CFNull", __SB_CFNull_methods);
	__SB_CFNull_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(__SB_CFArray, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(__SB_CFArray));
		intern->len = sizeof(__SB_CFArray);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(__SB_CFArray, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(__SB_CFArray));
}

zend_class_entry *__SB_CFArray_ce_ptr = NULL;

static zend_function_entry __SB_CFArray_methods[] = {
	PHP_ME(__SB_CFArray, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(__SB_CFArray, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register___SB_CFArray(TSRMLS_D)
{
	zend_class_entry ce;
	if (__SB_CFArray_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "__SB_CFArray", __SB_CFArray_methods);
	__SB_CFArray_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(__SB_CFDictionary, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(__SB_CFDictionary));
		intern->len = sizeof(__SB_CFDictionary);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(__SB_CFDictionary, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(__SB_CFDictionary));
}

zend_class_entry *__SB_CFDictionary_ce_ptr = NULL;

static zend_function_entry __SB_CFDictionary_methods[] = {
	PHP_ME(__SB_CFDictionary, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(__SB_CFDictionary, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register___SB_CFDictionary(TSRMLS_D)
{
	zend_class_entry ce;
	if (__SB_CFDictionary_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "__SB_CFDictionary", __SB_CFDictionary_methods);
	__SB_CFDictionary_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(__SB_CFBoolean, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(__SB_CFBoolean));
		intern->len = sizeof(__SB_CFBoolean);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(__SB_CFBoolean, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(__SB_CFBoolean));
}

zend_class_entry *__SB_CFBoolean_ce_ptr = NULL;

static zend_function_entry __SB_CFBoolean_methods[] = {
	PHP_ME(__SB_CFBoolean, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(__SB_CFBoolean, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register___SB_CFBoolean(TSRMLS_D)
{
	zend_class_entry ce;
	if (__SB_CFBoolean_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "__SB_CFBoolean", __SB_CFBoolean_methods);
	__SB_CFBoolean_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(__SB_CFAllocator, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(__SB_CFAllocator));
		intern->len = sizeof(__SB_CFAllocator);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(__SB_CFAllocator, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(__SB_CFAllocator));
}

zend_class_entry *__SB_CFAllocator_ce_ptr = NULL;

static zend_function_entry __SB_CFAllocator_methods[] = {
	PHP_ME(__SB_CFAllocator, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(__SB_CFAllocator, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register___SB_CFAllocator(TSRMLS_D)
{
	zend_class_entry ce;
	if (__SB_CFAllocator_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "__SB_CFAllocator", __SB_CFAllocator_methods);
	__SB_CFAllocator_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(__SB_CFString, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(__SB_CFString));
		intern->len = sizeof(__SB_CFString);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(__SB_CFString, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(__SB_CFString));
}

zend_class_entry *__SB_CFString_ce_ptr = NULL;

static zend_function_entry __SB_CFString_methods[] = {
	PHP_ME(__SB_CFString, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(__SB_CFString, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register___SB_CFString(TSRMLS_D)
{
	zend_class_entry ce;
	if (__SB_CFString_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "__SB_CFString", __SB_CFString_methods);
	__SB_CFString_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(__SB_CFData, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(__SB_CFData));
		intern->len = sizeof(__SB_CFData);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(__SB_CFData, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(__SB_CFData));
}

zend_class_entry *__SB_CFData_ce_ptr = NULL;

static zend_function_entry __SB_CFData_methods[] = {
	PHP_ME(__SB_CFData, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(__SB_CFData, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register___SB_CFData(TSRMLS_D)
{
	zend_class_entry ce;
	if (__SB_CFData_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "__SB_CFData", __SB_CFData_methods);
	__SB_CFData_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SB_CFRange, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SB_CFRange));
		intern->len = sizeof(SB_CFRange);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SB_CFRange, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SB_CFRange));
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(SB_CFRange, get_location)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SB_CFRange, set_location)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SB_CFRange, get_length)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(SB_CFRange, set_length)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

zend_class_entry *SB_CFRange_ce_ptr = NULL;

static zend_function_entry SB_CFRange_methods[] = {
	PHP_ME(SB_CFRange, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SB_CFRange, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SB_CFRange, get_location, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SB_CFRange, set_location, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SB_CFRange, get_length, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SB_CFRange, set_length, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SB_CFRange(TSRMLS_D)
{
	zend_class_entry ce;
	if (SB_CFRange_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SB_CFRange", SB_CFRange_methods);
	SB_CFRange_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *SB_CFComparisionResult_ce_ptr = NULL;

zend_class_entry *SB_CFStringCompareFlags_ce_ptr = NULL;

zend_class_entry *SB_CFStringEncoding_ce_ptr = NULL;

SB_PHP_METHOD(SB_CFDictionaryKeyCallBacks, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SB_CFDictionaryKeyCallBacks));
		intern->len = sizeof(SB_CFDictionaryKeyCallBacks);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SB_CFDictionaryKeyCallBacks, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SB_CFDictionaryKeyCallBacks));
}

SB_PHP_METHOD(SB_CFDictionaryKeyCallBacks, get_version)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SB_CFDictionaryKeyCallBacks, set_version)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

zend_class_entry *SB_CFDictionaryKeyCallBacks_ce_ptr = NULL;

static zend_function_entry SB_CFDictionaryKeyCallBacks_methods[] = {
	PHP_ME(SB_CFDictionaryKeyCallBacks, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SB_CFDictionaryKeyCallBacks, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SB_CFDictionaryKeyCallBacks, get_version, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SB_CFDictionaryKeyCallBacks, set_version, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SB_CFDictionaryKeyCallBacks(TSRMLS_D)
{
	zend_class_entry ce;
	if (SB_CFDictionaryKeyCallBacks_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SB_CFDictionaryKeyCallBacks", SB_CFDictionaryKeyCallBacks_methods);
	SB_CFDictionaryKeyCallBacks_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SB_CFDictionaryValueCallBacks, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SB_CFDictionaryValueCallBacks));
		intern->len = sizeof(SB_CFDictionaryValueCallBacks);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SB_CFDictionaryValueCallBacks, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SB_CFDictionaryValueCallBacks));
}

SB_PHP_METHOD(SB_CFDictionaryValueCallBacks, get_version)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SB_CFDictionaryValueCallBacks, set_version)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

zend_class_entry *SB_CFDictionaryValueCallBacks_ce_ptr = NULL;

static zend_function_entry SB_CFDictionaryValueCallBacks_methods[] = {
	PHP_ME(SB_CFDictionaryValueCallBacks, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SB_CFDictionaryValueCallBacks, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SB_CFDictionaryValueCallBacks, get_version, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SB_CFDictionaryValueCallBacks, set_version, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SB_CFDictionaryValueCallBacks(TSRMLS_D)
{
	zend_class_entry ce;
	if (SB_CFDictionaryValueCallBacks_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SB_CFDictionaryValueCallBacks", SB_CFDictionaryValueCallBacks_methods);
	SB_CFDictionaryValueCallBacks_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SB_CFArrayCallBacks, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SB_CFArrayCallBacks));
		intern->len = sizeof(SB_CFArrayCallBacks);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SB_CFArrayCallBacks, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SB_CFArrayCallBacks));
}

SB_PHP_METHOD(SB_CFArrayCallBacks, get_version)
{
	SBStuctGetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SB_CFArrayCallBacks, set_version)
{
	SBStuctSetFieldInt64(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

zend_class_entry *SB_CFArrayCallBacks_ce_ptr = NULL;

static zend_function_entry SB_CFArrayCallBacks_methods[] = {
	PHP_ME(SB_CFArrayCallBacks, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SB_CFArrayCallBacks, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SB_CFArrayCallBacks, get_version, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SB_CFArrayCallBacks, set_version, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SB_CFArrayCallBacks(TSRMLS_D)
{
	zend_class_entry ce;
	if (SB_CFArrayCallBacks_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SB_CFArrayCallBacks", SB_CFArrayCallBacks_methods);
	SB_CFArrayCallBacks_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *SB_SecKeychainStatus_ce_ptr = NULL;

zend_class_entry *SB_SecExternalFormat_ce_ptr = NULL;

zend_class_entry *SB_SecExternalItemType_ce_ptr = NULL;

zend_class_entry *SB_SecItemImportExportFlags_ce_ptr = NULL;

zend_class_entry *SB_SecKeyImportExportFlags_ce_ptr = NULL;

SB_PHP_METHOD(SB_OpaqueSecKeychainRef, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SB_OpaqueSecKeychainRef));
		intern->len = sizeof(SB_OpaqueSecKeychainRef);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SB_OpaqueSecKeychainRef, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SB_OpaqueSecKeychainRef));
}

zend_class_entry *SB_OpaqueSecKeychainRef_ce_ptr = NULL;

static zend_function_entry SB_OpaqueSecKeychainRef_methods[] = {
	PHP_ME(SB_OpaqueSecKeychainRef, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SB_OpaqueSecKeychainRef, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_SB_OpaqueSecKeychainRef(TSRMLS_D)
{
	zend_class_entry ce;
	if (SB_OpaqueSecKeychainRef_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SB_OpaqueSecKeychainRef", SB_OpaqueSecKeychainRef_methods);
	SB_OpaqueSecKeychainRef_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SB_OpaqueSecAccessRef, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SB_OpaqueSecAccessRef));
		intern->len = sizeof(SB_OpaqueSecAccessRef);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SB_OpaqueSecAccessRef, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SB_OpaqueSecAccessRef));
}

zend_class_entry *SB_OpaqueSecAccessRef_ce_ptr = NULL;

static zend_function_entry SB_OpaqueSecAccessRef_methods[] = {
	PHP_ME(SB_OpaqueSecAccessRef, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SB_OpaqueSecAccessRef, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_SB_OpaqueSecAccessRef(TSRMLS_D)
{
	zend_class_entry ce;
	if (SB_OpaqueSecAccessRef_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SB_OpaqueSecAccessRef", SB_OpaqueSecAccessRef_methods);
	SB_OpaqueSecAccessRef_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SB_OpaqueSecKeychainItemRef, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SB_OpaqueSecKeychainItemRef));
		intern->len = sizeof(SB_OpaqueSecKeychainItemRef);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SB_OpaqueSecKeychainItemRef, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SB_OpaqueSecKeychainItemRef));
}

zend_class_entry *SB_OpaqueSecKeychainItemRef_ce_ptr = NULL;

static zend_function_entry SB_OpaqueSecKeychainItemRef_methods[] = {
	PHP_ME(SB_OpaqueSecKeychainItemRef, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SB_OpaqueSecKeychainItemRef, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_SB_OpaqueSecKeychainItemRef(TSRMLS_D)
{
	zend_class_entry ce;
	if (SB_OpaqueSecKeychainItemRef_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SB_OpaqueSecKeychainItemRef", SB_OpaqueSecKeychainItemRef_methods);
	SB_OpaqueSecKeychainItemRef_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SB_SecItemImportExportKeyParameters, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SB_SecItemImportExportKeyParameters));
		intern->len = sizeof(SB_SecItemImportExportKeyParameters);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SB_SecItemImportExportKeyParameters, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SB_SecItemImportExportKeyParameters));
}

SB_PHP_METHOD(SB_SecItemImportExportKeyParameters, get_version)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SB_SecItemImportExportKeyParameters, set_version)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SB_SecItemImportExportKeyParameters, get_flags)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SB_SecItemImportExportKeyParameters, set_flags)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

zend_class_entry *SB_SecItemImportExportKeyParameters_ce_ptr = NULL;

static zend_function_entry SB_SecItemImportExportKeyParameters_methods[] = {
	PHP_ME(SB_SecItemImportExportKeyParameters, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SB_SecItemImportExportKeyParameters, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SB_SecItemImportExportKeyParameters, get_version, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SB_SecItemImportExportKeyParameters, set_version, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SB_SecItemImportExportKeyParameters, get_flags, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SB_SecItemImportExportKeyParameters, set_flags, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SB_SecItemImportExportKeyParameters(TSRMLS_D)
{
	zend_class_entry ce;
	if (SB_SecItemImportExportKeyParameters_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SB_SecItemImportExportKeyParameters", SB_SecItemImportExportKeyParameters_methods);
	SB_SecItemImportExportKeyParameters_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *SB_SecItemClass_ce_ptr = NULL;

zend_class_entry *SB_SecItemAttr_ce_ptr = NULL;

SB_PHP_METHOD(SB_SecKeychainAttribute, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SB_SecKeychainAttribute));
		intern->len = sizeof(SB_SecKeychainAttribute);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SB_SecKeychainAttribute, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SB_SecKeychainAttribute));
}

SB_PHP_METHOD(SB_SecKeychainAttribute, get_length)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SB_SecKeychainAttribute, set_length)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

zend_class_entry *SB_SecKeychainAttribute_ce_ptr = NULL;

static zend_function_entry SB_SecKeychainAttribute_methods[] = {
	PHP_ME(SB_SecKeychainAttribute, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SB_SecKeychainAttribute, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SB_SecKeychainAttribute, get_length, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SB_SecKeychainAttribute, set_length, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SB_SecKeychainAttribute(TSRMLS_D)
{
	zend_class_entry ce;
	if (SB_SecKeychainAttribute_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SB_SecKeychainAttribute", SB_SecKeychainAttribute_methods);
	SB_SecKeychainAttribute_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SB_SecKeychainAttributeList, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SB_SecKeychainAttributeList));
		intern->len = sizeof(SB_SecKeychainAttributeList);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SB_SecKeychainAttributeList, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SB_SecKeychainAttributeList));
}

SB_PHP_METHOD(SB_SecKeychainAttributeList, get_count)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SB_SecKeychainAttributeList, set_count)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

zend_class_entry *SB_SecKeychainAttributeList_ce_ptr = NULL;

static zend_function_entry SB_SecKeychainAttributeList_methods[] = {
	PHP_ME(SB_SecKeychainAttributeList, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SB_SecKeychainAttributeList, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SB_SecKeychainAttributeList, get_count, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SB_SecKeychainAttributeList, set_count, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SB_SecKeychainAttributeList(TSRMLS_D)
{
	zend_class_entry ce;
	if (SB_SecKeychainAttributeList_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SB_SecKeychainAttributeList", SB_SecKeychainAttributeList_methods);
	SB_SecKeychainAttributeList_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *SB_AuthorizationFlags_ce_ptr = NULL;

SB_PHP_METHOD(SB_AuthorizationOpaqueRef, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SB_AuthorizationOpaqueRef));
		intern->len = sizeof(SB_AuthorizationOpaqueRef);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SB_AuthorizationOpaqueRef, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SB_AuthorizationOpaqueRef));
}

zend_class_entry *SB_AuthorizationOpaqueRef_ce_ptr = NULL;

static zend_function_entry SB_AuthorizationOpaqueRef_methods[] = {
	PHP_ME(SB_AuthorizationOpaqueRef, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SB_AuthorizationOpaqueRef, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_SB_AuthorizationOpaqueRef(TSRMLS_D)
{
	zend_class_entry ce;
	if (SB_AuthorizationOpaqueRef_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SB_AuthorizationOpaqueRef", SB_AuthorizationOpaqueRef_methods);
	SB_AuthorizationOpaqueRef_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SB_AuthorizationItem, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SB_AuthorizationItem));
		intern->len = sizeof(SB_AuthorizationItem);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SB_AuthorizationItem, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SB_AuthorizationItem));
}

SB_PHP_METHOD(SB_AuthorizationItem, get_valueLength)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SB_AuthorizationItem, set_valueLength)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(SB_AuthorizationItem, get_flags)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(SB_AuthorizationItem, set_flags)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

zend_class_entry *SB_AuthorizationItem_ce_ptr = NULL;

static zend_function_entry SB_AuthorizationItem_methods[] = {
	PHP_ME(SB_AuthorizationItem, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SB_AuthorizationItem, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SB_AuthorizationItem, get_valueLength, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SB_AuthorizationItem, set_valueLength, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(SB_AuthorizationItem, get_flags, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SB_AuthorizationItem, set_flags, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SB_AuthorizationItem(TSRMLS_D)
{
	zend_class_entry ce;
	if (SB_AuthorizationItem_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SB_AuthorizationItem", SB_AuthorizationItem_methods);
	SB_AuthorizationItem_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SB_AuthorizationItemSet, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SB_AuthorizationItemSet));
		intern->len = sizeof(SB_AuthorizationItemSet);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SB_AuthorizationItemSet, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SB_AuthorizationItemSet));
}

SB_PHP_METHOD(SB_AuthorizationItemSet, get_count)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(SB_AuthorizationItemSet, set_count)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

zend_class_entry *SB_AuthorizationItemSet_ce_ptr = NULL;

static zend_function_entry SB_AuthorizationItemSet_methods[] = {
	PHP_ME(SB_AuthorizationItemSet, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SB_AuthorizationItemSet, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(SB_AuthorizationItemSet, get_count, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(SB_AuthorizationItemSet, set_count, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_SB_AuthorizationItemSet(TSRMLS_D)
{
	zend_class_entry ce;
	if (SB_AuthorizationItemSet_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SB_AuthorizationItemSet", SB_AuthorizationItemSet_methods);
	SB_AuthorizationItemSet_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *SB_SecTrustSettingsDomain_ce_ptr = NULL;

SB_PHP_METHOD(__SB_SecTrust, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(__SB_SecTrust));
		intern->len = sizeof(__SB_SecTrust);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(__SB_SecTrust, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(__SB_SecTrust));
}

zend_class_entry *__SB_SecTrust_ce_ptr = NULL;

static zend_function_entry __SB_SecTrust_methods[] = {
	PHP_ME(__SB_SecTrust, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(__SB_SecTrust, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register___SB_SecTrust(TSRMLS_D)
{
	zend_class_entry ce;
	if (__SB_SecTrust_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "__SB_SecTrust", __SB_SecTrust_methods);
	__SB_SecTrust_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *SB_SecTrustResultType_ce_ptr = NULL;

SB_PHP_METHOD(SB_OpaqueSecCertificateRef, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SB_OpaqueSecCertificateRef));
		intern->len = sizeof(SB_OpaqueSecCertificateRef);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SB_OpaqueSecCertificateRef, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SB_OpaqueSecCertificateRef));
}

zend_class_entry *SB_OpaqueSecCertificateRef_ce_ptr = NULL;

static zend_function_entry SB_OpaqueSecCertificateRef_methods[] = {
	PHP_ME(SB_OpaqueSecCertificateRef, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SB_OpaqueSecCertificateRef, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_SB_OpaqueSecCertificateRef(TSRMLS_D)
{
	zend_class_entry ce;
	if (SB_OpaqueSecCertificateRef_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SB_OpaqueSecCertificateRef", SB_OpaqueSecCertificateRef_methods);
	SB_OpaqueSecCertificateRef_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SB_OpaqueSecIdentityRef, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SB_OpaqueSecIdentityRef));
		intern->len = sizeof(SB_OpaqueSecIdentityRef);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SB_OpaqueSecIdentityRef, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SB_OpaqueSecIdentityRef));
}

zend_class_entry *SB_OpaqueSecIdentityRef_ce_ptr = NULL;

static zend_function_entry SB_OpaqueSecIdentityRef_methods[] = {
	PHP_ME(SB_OpaqueSecIdentityRef, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SB_OpaqueSecIdentityRef, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_SB_OpaqueSecIdentityRef(TSRMLS_D)
{
	zend_class_entry ce;
	if (SB_OpaqueSecIdentityRef_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SB_OpaqueSecIdentityRef", SB_OpaqueSecIdentityRef_methods);
	SB_OpaqueSecIdentityRef_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SB_OpaqueSecKeyRef, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SB_OpaqueSecKeyRef));
		intern->len = sizeof(SB_OpaqueSecKeyRef);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SB_OpaqueSecKeyRef, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SB_OpaqueSecKeyRef));
}

zend_class_entry *SB_OpaqueSecKeyRef_ce_ptr = NULL;

static zend_function_entry SB_OpaqueSecKeyRef_methods[] = {
	PHP_ME(SB_OpaqueSecKeyRef, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SB_OpaqueSecKeyRef, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_SB_OpaqueSecKeyRef(TSRMLS_D)
{
	zend_class_entry ce;
	if (SB_OpaqueSecKeyRef_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SB_OpaqueSecKeyRef", SB_OpaqueSecKeyRef_methods);
	SB_OpaqueSecKeyRef_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(SB_OpaqueSecPolicyRef, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(SB_OpaqueSecPolicyRef));
		intern->len = sizeof(SB_OpaqueSecPolicyRef);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(SB_OpaqueSecPolicyRef, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(SB_OpaqueSecPolicyRef));
}

zend_class_entry *SB_OpaqueSecPolicyRef_ce_ptr = NULL;

static zend_function_entry SB_OpaqueSecPolicyRef_methods[] = {
	PHP_ME(SB_OpaqueSecPolicyRef, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(SB_OpaqueSecPolicyRef, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_SB_OpaqueSecPolicyRef(TSRMLS_D)
{
	zend_class_entry ce;
	if (SB_OpaqueSecPolicyRef_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "SB_OpaqueSecPolicyRef", SB_OpaqueSecPolicyRef_methods);
	SB_OpaqueSecPolicyRef_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBAppleCommon_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_NULL_CONSTANT(SBAppleCommon, SB_kAuthorizationEmptyEnvironment, SB_kAuthorizationEmptyEnvironment);
}

void Register_SBAppleCommon_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "SB_CFComparisionResult", NULL);
	SB_CFComparisionResult_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	SB_CFComparisionResult_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(SB_CFComparisionResult_ce_ptr, "SB_kCFCompareLessThan", -1)
	SB_DECLARE_CLASS_LONG_CONST(SB_CFComparisionResult_ce_ptr, "SB_kCFCompareEqualTo", 0)
	SB_DECLARE_CLASS_LONG_CONST(SB_CFComparisionResult_ce_ptr, "SB_kCFCompareGreaterThan", 1)
	
	INIT_CLASS_ENTRY(ce, "SB_CFStringCompareFlags", NULL);
	SB_CFStringCompareFlags_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	SB_CFStringCompareFlags_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(SB_CFStringCompareFlags_ce_ptr, "SB_kCFCompareCaseInsensitive", 1)
	SB_DECLARE_CLASS_LONG_CONST(SB_CFStringCompareFlags_ce_ptr, "SB_kCFCompareBackwards", 4)
	SB_DECLARE_CLASS_LONG_CONST(SB_CFStringCompareFlags_ce_ptr, "SB_kCFCompareAnchored", 8)
	SB_DECLARE_CLASS_LONG_CONST(SB_CFStringCompareFlags_ce_ptr, "SB_kCFCompareNonliteral", 16)
	SB_DECLARE_CLASS_LONG_CONST(SB_CFStringCompareFlags_ce_ptr, "SB_kCFCompareLocalized", 32)
	SB_DECLARE_CLASS_LONG_CONST(SB_CFStringCompareFlags_ce_ptr, "SB_kCFCompareNumerically", 64)
	SB_DECLARE_CLASS_LONG_CONST(SB_CFStringCompareFlags_ce_ptr, "SB_kCFCompareDiacriticInsensitive", 128)
	SB_DECLARE_CLASS_LONG_CONST(SB_CFStringCompareFlags_ce_ptr, "SB_kCFCompareWidthInsensitive", 256)
	SB_DECLARE_CLASS_LONG_CONST(SB_CFStringCompareFlags_ce_ptr, "SB_kCFCompareForcedOrdering", 512)
	
	INIT_CLASS_ENTRY(ce, "SB_CFStringEncoding", NULL);
	SB_CFStringEncoding_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	SB_CFStringEncoding_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(SB_CFStringEncoding_ce_ptr, "SB_kCFStringEncodingMacRoman", 0)
	SB_DECLARE_CLASS_LONG_CONST(SB_CFStringEncoding_ce_ptr, "SB_kCFStringEncodingWindowsLatin1", 1280)
	SB_DECLARE_CLASS_LONG_CONST(SB_CFStringEncoding_ce_ptr, "SB_kCFStringEncodingUTF16", 256)
	SB_DECLARE_CLASS_LONG_CONST(SB_CFStringEncoding_ce_ptr, "SB_kCFStringEncodingUnicode", 256)
	SB_DECLARE_CLASS_LONG_CONST(SB_CFStringEncoding_ce_ptr, "SB_kCFStringEncodingISOLatin1", 513)
	SB_DECLARE_CLASS_LONG_CONST(SB_CFStringEncoding_ce_ptr, "SB_kCFStringEncodingNextStepLatin", 2817)
	SB_DECLARE_CLASS_LONG_CONST(SB_CFStringEncoding_ce_ptr, "SB_kCFStringEncodingASCII", 1536)
	SB_DECLARE_CLASS_LONG_CONST(SB_CFStringEncoding_ce_ptr, "SB_kCFStringEncodingUTF8", 134217984)
	SB_DECLARE_CLASS_LONG_CONST(SB_CFStringEncoding_ce_ptr, "SB_kCFStringEncodingNonLossyASCII", 3071)
	SB_DECLARE_CLASS_LONG_CONST(SB_CFStringEncoding_ce_ptr, "SB_kCFStringEncodingUTF16BE", 268435712)
	SB_DECLARE_CLASS_LONG_CONST(SB_CFStringEncoding_ce_ptr, "SB_kCFStringEncodingUTF32", 201326848)
	SB_DECLARE_CLASS_LONG_CONST(SB_CFStringEncoding_ce_ptr, "SB_kCFStringEncodingUTF16LE", 335544576)
	SB_DECLARE_CLASS_LONG_CONST(SB_CFStringEncoding_ce_ptr, "SB_kCFStringEncodingUTF32BE", 402653440)
	SB_DECLARE_CLASS_LONG_CONST(SB_CFStringEncoding_ce_ptr, "SB_kCFStringEncodingUTF32LE", 469762304)
	
	INIT_CLASS_ENTRY(ce, "SB_SecKeychainStatus", NULL);
	SB_SecKeychainStatus_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	SB_SecKeychainStatus_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(SB_SecKeychainStatus_ce_ptr, "SB_kSecUnlockStateStatus", 1)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecKeychainStatus_ce_ptr, "SB_kSecReadPermStatus", 2)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecKeychainStatus_ce_ptr, "SB_UnlockReadPermStatus", 3)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecKeychainStatus_ce_ptr, "SB_kSecWritePermStatus", 4)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecKeychainStatus_ce_ptr, "SB_UnlockWritePermStatus", 5)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecKeychainStatus_ce_ptr, "SB_ReadWritePermStatus", 6)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecKeychainStatus_ce_ptr, "SB_UnlockReadWritePermStatus", 7)
	
	INIT_CLASS_ENTRY(ce, "SB_SecExternalFormat", NULL);
	SB_SecExternalFormat_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	SB_SecExternalFormat_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(SB_SecExternalFormat_ce_ptr, "SB_kSecFormatUnknown", 0)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecExternalFormat_ce_ptr, "SB_kSecFormatOpenSSL", 1)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecExternalFormat_ce_ptr, "SB_kSecFormatSSH", 2)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecExternalFormat_ce_ptr, "SB_kSecFormatBSAFE", 3)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecExternalFormat_ce_ptr, "SB_kSecFormatRawKey", 4)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecExternalFormat_ce_ptr, "SB_kSecFormatWrappedPKCS8", 5)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecExternalFormat_ce_ptr, "SB_kSecFormatWrappedOpenSSL", 6)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecExternalFormat_ce_ptr, "SB_kSecFormatWrappedSSH", 7)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecExternalFormat_ce_ptr, "SB_kSecFormatWrappedLSH", 8)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecExternalFormat_ce_ptr, "SB_kSecFormatX509Cert", 9)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecExternalFormat_ce_ptr, "SB_kSecFormatPEMSequence", 10)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecExternalFormat_ce_ptr, "SB_kSecFormatPKCS7", 11)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecExternalFormat_ce_ptr, "SB_kSecFormatPKCS12", 12)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecExternalFormat_ce_ptr, "SB_kSecFormatNetscapeCertSequence", 13)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecExternalFormat_ce_ptr, "SB_kSecFormatSSHv2", 14)
	
	INIT_CLASS_ENTRY(ce, "SB_SecExternalItemType", NULL);
	SB_SecExternalItemType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	SB_SecExternalItemType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(SB_SecExternalItemType_ce_ptr, "SB_kSecItemTypeUnknown", 0)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecExternalItemType_ce_ptr, "SB_kSecItemTypePrivateKey", 1)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecExternalItemType_ce_ptr, "SB_kSecItemTypePublicKey", 2)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecExternalItemType_ce_ptr, "SB_kSecItemTypeSessionKey", 3)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecExternalItemType_ce_ptr, "SB_kSecItemTypeCertificate", 4)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecExternalItemType_ce_ptr, "SB_kSecItemTypeAggregate", 5)
	
	INIT_CLASS_ENTRY(ce, "SB_SecItemImportExportFlags", NULL);
	SB_SecItemImportExportFlags_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	SB_SecItemImportExportFlags_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(SB_SecItemImportExportFlags_ce_ptr, "SB_kSecItemPemArmour", 1)
	
	INIT_CLASS_ENTRY(ce, "SB_SecKeyImportExportFlags", NULL);
	SB_SecKeyImportExportFlags_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	SB_SecKeyImportExportFlags_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(SB_SecKeyImportExportFlags_ce_ptr, "SB_kSecKeyImportOnlyOne", 1)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecKeyImportExportFlags_ce_ptr, "SB_kSecKeySecurePassphrase", 2)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecKeyImportExportFlags_ce_ptr, "SB_kSecKeyNoAccessControl", 4)
	
	INIT_CLASS_ENTRY(ce, "SB_SecItemClass", NULL);
	SB_SecItemClass_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	SB_SecItemClass_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(SB_SecItemClass_ce_ptr, "SB_kSecCertificateItemClass", -2147479552)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecItemClass_ce_ptr, "SB_kSecGenericPasswordItemClass", 1734700656)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecItemClass_ce_ptr, "SB_kSecSymmetricKeyItemClass", 17)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecItemClass_ce_ptr, "SB_kSecPrivateKeyItemClass", 16)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecItemClass_ce_ptr, "SB_kSecPublicKeyItemClass", 15)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecItemClass_ce_ptr, "SB_kSecInternetPasswordItemClass", 1768842612)
	
	INIT_CLASS_ENTRY(ce, "SB_SecItemAttr", NULL);
	SB_SecItemAttr_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	SB_SecItemAttr_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(SB_SecItemAttr_ce_ptr, "SB_kSecAccountItemAttr", 1633903476)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecItemAttr_ce_ptr, "SB_kSecCreationDateItemAttr", 1667522932)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecItemAttr_ce_ptr, "SB_kSecAlias", 1634494835)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecItemAttr_ce_ptr, "SB_kSecAddressItemAttr", 1633969266)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecItemAttr_ce_ptr, "SB_kSecAuthenticationTypeItemAttr", 1635023216)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecItemAttr_ce_ptr, "SB_kSecModDateItemAttr", 1835295092)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecItemAttr_ce_ptr, "SB_kSecCrlEncoding", 1668443747)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecItemAttr_ce_ptr, "SB_kSecCrlType", 1668445296)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecItemAttr_ce_ptr, "SB_kSecCertificateEncoding", 1667591779)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecItemAttr_ce_ptr, "SB_kSecCertificateType", 1668577648)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecItemAttr_ce_ptr, "SB_kSecGenericItemAttr", 1734700641)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecItemAttr_ce_ptr, "SB_kSecCustomIconItemAttr", 1668641641)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecItemAttr_ce_ptr, "SB_kSecInvisibleItemAttr", 1768846953)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecItemAttr_ce_ptr, "SB_kSecLabelItemAttr", 1818321516)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecItemAttr_ce_ptr, "SB_kSecCreatorItemAttr", 1668445298)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecItemAttr_ce_ptr, "SB_kSecCommentItemAttr", 1768123764)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecItemAttr_ce_ptr, "SB_kSecDescriptionItemAttr", 1684370275)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecItemAttr_ce_ptr, "SB_kSecTypeItemAttr", 1954115685)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecItemAttr_ce_ptr, "SB_kSecProtocolItemAttr", 1886675820)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecItemAttr_ce_ptr, "SB_kSecSignatureItemAttr", 1936943463)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecItemAttr_ce_ptr, "SB_kSecPathItemAttr", 1885434984)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecItemAttr_ce_ptr, "SB_kSecPortItemAttr", 1886351988)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecItemAttr_ce_ptr, "SB_kSecServerItemAttr", 1936881266)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecItemAttr_ce_ptr, "SB_kSecSecurityDomainItemAttr", 1935961454)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecItemAttr_ce_ptr, "SB_kSecServiceItemAttr", 1937138533)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecItemAttr_ce_ptr, "SB_kSecNegativeItemAttr", 1852139361)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecItemAttr_ce_ptr, "SB_kSecScriptCodeItemAttr", 1935897200)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecItemAttr_ce_ptr, "SB_kSecVolumeItemAttr", 1986817381)
	
	INIT_CLASS_ENTRY(ce, "SB_AuthorizationFlags", NULL);
	SB_AuthorizationFlags_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	SB_AuthorizationFlags_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(SB_AuthorizationFlags_ce_ptr, "SB_kAuthorizationFlagDefaults", 0)
	SB_DECLARE_CLASS_LONG_CONST(SB_AuthorizationFlags_ce_ptr, "SB_kAuthorizationFlagInteractionAllowed", 1)
	SB_DECLARE_CLASS_LONG_CONST(SB_AuthorizationFlags_ce_ptr, "SB_kAuthorizationFlagExtendRights", 2)
	SB_DECLARE_CLASS_LONG_CONST(SB_AuthorizationFlags_ce_ptr, "SB_kAuthorizationFlagPartialRights", 4)
	SB_DECLARE_CLASS_LONG_CONST(SB_AuthorizationFlags_ce_ptr, "SB_kAuthorizationFlagDestroyRights", 8)
	SB_DECLARE_CLASS_LONG_CONST(SB_AuthorizationFlags_ce_ptr, "SB_kAuthorizationFlagPreAuthorize", 16)
	SB_DECLARE_CLASS_LONG_CONST(SB_AuthorizationFlags_ce_ptr, "SB_kAuthorizationFlagNoData", 1048576)
	
	INIT_CLASS_ENTRY(ce, "SB_SecTrustSettingsDomain", NULL);
	SB_SecTrustSettingsDomain_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	SB_SecTrustSettingsDomain_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(SB_SecTrustSettingsDomain_ce_ptr, "SB_kSecTrustSettingsDomainUser", 0)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecTrustSettingsDomain_ce_ptr, "SB_kSecTrustSettingsDomainAdmin", 1)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecTrustSettingsDomain_ce_ptr, "SB_kSecTrustSettingsDomainSystem", 2)
	
	INIT_CLASS_ENTRY(ce, "SB_SecTrustResultType", NULL);
	SB_SecTrustResultType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	SB_SecTrustResultType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(SB_SecTrustResultType_ce_ptr, "SB_kSecTrustResultInvalid", 0)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecTrustResultType_ce_ptr, "SB_kSecTrustResultProceed", 1)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecTrustResultType_ce_ptr, "SB_kSecTrustResultDeny", 3)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecTrustResultType_ce_ptr, "SB_kSecTrustResultUnspecified", 4)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecTrustResultType_ce_ptr, "SB_kSecTrustResultRecoverableTrustFailure", 5)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecTrustResultType_ce_ptr, "SB_kSecTrustResultFatalTrustFailure", 6)
	SB_DECLARE_CLASS_LONG_CONST(SB_SecTrustResultType_ce_ptr, "SB_kSecTrustResultOtherError", 7)
}
#endif
