#include "sbbzip2common.h"

SB_PHP_FUNCTION(SBBzip2Common, BZ2_compressBlock)
{
	zend_bool bis_last_block;
	zval *os;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &os, EState_ce_ptr, &bis_last_block) == SUCCESS)
	{
		SBCheckError(SBBzip2Common_BZ2_compressBlock(SBGetObjectHandle(os TSRMLS_CC), (int8_t)bis_last_block) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(EState, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBBzip2Common, BZ2_decompress)
{
	zval *os;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &os, DState_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBBzip2Common_BZ2_decompress(SBGetObjectHandle(os TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(DState)" TSRMLS_CC);
	}
}

