#include "sbcryptoprovrs.h"

void Register_SBCryptoProvRS_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SInvalidPublicKey, SB_SInvalidPublicKey, SB_SInvalidPublicKey);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SInvalidSecretKey, SB_SInvalidSecretKey, SB_SInvalidSecretKey);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SPrimitiveOpFailed, SB_SPrimitiveOpFailed, SB_SPrimitiveOpFailed);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SUnsupportedAlgorithmInt, SB_SUnsupportedAlgorithmInt, SB_SUnsupportedAlgorithmInt);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SUnsupportedAlgorithmStr, SB_SUnsupportedAlgorithmStr, SB_SUnsupportedAlgorithmStr);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SUnsupportedPropertyStr, SB_SUnsupportedPropertyStr, SB_SUnsupportedPropertyStr);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SUnknownAlgorithmProperty, SB_SUnknownAlgorithmProperty, SB_SUnknownAlgorithmProperty);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SCryptoAPIError, SB_SCryptoAPIError, SB_SCryptoAPIError);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SUnsupportedHashAlgorithmInt, SB_SUnsupportedHashAlgorithmInt, SB_SUnsupportedHashAlgorithmInt);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SUnsupportedPropertyValue, SB_SUnsupportedPropertyValue, SB_SUnsupportedPropertyValue);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SModuleInitializationFailed, SB_SModuleInitializationFailed, SB_SModuleInitializationFailed);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SHashAlgorithmMismatch, SB_SHashAlgorithmMismatch, SB_SHashAlgorithmMismatch);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SInvalidContext, SB_SInvalidContext, SB_SInvalidContext);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SInvalidAlgorithm, SB_SInvalidAlgorithm, SB_SInvalidAlgorithm);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SCannotChangeAlgorithm, SB_SCannotChangeAlgorithm, SB_SCannotChangeAlgorithm);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SCannotChangeROProperty, SB_SCannotChangeROProperty, SB_SCannotChangeROProperty);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SNotASymmetricCipherContext, SB_SNotASymmetricCipherContext, SB_SNotASymmetricCipherContext);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SNotAHashContext, SB_SNotAHashContext, SB_SNotAHashContext);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SNotAPKIContext, SB_SNotAPKIContext, SB_SNotAPKIContext);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SNotARC4Context, SB_SNotARC4Context, SB_SNotARC4Context);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SNotAGOST89Context, SB_SNotAGOST89Context, SB_SNotAGOST89Context);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SNotAGOST2001Context, SB_SNotAGOST2001Context, SB_SNotAGOST2001Context);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SNotARSAContext, SB_SNotARSAContext, SB_SNotARSAContext);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SNotAECDSAContext, SB_SNotAECDSAContext, SB_SNotAECDSAContext);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SCannotCloneContext, SB_SCannotCloneContext, SB_SCannotCloneContext);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SUnsupportedOperation, SB_SUnsupportedOperation, SB_SUnsupportedOperation);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SUnrecognizedPadding, SB_SUnrecognizedPadding, SB_SUnrecognizedPadding);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SInternalException, SB_SInternalException, SB_SInternalException);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SInvalidKeyMaterial, SB_SInvalidKeyMaterial, SB_SInvalidKeyMaterial);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SNoIVInKeyMaterial, SB_SNoIVInKeyMaterial, SB_SNoIVInKeyMaterial);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SInvalidKeyFormat, SB_SInvalidKeyFormat, SB_SInvalidKeyFormat);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SInvalidCipherMode, SB_SInvalidCipherMode, SB_SInvalidCipherMode);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SInvalidCryptoProvider, SB_SInvalidCryptoProvider, SB_SInvalidCryptoProvider);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SCannotCompleteOperation, SB_SCannotCompleteOperation, SB_SCannotCompleteOperation);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SInterruptedByUser, SB_SInterruptedByUser, SB_SInterruptedByUser);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SUnsupportedCryptoProvider, SB_SUnsupportedCryptoProvider, SB_SUnsupportedCryptoProvider);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SPublicKeyNotFound, SB_SPublicKeyNotFound, SB_SPublicKeyNotFound);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SSecretKeyNotFound, SB_SSecretKeyNotFound, SB_SSecretKeyNotFound);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SBadKeyMaterial, SB_SBadKeyMaterial, SB_SBadKeyMaterial);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SInvalidKeyMaterialType, SB_SInvalidKeyMaterialType, SB_SInvalidKeyMaterialType);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SDecryptionFailed, SB_SDecryptionFailed, SB_SDecryptionFailed);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SKEKDerivationFailed, SB_SKEKDerivationFailed, SB_SKEKDerivationFailed);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SUnsupportedEncryptionType, SB_SUnsupportedEncryptionType, SB_SUnsupportedEncryptionType);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SOnlyDetachedSigningSupported, SB_SOnlyDetachedSigningSupported, SB_SOnlyDetachedSigningSupported);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SInputTooLong, SB_SInputTooLong, SB_SInputTooLong);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SBadSignatureFormatting, SB_SBadSignatureFormatting, SB_SBadSignatureFormatting);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SCannotModifyReadOnlyProperty, SB_SCannotModifyReadOnlyProperty, SB_SCannotModifyReadOnlyProperty);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SKeyGenerationFailed, SB_SKeyGenerationFailed, SB_SKeyGenerationFailed);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SNotASigningAlgorithm, SB_SNotASigningAlgorithm, SB_SNotASigningAlgorithm);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SFeatureNotAvailable, SB_SFeatureNotAvailable, SB_SFeatureNotAvailable);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SFailedToModifyReadonlyProperty, SB_SFailedToModifyReadonlyProperty, SB_SFailedToModifyReadonlyProperty);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SUnsupportedKeyMaterial, SB_SUnsupportedKeyMaterial, SB_SUnsupportedKeyMaterial);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SKeyPropertyNotSupported, SB_SKeyPropertyNotSupported, SB_SKeyPropertyNotSupported);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SInvalidPadding, SB_SInvalidPadding, SB_SInvalidPadding);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SKeyDecryptionFailed, SB_SKeyDecryptionFailed, SB_SKeyDecryptionFailed);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SDriverNotFound, SB_SDriverNotFound, SB_SDriverNotFound);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SUnsupportedFeature, SB_SUnsupportedFeature, SB_SUnsupportedFeature);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SCannotClonePKCS11Context, SB_SCannotClonePKCS11Context, SB_SCannotClonePKCS11Context);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SCannotCloneWin32Context, SB_SCannotCloneWin32Context, SB_SCannotCloneWin32Context);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SKeyAlreadyPrepared, SB_SKeyAlreadyPrepared, SB_SKeyAlreadyPrepared);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SFailedToExportSecretKey, SB_SFailedToExportSecretKey, SB_SFailedToExportSecretKey);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SObjectNotFound, SB_SObjectNotFound, SB_SObjectNotFound);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SBadObjectType, SB_SBadObjectType, SB_SBadObjectType);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SHandleNotFound, SB_SHandleNotFound, SB_SHandleNotFound);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SMethodNotImplemented, SB_SMethodNotImplemented, SB_SMethodNotImplemented);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SPublicKeyTooLong, SB_SPublicKeyTooLong, SB_SPublicKeyTooLong);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SInvalidECDomainParameters, SB_SInvalidECDomainParameters, SB_SInvalidECDomainParameters);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SUnknownEC, SB_SUnknownEC, SB_SUnknownEC);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SUnknownField, SB_SUnknownField, SB_SUnknownField);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SInvalidKeyProperty, SB_SInvalidKeyProperty, SB_SInvalidKeyProperty);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SOperationInitializationFailed, SB_SOperationInitializationFailed, SB_SOperationInitializationFailed);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SInstantiationFailed, SB_SInstantiationFailed, SB_SInstantiationFailed);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SInvalidPropertyValue, SB_SInvalidPropertyValue, SB_SInvalidPropertyValue);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SUnsupportedPublicKeyFormat, SB_SUnsupportedPublicKeyFormat, SB_SUnsupportedPublicKeyFormat);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SCannotUnregisterDefaultProvider, SB_SCannotUnregisterDefaultProvider, SB_SCannotUnregisterDefaultProvider);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SNoSuitableProviderInt, SB_SNoSuitableProviderInt, SB_SNoSuitableProviderInt);
	SB_REGISTER_STRING_CONSTANT(SBCryptoProvRS, SNoSuitableProviderStr, SB_SNoSuitableProviderStr, SB_SNoSuitableProviderStr);
}

