#include "sbrsa.h"

zend_class_entry *TElRSAAntiTimingParams_ce_ptr = NULL;

SB_PHP_METHOD(TElRSAAntiTimingParams, Init)
{
	SBArrayZValInfo aiRSAE;
	SBArrayZValInfo aiRSAM;
	zval *zaRSAE;
	zval *zaRSAM;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaRSAM, &zaRSAE) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaRSAM)) || (IS_ARRAY == Z_TYPE_P(zaRSAM)) || (IS_NULL == Z_TYPE_P(zaRSAM))) && ((IS_STRING == Z_TYPE_P(zaRSAE)) || (IS_ARRAY == Z_TYPE_P(zaRSAE)) || (IS_NULL == Z_TYPE_P(zaRSAE))))
	{
		if (!SBGetByteArrayFromZVal(zaRSAM, &aiRSAM TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaRSAE, &aiRSAE TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElRSAAntiTimingParams_Init(SBGetObjectHandle(getThis() TSRMLS_CC), aiRSAM.data, aiRSAM.len, aiRSAE.data, aiRSAE.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiRSAM);
		SBFreeArrayZValInfo(&aiRSAE);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAAntiTimingParams, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElRSAAntiTimingParams_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAAntiTimingParams, GetNextBlindingPair)
{
	zval *oVF;
	zval *oVI;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oVI, TLInt_ce_ptr, &oVF, TLInt_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElRSAAntiTimingParams_GetNextBlindingPair(SBGetObjectHandle(getThis() TSRMLS_CC), (TLInt *)SBGetStructPointer(oVI TSRMLS_CC), (TLInt *)SBGetStructPointer(oVF TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAAntiTimingParams, get_Initialized)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElRSAAntiTimingParams_get_Initialized(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRSAAntiTimingParams, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRSAAntiTimingParams_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAAntiTimingParams_Init, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, RSAM, 0, 1)
	ZEND_ARG_TYPE_INFO(0, RSAE, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAAntiTimingParams_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAAntiTimingParams_GetNextBlindingPair, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, VI, TLInt, 1)
	ZEND_ARG_OBJ_INFO(0, VF, TLInt, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAAntiTimingParams_get_Initialized, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRSAAntiTimingParams___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElRSAAntiTimingParams_methods[] = {
	PHP_ME(TElRSAAntiTimingParams, Init, arginfo_TElRSAAntiTimingParams_Init, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAAntiTimingParams, Reset, arginfo_TElRSAAntiTimingParams_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAAntiTimingParams, GetNextBlindingPair, arginfo_TElRSAAntiTimingParams_GetNextBlindingPair, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAAntiTimingParams, get_Initialized, arginfo_TElRSAAntiTimingParams_get_Initialized, ZEND_ACC_PUBLIC)
	PHP_ME(TElRSAAntiTimingParams, __construct, arginfo_TElRSAAntiTimingParams___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElRSAAntiTimingParams(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElRSAAntiTimingParams_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElRSAAntiTimingParams", TElRSAAntiTimingParams_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElRSAAntiTimingParams_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBRSA, ValidateSignature)
{
	long l4HashSize;
	long l4PrivateKeyBlobSize;
	long l4PublicExponentSize;
	long l4PublicModulusSize;
	long l4SignatureSize;
	SBArrayZValInfo piHash;
	SBArrayZValInfo piPrivateKeyBlob;
	SBArrayZValInfo piPublicExponent;
	SBArrayZValInfo piPublicModulus;
	SBArrayZValInfo piSignature;
	zval *zpHash;
	zval *zpPrivateKeyBlob;
	zval *zpPublicExponent;
	zval *zpPublicModulus;
	zval *zpSignature;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzlzl", &zpHash, &l4HashSize, &zpPublicModulus, &l4PublicModulusSize, &zpPublicExponent, &l4PublicExponentSize, &zpSignature, &l4SignatureSize) == SUCCESS) && ((Z_TYPE_P(zpHash) == IS_STRING) || (Z_TYPE_P(zpHash) == IS_ARRAY) || (Z_TYPE_P(zpHash) == IS_NULL) || ((Z_TYPE_P(zpHash) == IS_OBJECT) && (Z_OBJCE_P(zpHash) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpPublicModulus) == IS_STRING) || (Z_TYPE_P(zpPublicModulus) == IS_ARRAY) || (Z_TYPE_P(zpPublicModulus) == IS_NULL) || ((Z_TYPE_P(zpPublicModulus) == IS_OBJECT) && (Z_OBJCE_P(zpPublicModulus) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpPublicExponent) == IS_STRING) || (Z_TYPE_P(zpPublicExponent) == IS_ARRAY) || (Z_TYPE_P(zpPublicExponent) == IS_NULL) || ((Z_TYPE_P(zpPublicExponent) == IS_OBJECT) && (Z_OBJCE_P(zpPublicExponent) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpSignature) == IS_STRING) || (Z_TYPE_P(zpSignature) == IS_ARRAY) || (Z_TYPE_P(zpSignature) == IS_NULL) || ((Z_TYPE_P(zpSignature) == IS_OBJECT) && (Z_OBJCE_P(zpSignature) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpHash, &piHash TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpPublicModulus, &piPublicModulus TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpPublicExponent, &piPublicExponent TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpSignature, &piSignature TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBRSA_ValidateSignature(piHash.data, (int32_t)l4HashSize, piPublicModulus.data, (int32_t)l4PublicModulusSize, piPublicExponent.data, (int32_t)l4PublicExponentSize, piSignature.data, (int32_t)l4SignatureSize, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piHash);
		SBFreePointerZValInfo(&piPublicModulus);
		SBFreePointerZValInfo(&piPublicExponent);
		SBFreePointerZValInfo(&piSignature);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzl", &zpHash, &l4HashSize, &zpPrivateKeyBlob, &l4PrivateKeyBlobSize, &zpSignature, &l4SignatureSize) == SUCCESS) && ((Z_TYPE_P(zpHash) == IS_STRING) || (Z_TYPE_P(zpHash) == IS_ARRAY) || (Z_TYPE_P(zpHash) == IS_NULL) || ((Z_TYPE_P(zpHash) == IS_OBJECT) && (Z_OBJCE_P(zpHash) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpPrivateKeyBlob) == IS_STRING) || (Z_TYPE_P(zpPrivateKeyBlob) == IS_ARRAY) || (Z_TYPE_P(zpPrivateKeyBlob) == IS_NULL) || ((Z_TYPE_P(zpPrivateKeyBlob) == IS_OBJECT) && (Z_OBJCE_P(zpPrivateKeyBlob) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpSignature) == IS_STRING) || (Z_TYPE_P(zpSignature) == IS_ARRAY) || (Z_TYPE_P(zpSignature) == IS_NULL) || ((Z_TYPE_P(zpSignature) == IS_OBJECT) && (Z_OBJCE_P(zpSignature) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpHash, &piHash TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpPrivateKeyBlob, &piPrivateKeyBlob TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpSignature, &piSignature TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBRSA_ValidateSignature_1(piHash.data, (int32_t)l4HashSize, piPrivateKeyBlob.data, (int32_t)l4PrivateKeyBlobSize, piSignature.data, (int32_t)l4SignatureSize, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piHash);
		SBFreePointerZValInfo(&piPrivateKeyBlob);
		SBFreePointerZValInfo(&piSignature);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer) or (TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRSA, ExtractSignedData)
{
	long l4PublicExponentSize;
	long l4PublicModulusSize;
	long l4SignatureSize;
	SBArrayZValInfo piPublicExponent;
	SBArrayZValInfo piPublicModulus;
	SBArrayZValInfo piSignature;
	uint32_t _err;
	zval *zpPublicExponent;
	zval *zpPublicModulus;
	zval *zpSignature;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzl", &zpPublicModulus, &l4PublicModulusSize, &zpPublicExponent, &l4PublicExponentSize, &zpSignature, &l4SignatureSize) == SUCCESS) && ((Z_TYPE_P(zpPublicModulus) == IS_STRING) || (Z_TYPE_P(zpPublicModulus) == IS_ARRAY) || (Z_TYPE_P(zpPublicModulus) == IS_NULL) || ((Z_TYPE_P(zpPublicModulus) == IS_OBJECT) && (Z_OBJCE_P(zpPublicModulus) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpPublicExponent) == IS_STRING) || (Z_TYPE_P(zpPublicExponent) == IS_ARRAY) || (Z_TYPE_P(zpPublicExponent) == IS_NULL) || ((Z_TYPE_P(zpPublicExponent) == IS_OBJECT) && (Z_OBJCE_P(zpPublicExponent) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpSignature) == IS_STRING) || (Z_TYPE_P(zpSignature) == IS_ARRAY) || (Z_TYPE_P(zpSignature) == IS_NULL) || ((Z_TYPE_P(zpSignature) == IS_OBJECT) && (Z_OBJCE_P(zpSignature) == TSBPointer_ce_ptr))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetPointerFromZVal(zpPublicModulus, &piPublicModulus TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpPublicExponent, &piPublicExponent TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpSignature, &piSignature TSRMLS_CC)) RETURN_FALSE;
		_err = SBRSA_ExtractSignedData(piPublicModulus.data, (int32_t)l4PublicModulusSize, piPublicExponent.data, (int32_t)l4PublicExponentSize, piSignature.data, (int32_t)l4SignatureSize, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1061495975, 6, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreePointerZValInfo(&piPublicModulus);
		SBFreePointerZValInfo(&piPublicExponent);
		SBFreePointerZValInfo(&piSignature);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRSA, Generate)
{
	int32_t l4PrivateExponentSizeRaw;
	int32_t l4PrivateKeyBlobSizeRaw;
	int32_t l4PublicExponentSizeRaw;
	int32_t l4PublicModulusSizeRaw;
	long l4Bits;
	SBArrayZValInfo piData;
	SBArrayZValInfo piPrivateExponent;
	SBArrayZValInfo piPrivateKeyBlob;
	SBArrayZValInfo piPublicExponent;
	SBArrayZValInfo piPublicModulus;
	void *pzProgressFunc;
	zval *oP;
	zval *oPrivateExponent;
	zval *oPublicExponent;
	zval *oPublicModulus;
	zval *oQ;
	zval *oU;
	zval *zl4PrivateExponentSize;
	zval *zl4PrivateKeyBlobSize;
	zval *zl4PublicExponentSize;
	zval *zl4PublicModulusSize;
	zval *zpData;
	zval *zpPrivateExponent;
	zval *zpPrivateKeyBlob;
	zval *zpPublicExponent;
	zval *zpPublicModulus;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzzzzzz", &l4Bits, &zpPublicModulus, &zl4PublicModulusSize, &zpPublicExponent, &zl4PublicExponentSize, &zpPrivateExponent, &zl4PrivateExponentSize) == SUCCESS) && ((Z_TYPE_P(zpPublicModulus) == IS_STRING) || (Z_TYPE_P(zpPublicModulus) == IS_ARRAY) || (Z_TYPE_P(zpPublicModulus) == IS_NULL) || ((Z_TYPE_P(zpPublicModulus) == IS_OBJECT) && (Z_OBJCE_P(zpPublicModulus) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PublicModulusSize) && (IS_LONG == Z_TYPE_P(zl4PublicModulusSize)) && ((Z_TYPE_P(zpPublicExponent) == IS_STRING) || (Z_TYPE_P(zpPublicExponent) == IS_ARRAY) || (Z_TYPE_P(zpPublicExponent) == IS_NULL) || ((Z_TYPE_P(zpPublicExponent) == IS_OBJECT) && (Z_OBJCE_P(zpPublicExponent) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PublicExponentSize) && (IS_LONG == Z_TYPE_P(zl4PublicExponentSize)) && ((Z_TYPE_P(zpPrivateExponent) == IS_STRING) || (Z_TYPE_P(zpPrivateExponent) == IS_ARRAY) || (Z_TYPE_P(zpPrivateExponent) == IS_NULL) || ((Z_TYPE_P(zpPrivateExponent) == IS_OBJECT) && (Z_OBJCE_P(zpPrivateExponent) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PrivateExponentSize) && (IS_LONG == Z_TYPE_P(zl4PrivateExponentSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpPublicModulus, &piPublicModulus TSRMLS_CC)) RETURN_FALSE;
		l4PublicModulusSizeRaw = (int32_t)Z_LVAL_P(zl4PublicModulusSize);
		if (!SBGetPointerFromZVal(zpPublicExponent, &piPublicExponent TSRMLS_CC)) RETURN_FALSE;
		l4PublicExponentSizeRaw = (int32_t)Z_LVAL_P(zl4PublicExponentSize);
		if (!SBGetPointerFromZVal(zpPrivateExponent, &piPrivateExponent TSRMLS_CC)) RETURN_FALSE;
		l4PrivateExponentSizeRaw = (int32_t)Z_LVAL_P(zl4PrivateExponentSize);
		SBCheckError(SBRSA_Generate((int32_t)l4Bits, piPublicModulus.data, &l4PublicModulusSizeRaw, piPublicExponent.data, &l4PublicExponentSizeRaw, piPrivateExponent.data, &l4PrivateExponentSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piPublicModulus);
		ZVAL_LONG(zl4PublicModulusSize, (long)l4PublicModulusSizeRaw);
		SBFreePointerZValInfo(&piPublicExponent);
		ZVAL_LONG(zl4PublicExponentSize, (long)l4PublicExponentSizeRaw);
		SBFreePointerZValInfo(&piPrivateExponent);
		ZVAL_LONG(zl4PrivateExponentSize, (long)l4PrivateExponentSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzzzzzzzzzz", &l4Bits, &zpPublicModulus, &zl4PublicModulusSize, &zpPublicExponent, &zl4PublicExponentSize, &zpPrivateExponent, &zl4PrivateExponentSize, &zpPrivateKeyBlob, &zl4PrivateKeyBlobSize, &zProgressFunc, &zpData) == SUCCESS) && ((Z_TYPE_P(zpPublicModulus) == IS_STRING) || (Z_TYPE_P(zpPublicModulus) == IS_ARRAY) || (Z_TYPE_P(zpPublicModulus) == IS_NULL) || ((Z_TYPE_P(zpPublicModulus) == IS_OBJECT) && (Z_OBJCE_P(zpPublicModulus) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PublicModulusSize) && (IS_LONG == Z_TYPE_P(zl4PublicModulusSize)) && ((Z_TYPE_P(zpPublicExponent) == IS_STRING) || (Z_TYPE_P(zpPublicExponent) == IS_ARRAY) || (Z_TYPE_P(zpPublicExponent) == IS_NULL) || ((Z_TYPE_P(zpPublicExponent) == IS_OBJECT) && (Z_OBJCE_P(zpPublicExponent) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PublicExponentSize) && (IS_LONG == Z_TYPE_P(zl4PublicExponentSize)) && ((Z_TYPE_P(zpPrivateExponent) == IS_STRING) || (Z_TYPE_P(zpPrivateExponent) == IS_ARRAY) || (Z_TYPE_P(zpPrivateExponent) == IS_NULL) || ((Z_TYPE_P(zpPrivateExponent) == IS_OBJECT) && (Z_OBJCE_P(zpPrivateExponent) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PrivateExponentSize) && (IS_LONG == Z_TYPE_P(zl4PrivateExponentSize)) && ((Z_TYPE_P(zpPrivateKeyBlob) == IS_STRING) || (Z_TYPE_P(zpPrivateKeyBlob) == IS_ARRAY) || (Z_TYPE_P(zpPrivateKeyBlob) == IS_NULL) || ((Z_TYPE_P(zpPrivateKeyBlob) == IS_OBJECT) && (Z_OBJCE_P(zpPrivateKeyBlob) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PrivateKeyBlobSize) && (IS_LONG == Z_TYPE_P(zl4PrivateKeyBlobSize)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpData) == IS_STRING) || (Z_TYPE_P(zpData) == IS_ARRAY) || (Z_TYPE_P(zpData) == IS_NULL) || ((Z_TYPE_P(zpData) == IS_OBJECT) && (Z_OBJCE_P(zpData) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpPublicModulus, &piPublicModulus TSRMLS_CC)) RETURN_FALSE;
		l4PublicModulusSizeRaw = (int32_t)Z_LVAL_P(zl4PublicModulusSize);
		if (!SBGetPointerFromZVal(zpPublicExponent, &piPublicExponent TSRMLS_CC)) RETURN_FALSE;
		l4PublicExponentSizeRaw = (int32_t)Z_LVAL_P(zl4PublicExponentSize);
		if (!SBGetPointerFromZVal(zpPrivateExponent, &piPrivateExponent TSRMLS_CC)) RETURN_FALSE;
		l4PrivateExponentSizeRaw = (int32_t)Z_LVAL_P(zl4PrivateExponentSize);
		if (!SBGetPointerFromZVal(zpPrivateKeyBlob, &piPrivateKeyBlob TSRMLS_CC)) RETURN_FALSE;
		l4PrivateKeyBlobSizeRaw = (int32_t)Z_LVAL_P(zl4PrivateKeyBlobSize);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpData, &piData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBRSA_Generate_1((int32_t)l4Bits, piPublicModulus.data, &l4PublicModulusSizeRaw, piPublicExponent.data, &l4PublicExponentSizeRaw, piPrivateExponent.data, &l4PrivateExponentSizeRaw, piPrivateKeyBlob.data, &l4PrivateKeyBlobSizeRaw, pzProgressFunc ? &TSBMathProgressFuncRaw : NULL, pzProgressFunc, piData.data, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piPublicModulus);
		ZVAL_LONG(zl4PublicModulusSize, (long)l4PublicModulusSizeRaw);
		SBFreePointerZValInfo(&piPublicExponent);
		ZVAL_LONG(zl4PublicExponentSize, (long)l4PublicExponentSizeRaw);
		SBFreePointerZValInfo(&piPrivateExponent);
		ZVAL_LONG(zl4PrivateExponentSize, (long)l4PrivateExponentSizeRaw);
		SBFreePointerZValInfo(&piPrivateKeyBlob);
		ZVAL_LONG(zl4PrivateKeyBlobSize, (long)l4PrivateKeyBlobSizeRaw);
		SBFreePointerZValInfo(&piData);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!O!O!O!O!", &l4Bits, &oPublicModulus, TLInt_ce_ptr, &oPublicExponent, TLInt_ce_ptr, &oPrivateExponent, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &oQ, TLInt_ce_ptr, &oU, TLInt_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBRSA_Generate_2((int32_t)l4Bits, (TLInt *)SBGetStructPointer(oPublicModulus TSRMLS_CC), (TLInt *)SBGetStructPointer(oPublicExponent TSRMLS_CC), (TLInt *)SBGetStructPointer(oPrivateExponent TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), (TLInt *)SBGetStructPointer(oQ TSRMLS_CC), (TLInt *)SBGetStructPointer(oU TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer) or (integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBMathProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL) or (integer, TLInt, TLInt, TLInt, TLInt, TLInt, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRSA, ExternalGenerate)
{
	int32_t l4PrivateExponentSizeRaw;
	int32_t l4PrivateKeyBlobSizeRaw;
	int32_t l4PublicExponentSizeRaw;
	int32_t l4PublicModulusSizeRaw;
	long l4Bits;
	SBArrayZValInfo piData;
	SBArrayZValInfo piPrivateExponent;
	SBArrayZValInfo piPrivateKeyBlob;
	SBArrayZValInfo piPublicExponent;
	SBArrayZValInfo piPublicModulus;
	void *pzProgressFunc;
	zval *oP;
	zval *oPrivateExponent;
	zval *oPublicExponent;
	zval *oPublicModulus;
	zval *oQ;
	zval *oU;
	zval *zl4PrivateExponentSize;
	zval *zl4PrivateKeyBlobSize;
	zval *zl4PublicExponentSize;
	zval *zl4PublicModulusSize;
	zval *zpData;
	zval *zpPrivateExponent;
	zval *zpPrivateKeyBlob;
	zval *zpPublicExponent;
	zval *zpPublicModulus;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzzzzzz", &l4Bits, &zpPublicModulus, &zl4PublicModulusSize, &zpPublicExponent, &zl4PublicExponentSize, &zpPrivateExponent, &zl4PrivateExponentSize) == SUCCESS) && ((Z_TYPE_P(zpPublicModulus) == IS_STRING) || (Z_TYPE_P(zpPublicModulus) == IS_ARRAY) || (Z_TYPE_P(zpPublicModulus) == IS_NULL) || ((Z_TYPE_P(zpPublicModulus) == IS_OBJECT) && (Z_OBJCE_P(zpPublicModulus) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PublicModulusSize) && (IS_LONG == Z_TYPE_P(zl4PublicModulusSize)) && ((Z_TYPE_P(zpPublicExponent) == IS_STRING) || (Z_TYPE_P(zpPublicExponent) == IS_ARRAY) || (Z_TYPE_P(zpPublicExponent) == IS_NULL) || ((Z_TYPE_P(zpPublicExponent) == IS_OBJECT) && (Z_OBJCE_P(zpPublicExponent) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PublicExponentSize) && (IS_LONG == Z_TYPE_P(zl4PublicExponentSize)) && ((Z_TYPE_P(zpPrivateExponent) == IS_STRING) || (Z_TYPE_P(zpPrivateExponent) == IS_ARRAY) || (Z_TYPE_P(zpPrivateExponent) == IS_NULL) || ((Z_TYPE_P(zpPrivateExponent) == IS_OBJECT) && (Z_OBJCE_P(zpPrivateExponent) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PrivateExponentSize) && (IS_LONG == Z_TYPE_P(zl4PrivateExponentSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpPublicModulus, &piPublicModulus TSRMLS_CC)) RETURN_FALSE;
		l4PublicModulusSizeRaw = (int32_t)Z_LVAL_P(zl4PublicModulusSize);
		if (!SBGetPointerFromZVal(zpPublicExponent, &piPublicExponent TSRMLS_CC)) RETURN_FALSE;
		l4PublicExponentSizeRaw = (int32_t)Z_LVAL_P(zl4PublicExponentSize);
		if (!SBGetPointerFromZVal(zpPrivateExponent, &piPrivateExponent TSRMLS_CC)) RETURN_FALSE;
		l4PrivateExponentSizeRaw = (int32_t)Z_LVAL_P(zl4PrivateExponentSize);
		SBCheckError(SBRSA_ExternalGenerate((int32_t)l4Bits, piPublicModulus.data, &l4PublicModulusSizeRaw, piPublicExponent.data, &l4PublicExponentSizeRaw, piPrivateExponent.data, &l4PrivateExponentSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piPublicModulus);
		ZVAL_LONG(zl4PublicModulusSize, (long)l4PublicModulusSizeRaw);
		SBFreePointerZValInfo(&piPublicExponent);
		ZVAL_LONG(zl4PublicExponentSize, (long)l4PublicExponentSizeRaw);
		SBFreePointerZValInfo(&piPrivateExponent);
		ZVAL_LONG(zl4PrivateExponentSize, (long)l4PrivateExponentSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzzzzzzzzzz", &l4Bits, &zpPublicModulus, &zl4PublicModulusSize, &zpPublicExponent, &zl4PublicExponentSize, &zpPrivateExponent, &zl4PrivateExponentSize, &zpPrivateKeyBlob, &zl4PrivateKeyBlobSize, &zProgressFunc, &zpData) == SUCCESS) && ((Z_TYPE_P(zpPublicModulus) == IS_STRING) || (Z_TYPE_P(zpPublicModulus) == IS_ARRAY) || (Z_TYPE_P(zpPublicModulus) == IS_NULL) || ((Z_TYPE_P(zpPublicModulus) == IS_OBJECT) && (Z_OBJCE_P(zpPublicModulus) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PublicModulusSize) && (IS_LONG == Z_TYPE_P(zl4PublicModulusSize)) && ((Z_TYPE_P(zpPublicExponent) == IS_STRING) || (Z_TYPE_P(zpPublicExponent) == IS_ARRAY) || (Z_TYPE_P(zpPublicExponent) == IS_NULL) || ((Z_TYPE_P(zpPublicExponent) == IS_OBJECT) && (Z_OBJCE_P(zpPublicExponent) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PublicExponentSize) && (IS_LONG == Z_TYPE_P(zl4PublicExponentSize)) && ((Z_TYPE_P(zpPrivateExponent) == IS_STRING) || (Z_TYPE_P(zpPrivateExponent) == IS_ARRAY) || (Z_TYPE_P(zpPrivateExponent) == IS_NULL) || ((Z_TYPE_P(zpPrivateExponent) == IS_OBJECT) && (Z_OBJCE_P(zpPrivateExponent) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PrivateExponentSize) && (IS_LONG == Z_TYPE_P(zl4PrivateExponentSize)) && ((Z_TYPE_P(zpPrivateKeyBlob) == IS_STRING) || (Z_TYPE_P(zpPrivateKeyBlob) == IS_ARRAY) || (Z_TYPE_P(zpPrivateKeyBlob) == IS_NULL) || ((Z_TYPE_P(zpPrivateKeyBlob) == IS_OBJECT) && (Z_OBJCE_P(zpPrivateKeyBlob) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PrivateKeyBlobSize) && (IS_LONG == Z_TYPE_P(zl4PrivateKeyBlobSize)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpData) == IS_STRING) || (Z_TYPE_P(zpData) == IS_ARRAY) || (Z_TYPE_P(zpData) == IS_NULL) || ((Z_TYPE_P(zpData) == IS_OBJECT) && (Z_OBJCE_P(zpData) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpPublicModulus, &piPublicModulus TSRMLS_CC)) RETURN_FALSE;
		l4PublicModulusSizeRaw = (int32_t)Z_LVAL_P(zl4PublicModulusSize);
		if (!SBGetPointerFromZVal(zpPublicExponent, &piPublicExponent TSRMLS_CC)) RETURN_FALSE;
		l4PublicExponentSizeRaw = (int32_t)Z_LVAL_P(zl4PublicExponentSize);
		if (!SBGetPointerFromZVal(zpPrivateExponent, &piPrivateExponent TSRMLS_CC)) RETURN_FALSE;
		l4PrivateExponentSizeRaw = (int32_t)Z_LVAL_P(zl4PrivateExponentSize);
		if (!SBGetPointerFromZVal(zpPrivateKeyBlob, &piPrivateKeyBlob TSRMLS_CC)) RETURN_FALSE;
		l4PrivateKeyBlobSizeRaw = (int32_t)Z_LVAL_P(zl4PrivateKeyBlobSize);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpData, &piData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBRSA_ExternalGenerate_1((int32_t)l4Bits, piPublicModulus.data, &l4PublicModulusSizeRaw, piPublicExponent.data, &l4PublicExponentSizeRaw, piPrivateExponent.data, &l4PrivateExponentSizeRaw, piPrivateKeyBlob.data, &l4PrivateKeyBlobSizeRaw, pzProgressFunc ? &TSBMathProgressFuncRaw : NULL, pzProgressFunc, piData.data, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piPublicModulus);
		ZVAL_LONG(zl4PublicModulusSize, (long)l4PublicModulusSizeRaw);
		SBFreePointerZValInfo(&piPublicExponent);
		ZVAL_LONG(zl4PublicExponentSize, (long)l4PublicExponentSizeRaw);
		SBFreePointerZValInfo(&piPrivateExponent);
		ZVAL_LONG(zl4PrivateExponentSize, (long)l4PrivateExponentSizeRaw);
		SBFreePointerZValInfo(&piPrivateKeyBlob);
		ZVAL_LONG(zl4PrivateKeyBlobSize, (long)l4PrivateKeyBlobSizeRaw);
		SBFreePointerZValInfo(&piData);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!O!O!O!O!", &l4Bits, &oPublicModulus, TLInt_ce_ptr, &oPublicExponent, TLInt_ce_ptr, &oPrivateExponent, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &oQ, TLInt_ce_ptr, &oU, TLInt_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBRSA_ExternalGenerate_2((int32_t)l4Bits, (TLInt *)SBGetStructPointer(oPublicModulus TSRMLS_CC), (TLInt *)SBGetStructPointer(oPublicExponent TSRMLS_CC), (TLInt *)SBGetStructPointer(oPrivateExponent TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), (TLInt *)SBGetStructPointer(oQ TSRMLS_CC), (TLInt *)SBGetStructPointer(oU TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer) or (integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBMathProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL) or (integer, TLInt, TLInt, TLInt, TLInt, TLInt, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRSA, ExternalGenerationSupported)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBRSA_ExternalGenerationSupported(&bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRSA, Sign)
{
	int32_t l4SignatureSizeRaw;
	long l4HashSize;
	long l4PrivateExponentSize;
	long l4PrivateKeyBlobSize;
	long l4PublicModulusSize;
	SBArrayZValInfo piHash;
	SBArrayZValInfo piPrivateExponent;
	SBArrayZValInfo piPrivateKeyBlob;
	SBArrayZValInfo piPublicModulus;
	SBArrayZValInfo piSignature;
	zval *oAntiTimingParams;
	zval *zl4SignatureSize;
	zval *zpHash;
	zval *zpPrivateExponent;
	zval *zpPrivateKeyBlob;
	zval *zpPublicModulus;
	zval *zpSignature;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzlzzO!", &zpHash, &l4HashSize, &zpPublicModulus, &l4PublicModulusSize, &zpPrivateExponent, &l4PrivateExponentSize, &zpSignature, &zl4SignatureSize, &oAntiTimingParams, TElRSAAntiTimingParams_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpHash) == IS_STRING) || (Z_TYPE_P(zpHash) == IS_ARRAY) || (Z_TYPE_P(zpHash) == IS_NULL) || ((Z_TYPE_P(zpHash) == IS_OBJECT) && (Z_OBJCE_P(zpHash) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpPublicModulus) == IS_STRING) || (Z_TYPE_P(zpPublicModulus) == IS_ARRAY) || (Z_TYPE_P(zpPublicModulus) == IS_NULL) || ((Z_TYPE_P(zpPublicModulus) == IS_OBJECT) && (Z_OBJCE_P(zpPublicModulus) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpPrivateExponent) == IS_STRING) || (Z_TYPE_P(zpPrivateExponent) == IS_ARRAY) || (Z_TYPE_P(zpPrivateExponent) == IS_NULL) || ((Z_TYPE_P(zpPrivateExponent) == IS_OBJECT) && (Z_OBJCE_P(zpPrivateExponent) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpSignature) == IS_STRING) || (Z_TYPE_P(zpSignature) == IS_ARRAY) || (Z_TYPE_P(zpSignature) == IS_NULL) || ((Z_TYPE_P(zpSignature) == IS_OBJECT) && (Z_OBJCE_P(zpSignature) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4SignatureSize) && (IS_LONG == Z_TYPE_P(zl4SignatureSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpHash, &piHash TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpPublicModulus, &piPublicModulus TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpPrivateExponent, &piPrivateExponent TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpSignature, &piSignature TSRMLS_CC)) RETURN_FALSE;
		l4SignatureSizeRaw = (int32_t)Z_LVAL_P(zl4SignatureSize);
		SBCheckError(SBRSA_Sign(piHash.data, (int32_t)l4HashSize, piPublicModulus.data, (int32_t)l4PublicModulusSize, piPrivateExponent.data, (int32_t)l4PrivateExponentSize, piSignature.data, &l4SignatureSizeRaw, SBGetObjectHandle(oAntiTimingParams TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piHash);
		SBFreePointerZValInfo(&piPublicModulus);
		SBFreePointerZValInfo(&piPrivateExponent);
		SBFreePointerZValInfo(&piSignature);
		ZVAL_LONG(zl4SignatureSize, (long)l4SignatureSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzzO!", &zpHash, &l4HashSize, &zpPrivateKeyBlob, &l4PrivateKeyBlobSize, &zpSignature, &zl4SignatureSize, &oAntiTimingParams, TElRSAAntiTimingParams_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpHash) == IS_STRING) || (Z_TYPE_P(zpHash) == IS_ARRAY) || (Z_TYPE_P(zpHash) == IS_NULL) || ((Z_TYPE_P(zpHash) == IS_OBJECT) && (Z_OBJCE_P(zpHash) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpPrivateKeyBlob) == IS_STRING) || (Z_TYPE_P(zpPrivateKeyBlob) == IS_ARRAY) || (Z_TYPE_P(zpPrivateKeyBlob) == IS_NULL) || ((Z_TYPE_P(zpPrivateKeyBlob) == IS_OBJECT) && (Z_OBJCE_P(zpPrivateKeyBlob) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpSignature) == IS_STRING) || (Z_TYPE_P(zpSignature) == IS_ARRAY) || (Z_TYPE_P(zpSignature) == IS_NULL) || ((Z_TYPE_P(zpSignature) == IS_OBJECT) && (Z_OBJCE_P(zpSignature) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4SignatureSize) && (IS_LONG == Z_TYPE_P(zl4SignatureSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpHash, &piHash TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpPrivateKeyBlob, &piPrivateKeyBlob TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpSignature, &piSignature TSRMLS_CC)) RETURN_FALSE;
		l4SignatureSizeRaw = (int32_t)Z_LVAL_P(zl4SignatureSize);
		SBCheckError(SBRSA_Sign_1(piHash.data, (int32_t)l4HashSize, piPrivateKeyBlob.data, (int32_t)l4PrivateKeyBlobSize, piSignature.data, &l4SignatureSizeRaw, SBGetObjectHandle(oAntiTimingParams TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piHash);
		SBFreePointerZValInfo(&piPrivateKeyBlob);
		SBFreePointerZValInfo(&piSignature);
		ZVAL_LONG(zl4SignatureSize, (long)l4SignatureSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TElRSAAntiTimingParams) or (TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TElRSAAntiTimingParams)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRSA, Encrypt)
{
	int32_t l4OutSizeRaw;
	long l4InSize;
	long l4PublicExponentSize;
	long l4PublicModulusSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	SBArrayZValInfo piPublicExponent;
	SBArrayZValInfo piPublicModulus;
	zval *oPublicExponent;
	zval *oPublicModulus;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	zval *zpPublicExponent;
	zval *zpPublicModulus;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzlzz", &zpInBuffer, &l4InSize, &zpPublicModulus, &l4PublicModulusSize, &zpPublicExponent, &l4PublicExponentSize, &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpPublicModulus) == IS_STRING) || (Z_TYPE_P(zpPublicModulus) == IS_ARRAY) || (Z_TYPE_P(zpPublicModulus) == IS_NULL) || ((Z_TYPE_P(zpPublicModulus) == IS_OBJECT) && (Z_OBJCE_P(zpPublicModulus) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpPublicExponent) == IS_STRING) || (Z_TYPE_P(zpPublicExponent) == IS_ARRAY) || (Z_TYPE_P(zpPublicExponent) == IS_NULL) || ((Z_TYPE_P(zpPublicExponent) == IS_OBJECT) && (Z_OBJCE_P(zpPublicExponent) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpPublicModulus, &piPublicModulus TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpPublicExponent, &piPublicExponent TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(SBRSA_Encrypt(piInBuffer.data, (int32_t)l4InSize, piPublicModulus.data, (int32_t)l4PublicModulusSize, piPublicExponent.data, (int32_t)l4PublicExponentSize, piOutBuffer.data, &l4OutSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piPublicModulus);
		SBFreePointerZValInfo(&piPublicExponent);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzzO!O!", &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize, &oPublicModulus, TLInt_ce_ptr, &oPublicExponent, TLInt_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(SBRSA_Encrypt_1(piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, (TLInt *)SBGetStructPointer(oPublicModulus TSRMLS_CC), (TLInt *)SBGetStructPointer(oPublicExponent TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer) or (TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TLInt, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRSA, Decrypt)
{
	int32_t l4OutSizeRaw;
	long l4InSize;
	long l4PrivateExponentSize;
	long l4PrivateKeyBlobSize;
	long l4PublicModulusSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	SBArrayZValInfo piPrivateExponent;
	SBArrayZValInfo piPrivateKeyBlob;
	SBArrayZValInfo piPublicModulus;
	zval *oAntiTimingParams;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	zval *zpPrivateExponent;
	zval *zpPrivateKeyBlob;
	zval *zpPublicModulus;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzlzzO!", &zpInBuffer, &l4InSize, &zpPublicModulus, &l4PublicModulusSize, &zpPrivateExponent, &l4PrivateExponentSize, &zpOutBuffer, &zl4OutSize, &oAntiTimingParams, TElRSAAntiTimingParams_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpPublicModulus) == IS_STRING) || (Z_TYPE_P(zpPublicModulus) == IS_ARRAY) || (Z_TYPE_P(zpPublicModulus) == IS_NULL) || ((Z_TYPE_P(zpPublicModulus) == IS_OBJECT) && (Z_OBJCE_P(zpPublicModulus) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpPrivateExponent) == IS_STRING) || (Z_TYPE_P(zpPrivateExponent) == IS_ARRAY) || (Z_TYPE_P(zpPrivateExponent) == IS_NULL) || ((Z_TYPE_P(zpPrivateExponent) == IS_OBJECT) && (Z_OBJCE_P(zpPrivateExponent) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpPublicModulus, &piPublicModulus TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpPrivateExponent, &piPrivateExponent TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(SBRSA_Decrypt(piInBuffer.data, (int32_t)l4InSize, piPublicModulus.data, (int32_t)l4PublicModulusSize, piPrivateExponent.data, (int32_t)l4PrivateExponentSize, piOutBuffer.data, &l4OutSizeRaw, SBGetObjectHandle(oAntiTimingParams TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piPublicModulus);
		SBFreePointerZValInfo(&piPrivateExponent);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzzO!", &zpInBuffer, &l4InSize, &zpPrivateKeyBlob, &l4PrivateKeyBlobSize, &zpOutBuffer, &zl4OutSize, &oAntiTimingParams, TElRSAAntiTimingParams_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpPrivateKeyBlob) == IS_STRING) || (Z_TYPE_P(zpPrivateKeyBlob) == IS_ARRAY) || (Z_TYPE_P(zpPrivateKeyBlob) == IS_NULL) || ((Z_TYPE_P(zpPrivateKeyBlob) == IS_OBJECT) && (Z_OBJCE_P(zpPrivateKeyBlob) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpPrivateKeyBlob, &piPrivateKeyBlob TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(SBRSA_Decrypt_1(piInBuffer.data, (int32_t)l4InSize, piPrivateKeyBlob.data, (int32_t)l4PrivateKeyBlobSize, piOutBuffer.data, &l4OutSizeRaw, SBGetObjectHandle(oAntiTimingParams TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piPrivateKeyBlob);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TElRSAAntiTimingParams) or (TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TElRSAAntiTimingParams)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRSA, DecodePrivateKey)
{
	int32_t l4E1SizeRaw;
	int32_t l4E2SizeRaw;
	int32_t l4PrivateExponentSizeRaw;
	int32_t l4PSizeRaw;
	int32_t l4PublicExponentSizeRaw;
	int32_t l4PublicModulusSizeRaw;
	int32_t l4QSizeRaw;
	int32_t l4USizeRaw;
	long l4Size;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piE1;
	SBArrayZValInfo piE2;
	SBArrayZValInfo piP;
	SBArrayZValInfo piPrivateExponent;
	SBArrayZValInfo piPublicExponent;
	SBArrayZValInfo piPublicModulus;
	SBArrayZValInfo piQ;
	SBArrayZValInfo piU;
	zval *zl4E1Size;
	zval *zl4E2Size;
	zval *zl4PrivateExponentSize;
	zval *zl4PSize;
	zval *zl4PublicExponentSize;
	zval *zl4PublicModulusSize;
	zval *zl4QSize;
	zval *zl4USize;
	zval *zpBuffer;
	zval *zpE1;
	zval *zpE2;
	zval *zpP;
	zval *zpPrivateExponent;
	zval *zpPublicExponent;
	zval *zpPublicModulus;
	zval *zpQ;
	zval *zpU;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzzzzzz", &zpBuffer, &l4Size, &zpPublicModulus, &zl4PublicModulusSize, &zpPublicExponent, &zl4PublicExponentSize, &zpPrivateExponent, &zl4PrivateExponentSize) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpPublicModulus) == IS_STRING) || (Z_TYPE_P(zpPublicModulus) == IS_ARRAY) || (Z_TYPE_P(zpPublicModulus) == IS_NULL) || ((Z_TYPE_P(zpPublicModulus) == IS_OBJECT) && (Z_OBJCE_P(zpPublicModulus) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PublicModulusSize) && (IS_LONG == Z_TYPE_P(zl4PublicModulusSize)) && ((Z_TYPE_P(zpPublicExponent) == IS_STRING) || (Z_TYPE_P(zpPublicExponent) == IS_ARRAY) || (Z_TYPE_P(zpPublicExponent) == IS_NULL) || ((Z_TYPE_P(zpPublicExponent) == IS_OBJECT) && (Z_OBJCE_P(zpPublicExponent) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PublicExponentSize) && (IS_LONG == Z_TYPE_P(zl4PublicExponentSize)) && ((Z_TYPE_P(zpPrivateExponent) == IS_STRING) || (Z_TYPE_P(zpPrivateExponent) == IS_ARRAY) || (Z_TYPE_P(zpPrivateExponent) == IS_NULL) || ((Z_TYPE_P(zpPrivateExponent) == IS_OBJECT) && (Z_OBJCE_P(zpPrivateExponent) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PrivateExponentSize) && (IS_LONG == Z_TYPE_P(zl4PrivateExponentSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpPublicModulus, &piPublicModulus TSRMLS_CC)) RETURN_FALSE;
		l4PublicModulusSizeRaw = (int32_t)Z_LVAL_P(zl4PublicModulusSize);
		if (!SBGetPointerFromZVal(zpPublicExponent, &piPublicExponent TSRMLS_CC)) RETURN_FALSE;
		l4PublicExponentSizeRaw = (int32_t)Z_LVAL_P(zl4PublicExponentSize);
		if (!SBGetPointerFromZVal(zpPrivateExponent, &piPrivateExponent TSRMLS_CC)) RETURN_FALSE;
		l4PrivateExponentSizeRaw = (int32_t)Z_LVAL_P(zl4PrivateExponentSize);
		SBCheckError(SBRSA_DecodePrivateKey(piBuffer.data, (int32_t)l4Size, piPublicModulus.data, &l4PublicModulusSizeRaw, piPublicExponent.data, &l4PublicExponentSizeRaw, piPrivateExponent.data, &l4PrivateExponentSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		SBFreePointerZValInfo(&piPublicModulus);
		ZVAL_LONG(zl4PublicModulusSize, (long)l4PublicModulusSizeRaw);
		SBFreePointerZValInfo(&piPublicExponent);
		ZVAL_LONG(zl4PublicExponentSize, (long)l4PublicExponentSizeRaw);
		SBFreePointerZValInfo(&piPrivateExponent);
		ZVAL_LONG(zl4PrivateExponentSize, (long)l4PrivateExponentSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzzzzzzzzzzzzzzzz", &zpBuffer, &l4Size, &zpPublicModulus, &zl4PublicModulusSize, &zpPublicExponent, &zl4PublicExponentSize, &zpPrivateExponent, &zl4PrivateExponentSize, &zpP, &zl4PSize, &zpQ, &zl4QSize, &zpE1, &zl4E1Size, &zpE2, &zl4E2Size, &zpU, &zl4USize) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpPublicModulus) == IS_STRING) || (Z_TYPE_P(zpPublicModulus) == IS_ARRAY) || (Z_TYPE_P(zpPublicModulus) == IS_NULL) || ((Z_TYPE_P(zpPublicModulus) == IS_OBJECT) && (Z_OBJCE_P(zpPublicModulus) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PublicModulusSize) && (IS_LONG == Z_TYPE_P(zl4PublicModulusSize)) && ((Z_TYPE_P(zpPublicExponent) == IS_STRING) || (Z_TYPE_P(zpPublicExponent) == IS_ARRAY) || (Z_TYPE_P(zpPublicExponent) == IS_NULL) || ((Z_TYPE_P(zpPublicExponent) == IS_OBJECT) && (Z_OBJCE_P(zpPublicExponent) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PublicExponentSize) && (IS_LONG == Z_TYPE_P(zl4PublicExponentSize)) && ((Z_TYPE_P(zpPrivateExponent) == IS_STRING) || (Z_TYPE_P(zpPrivateExponent) == IS_ARRAY) || (Z_TYPE_P(zpPrivateExponent) == IS_NULL) || ((Z_TYPE_P(zpPrivateExponent) == IS_OBJECT) && (Z_OBJCE_P(zpPrivateExponent) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PrivateExponentSize) && (IS_LONG == Z_TYPE_P(zl4PrivateExponentSize)) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PSize) && (IS_LONG == Z_TYPE_P(zl4PSize)) && ((Z_TYPE_P(zpQ) == IS_STRING) || (Z_TYPE_P(zpQ) == IS_ARRAY) || (Z_TYPE_P(zpQ) == IS_NULL) || ((Z_TYPE_P(zpQ) == IS_OBJECT) && (Z_OBJCE_P(zpQ) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4QSize) && (IS_LONG == Z_TYPE_P(zl4QSize)) && ((Z_TYPE_P(zpE1) == IS_STRING) || (Z_TYPE_P(zpE1) == IS_ARRAY) || (Z_TYPE_P(zpE1) == IS_NULL) || ((Z_TYPE_P(zpE1) == IS_OBJECT) && (Z_OBJCE_P(zpE1) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4E1Size) && (IS_LONG == Z_TYPE_P(zl4E1Size)) && ((Z_TYPE_P(zpE2) == IS_STRING) || (Z_TYPE_P(zpE2) == IS_ARRAY) || (Z_TYPE_P(zpE2) == IS_NULL) || ((Z_TYPE_P(zpE2) == IS_OBJECT) && (Z_OBJCE_P(zpE2) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4E2Size) && (IS_LONG == Z_TYPE_P(zl4E2Size)) && ((Z_TYPE_P(zpU) == IS_STRING) || (Z_TYPE_P(zpU) == IS_ARRAY) || (Z_TYPE_P(zpU) == IS_NULL) || ((Z_TYPE_P(zpU) == IS_OBJECT) && (Z_OBJCE_P(zpU) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4USize) && (IS_LONG == Z_TYPE_P(zl4USize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpPublicModulus, &piPublicModulus TSRMLS_CC)) RETURN_FALSE;
		l4PublicModulusSizeRaw = (int32_t)Z_LVAL_P(zl4PublicModulusSize);
		if (!SBGetPointerFromZVal(zpPublicExponent, &piPublicExponent TSRMLS_CC)) RETURN_FALSE;
		l4PublicExponentSizeRaw = (int32_t)Z_LVAL_P(zl4PublicExponentSize);
		if (!SBGetPointerFromZVal(zpPrivateExponent, &piPrivateExponent TSRMLS_CC)) RETURN_FALSE;
		l4PrivateExponentSizeRaw = (int32_t)Z_LVAL_P(zl4PrivateExponentSize);
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		l4PSizeRaw = (int32_t)Z_LVAL_P(zl4PSize);
		if (!SBGetPointerFromZVal(zpQ, &piQ TSRMLS_CC)) RETURN_FALSE;
		l4QSizeRaw = (int32_t)Z_LVAL_P(zl4QSize);
		if (!SBGetPointerFromZVal(zpE1, &piE1 TSRMLS_CC)) RETURN_FALSE;
		l4E1SizeRaw = (int32_t)Z_LVAL_P(zl4E1Size);
		if (!SBGetPointerFromZVal(zpE2, &piE2 TSRMLS_CC)) RETURN_FALSE;
		l4E2SizeRaw = (int32_t)Z_LVAL_P(zl4E2Size);
		if (!SBGetPointerFromZVal(zpU, &piU TSRMLS_CC)) RETURN_FALSE;
		l4USizeRaw = (int32_t)Z_LVAL_P(zl4USize);
		SBCheckError(SBRSA_DecodePrivateKey_1(piBuffer.data, (int32_t)l4Size, piPublicModulus.data, &l4PublicModulusSizeRaw, piPublicExponent.data, &l4PublicExponentSizeRaw, piPrivateExponent.data, &l4PrivateExponentSizeRaw, piP.data, &l4PSizeRaw, piQ.data, &l4QSizeRaw, piE1.data, &l4E1SizeRaw, piE2.data, &l4E2SizeRaw, piU.data, &l4USizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		SBFreePointerZValInfo(&piPublicModulus);
		ZVAL_LONG(zl4PublicModulusSize, (long)l4PublicModulusSizeRaw);
		SBFreePointerZValInfo(&piPublicExponent);
		ZVAL_LONG(zl4PublicExponentSize, (long)l4PublicExponentSizeRaw);
		SBFreePointerZValInfo(&piPrivateExponent);
		ZVAL_LONG(zl4PrivateExponentSize, (long)l4PrivateExponentSizeRaw);
		SBFreePointerZValInfo(&piP);
		ZVAL_LONG(zl4PSize, (long)l4PSizeRaw);
		SBFreePointerZValInfo(&piQ);
		ZVAL_LONG(zl4QSize, (long)l4QSizeRaw);
		SBFreePointerZValInfo(&piE1);
		ZVAL_LONG(zl4E1Size, (long)l4E1SizeRaw);
		SBFreePointerZValInfo(&piE2);
		ZVAL_LONG(zl4E2Size, (long)l4E2SizeRaw);
		SBFreePointerZValInfo(&piU);
		ZVAL_LONG(zl4USize, (long)l4USizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer) or (TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRSA, EncodePrivateKey)
{
	int32_t l4OutSizeRaw;
	long l4CoefSize;
	long l4Exponent1Size;
	long l4Exponent2Size;
	long l4Prime1Size;
	long l4Prime2Size;
	long l4PrivateExponentSize;
	long l4PublicExponentSize;
	long l4PublicModulusSize;
	SBArrayZValInfo piCoef;
	SBArrayZValInfo piExponent1;
	SBArrayZValInfo piExponent2;
	SBArrayZValInfo piOutBuffer;
	SBArrayZValInfo piPrime1;
	SBArrayZValInfo piPrime2;
	SBArrayZValInfo piPrivateExponent;
	SBArrayZValInfo piPublicExponent;
	SBArrayZValInfo piPublicModulus;
	zval *zl4OutSize;
	zval *zpCoef;
	zval *zpExponent1;
	zval *zpExponent2;
	zval *zpOutBuffer;
	zval *zpPrime1;
	zval *zpPrime2;
	zval *zpPrivateExponent;
	zval *zpPublicExponent;
	zval *zpPublicModulus;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzlzlzlzlzlzlzz", &zpPublicModulus, &l4PublicModulusSize, &zpPublicExponent, &l4PublicExponentSize, &zpPrivateExponent, &l4PrivateExponentSize, &zpPrime1, &l4Prime1Size, &zpPrime2, &l4Prime2Size, &zpExponent1, &l4Exponent1Size, &zpExponent2, &l4Exponent2Size, &zpCoef, &l4CoefSize, &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpPublicModulus) == IS_STRING) || (Z_TYPE_P(zpPublicModulus) == IS_ARRAY) || (Z_TYPE_P(zpPublicModulus) == IS_NULL) || ((Z_TYPE_P(zpPublicModulus) == IS_OBJECT) && (Z_OBJCE_P(zpPublicModulus) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpPublicExponent) == IS_STRING) || (Z_TYPE_P(zpPublicExponent) == IS_ARRAY) || (Z_TYPE_P(zpPublicExponent) == IS_NULL) || ((Z_TYPE_P(zpPublicExponent) == IS_OBJECT) && (Z_OBJCE_P(zpPublicExponent) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpPrivateExponent) == IS_STRING) || (Z_TYPE_P(zpPrivateExponent) == IS_ARRAY) || (Z_TYPE_P(zpPrivateExponent) == IS_NULL) || ((Z_TYPE_P(zpPrivateExponent) == IS_OBJECT) && (Z_OBJCE_P(zpPrivateExponent) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpPrime1) == IS_STRING) || (Z_TYPE_P(zpPrime1) == IS_ARRAY) || (Z_TYPE_P(zpPrime1) == IS_NULL) || ((Z_TYPE_P(zpPrime1) == IS_OBJECT) && (Z_OBJCE_P(zpPrime1) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpPrime2) == IS_STRING) || (Z_TYPE_P(zpPrime2) == IS_ARRAY) || (Z_TYPE_P(zpPrime2) == IS_NULL) || ((Z_TYPE_P(zpPrime2) == IS_OBJECT) && (Z_OBJCE_P(zpPrime2) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpExponent1) == IS_STRING) || (Z_TYPE_P(zpExponent1) == IS_ARRAY) || (Z_TYPE_P(zpExponent1) == IS_NULL) || ((Z_TYPE_P(zpExponent1) == IS_OBJECT) && (Z_OBJCE_P(zpExponent1) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpExponent2) == IS_STRING) || (Z_TYPE_P(zpExponent2) == IS_ARRAY) || (Z_TYPE_P(zpExponent2) == IS_NULL) || ((Z_TYPE_P(zpExponent2) == IS_OBJECT) && (Z_OBJCE_P(zpExponent2) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpCoef) == IS_STRING) || (Z_TYPE_P(zpCoef) == IS_ARRAY) || (Z_TYPE_P(zpCoef) == IS_NULL) || ((Z_TYPE_P(zpCoef) == IS_OBJECT) && (Z_OBJCE_P(zpCoef) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpPublicModulus, &piPublicModulus TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpPublicExponent, &piPublicExponent TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpPrivateExponent, &piPrivateExponent TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpPrime1, &piPrime1 TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpPrime2, &piPrime2 TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpExponent1, &piExponent1 TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpExponent2, &piExponent2 TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpCoef, &piCoef TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(SBRSA_EncodePrivateKey(piPublicModulus.data, (int32_t)l4PublicModulusSize, piPublicExponent.data, (int32_t)l4PublicExponentSize, piPrivateExponent.data, (int32_t)l4PrivateExponentSize, piPrime1.data, (int32_t)l4Prime1Size, piPrime2.data, (int32_t)l4Prime2Size, piExponent1.data, (int32_t)l4Exponent1Size, piExponent2.data, (int32_t)l4Exponent2Size, piCoef.data, (int32_t)l4CoefSize, piOutBuffer.data, &l4OutSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piPublicModulus);
		SBFreePointerZValInfo(&piPublicExponent);
		SBFreePointerZValInfo(&piPrivateExponent);
		SBFreePointerZValInfo(&piPrime1);
		SBFreePointerZValInfo(&piPrime2);
		SBFreePointerZValInfo(&piExponent1);
		SBFreePointerZValInfo(&piExponent2);
		SBFreePointerZValInfo(&piCoef);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzlzz", &zpPublicModulus, &l4PublicModulusSize, &zpPublicExponent, &l4PublicExponentSize, &zpPrivateExponent, &l4PrivateExponentSize, &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpPublicModulus) == IS_STRING) || (Z_TYPE_P(zpPublicModulus) == IS_ARRAY) || (Z_TYPE_P(zpPublicModulus) == IS_NULL) || ((Z_TYPE_P(zpPublicModulus) == IS_OBJECT) && (Z_OBJCE_P(zpPublicModulus) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpPublicExponent) == IS_STRING) || (Z_TYPE_P(zpPublicExponent) == IS_ARRAY) || (Z_TYPE_P(zpPublicExponent) == IS_NULL) || ((Z_TYPE_P(zpPublicExponent) == IS_OBJECT) && (Z_OBJCE_P(zpPublicExponent) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpPrivateExponent) == IS_STRING) || (Z_TYPE_P(zpPrivateExponent) == IS_ARRAY) || (Z_TYPE_P(zpPrivateExponent) == IS_NULL) || ((Z_TYPE_P(zpPrivateExponent) == IS_OBJECT) && (Z_OBJCE_P(zpPrivateExponent) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpPublicModulus, &piPublicModulus TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpPublicExponent, &piPublicExponent TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpPrivateExponent, &piPrivateExponent TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(SBRSA_EncodePrivateKey_1(piPublicModulus.data, (int32_t)l4PublicModulusSize, piPublicExponent.data, (int32_t)l4PublicExponentSize, piPrivateExponent.data, (int32_t)l4PrivateExponentSize, piOutBuffer.data, &l4OutSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piPublicModulus);
		SBFreePointerZValInfo(&piPublicExponent);
		SBFreePointerZValInfo(&piPrivateExponent);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer) or (TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRSA, IsValidKey)
{
	long l4BlobSize;
	SBArrayZValInfo piBlob;
	zval *zpBlob;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBlob, &l4BlobSize) == SUCCESS) && ((Z_TYPE_P(zpBlob) == IS_STRING) || (Z_TYPE_P(zpBlob) == IS_ARRAY) || (Z_TYPE_P(zpBlob) == IS_NULL) || ((Z_TYPE_P(zpBlob) == IS_OBJECT) && (Z_OBJCE_P(zpBlob) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBlob, &piBlob TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBRSA_IsValidKey(piBlob.data, (int32_t)l4BlobSize, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBlob);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRSA, EncryptOAEP)
{
	int32_t l4OutSizeRaw;
	long l4HashAlg;
	long l4InSize;
	long l4PublicExponentSize;
	long l4PublicModulusSize;
	long l4SaltSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	SBArrayZValInfo piPublicExponent;
	SBArrayZValInfo piPublicModulus;
	SBArrayZValInfo piSalt;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	zval *zpPublicExponent;
	zval *zpPublicModulus;
	zval *zpSalt;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzlzllzz", &zpInBuffer, &l4InSize, &zpPublicModulus, &l4PublicModulusSize, &zpPublicExponent, &l4PublicExponentSize, &zpSalt, &l4SaltSize, &l4HashAlg, &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpPublicModulus) == IS_STRING) || (Z_TYPE_P(zpPublicModulus) == IS_ARRAY) || (Z_TYPE_P(zpPublicModulus) == IS_NULL) || ((Z_TYPE_P(zpPublicModulus) == IS_OBJECT) && (Z_OBJCE_P(zpPublicModulus) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpPublicExponent) == IS_STRING) || (Z_TYPE_P(zpPublicExponent) == IS_ARRAY) || (Z_TYPE_P(zpPublicExponent) == IS_NULL) || ((Z_TYPE_P(zpPublicExponent) == IS_OBJECT) && (Z_OBJCE_P(zpPublicExponent) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpSalt) == IS_STRING) || (Z_TYPE_P(zpSalt) == IS_ARRAY) || (Z_TYPE_P(zpSalt) == IS_NULL) || ((Z_TYPE_P(zpSalt) == IS_OBJECT) && (Z_OBJCE_P(zpSalt) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpPublicModulus, &piPublicModulus TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpPublicExponent, &piPublicExponent TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpSalt, &piSalt TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(SBRSA_EncryptOAEP(piInBuffer.data, (int32_t)l4InSize, piPublicModulus.data, (int32_t)l4PublicModulusSize, piPublicExponent.data, (int32_t)l4PublicExponentSize, piSalt.data, (int32_t)l4SaltSize, (int32_t)l4HashAlg, piOutBuffer.data, &l4OutSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piPublicModulus);
		SBFreePointerZValInfo(&piPublicExponent);
		SBFreePointerZValInfo(&piSalt);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRSA, DecryptOAEP)
{
	int32_t l4OutSizeRaw;
	long l4BlobSize;
	long l4HashAlg;
	long l4InSize;
	long l4PrivateExponentSize;
	long l4PublicModulusSize;
	long l4SaltSize;
	SBArrayZValInfo piBlob;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	SBArrayZValInfo piPrivateExponent;
	SBArrayZValInfo piPublicModulus;
	SBArrayZValInfo piSalt;
	zval *oAntiTimingParams;
	zval *zl4OutSize;
	zval *zpBlob;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	zval *zpPrivateExponent;
	zval *zpPublicModulus;
	zval *zpSalt;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzlzllzzO!", &zpInBuffer, &l4InSize, &zpPublicModulus, &l4PublicModulusSize, &zpPrivateExponent, &l4PrivateExponentSize, &zpSalt, &l4SaltSize, &l4HashAlg, &zpOutBuffer, &zl4OutSize, &oAntiTimingParams, TElRSAAntiTimingParams_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpPublicModulus) == IS_STRING) || (Z_TYPE_P(zpPublicModulus) == IS_ARRAY) || (Z_TYPE_P(zpPublicModulus) == IS_NULL) || ((Z_TYPE_P(zpPublicModulus) == IS_OBJECT) && (Z_OBJCE_P(zpPublicModulus) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpPrivateExponent) == IS_STRING) || (Z_TYPE_P(zpPrivateExponent) == IS_ARRAY) || (Z_TYPE_P(zpPrivateExponent) == IS_NULL) || ((Z_TYPE_P(zpPrivateExponent) == IS_OBJECT) && (Z_OBJCE_P(zpPrivateExponent) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpSalt) == IS_STRING) || (Z_TYPE_P(zpSalt) == IS_ARRAY) || (Z_TYPE_P(zpSalt) == IS_NULL) || ((Z_TYPE_P(zpSalt) == IS_OBJECT) && (Z_OBJCE_P(zpSalt) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpPublicModulus, &piPublicModulus TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpPrivateExponent, &piPrivateExponent TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpSalt, &piSalt TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(SBRSA_DecryptOAEP(piInBuffer.data, (int32_t)l4InSize, piPublicModulus.data, (int32_t)l4PublicModulusSize, piPrivateExponent.data, (int32_t)l4PrivateExponentSize, piSalt.data, (int32_t)l4SaltSize, (int32_t)l4HashAlg, piOutBuffer.data, &l4OutSizeRaw, SBGetObjectHandle(oAntiTimingParams TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piPublicModulus);
		SBFreePointerZValInfo(&piPrivateExponent);
		SBFreePointerZValInfo(&piSalt);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzllzzO!", &zpInBuffer, &l4InSize, &zpBlob, &l4BlobSize, &zpSalt, &l4SaltSize, &l4HashAlg, &zpOutBuffer, &zl4OutSize, &oAntiTimingParams, TElRSAAntiTimingParams_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpBlob) == IS_STRING) || (Z_TYPE_P(zpBlob) == IS_ARRAY) || (Z_TYPE_P(zpBlob) == IS_NULL) || ((Z_TYPE_P(zpBlob) == IS_OBJECT) && (Z_OBJCE_P(zpBlob) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpSalt) == IS_STRING) || (Z_TYPE_P(zpSalt) == IS_ARRAY) || (Z_TYPE_P(zpSalt) == IS_NULL) || ((Z_TYPE_P(zpSalt) == IS_OBJECT) && (Z_OBJCE_P(zpSalt) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpBlob, &piBlob TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpSalt, &piSalt TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(SBRSA_DecryptOAEP_1(piInBuffer.data, (int32_t)l4InSize, piBlob.data, (int32_t)l4BlobSize, piSalt.data, (int32_t)l4SaltSize, (int32_t)l4HashAlg, piOutBuffer.data, &l4OutSizeRaw, SBGetObjectHandle(oAntiTimingParams TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piBlob);
		SBFreePointerZValInfo(&piSalt);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, integer, TSBPointer|array of byte|string|NULL, &integer, TElRSAAntiTimingParams) or (TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, integer, TSBPointer|array of byte|string|NULL, &integer, TElRSAAntiTimingParams)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRSA, DecodePublicKey)
{
	int32_t l4PublicExponentSizeRaw;
	int32_t l4PublicModulusSizeRaw;
	long l4Size;
	SBArrayZValInfo aiAlgID;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piPublicExponent;
	SBArrayZValInfo piPublicModulus;
	uint32_t _err;
	zend_bool bInnerValuesOnly;
	zval *zaAlgID;
	zval *zl4PublicExponentSize;
	zval *zl4PublicModulusSize;
	zval *zpBuffer;
	zval *zpPublicExponent;
	zval *zpPublicModulus;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzzzzzb", &zpBuffer, &l4Size, &zpPublicModulus, &zl4PublicModulusSize, &zpPublicExponent, &zl4PublicExponentSize, &zaAlgID, &bInnerValuesOnly) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpPublicModulus) == IS_STRING) || (Z_TYPE_P(zpPublicModulus) == IS_ARRAY) || (Z_TYPE_P(zpPublicModulus) == IS_NULL) || ((Z_TYPE_P(zpPublicModulus) == IS_OBJECT) && (Z_OBJCE_P(zpPublicModulus) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PublicModulusSize) && (IS_LONG == Z_TYPE_P(zl4PublicModulusSize)) && ((Z_TYPE_P(zpPublicExponent) == IS_STRING) || (Z_TYPE_P(zpPublicExponent) == IS_ARRAY) || (Z_TYPE_P(zpPublicExponent) == IS_NULL) || ((Z_TYPE_P(zpPublicExponent) == IS_OBJECT) && (Z_OBJCE_P(zpPublicExponent) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4PublicExponentSize) && (IS_LONG == Z_TYPE_P(zl4PublicExponentSize)) && PZVAL_IS_REF(zaAlgID) && ((IS_STRING == Z_TYPE_P(zaAlgID)) || (IS_ARRAY == Z_TYPE_P(zaAlgID))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpPublicModulus, &piPublicModulus TSRMLS_CC)) RETURN_FALSE;
		l4PublicModulusSizeRaw = (int32_t)Z_LVAL_P(zl4PublicModulusSize);
		if (!SBGetPointerFromZVal(zpPublicExponent, &piPublicExponent TSRMLS_CC)) RETURN_FALSE;
		l4PublicExponentSizeRaw = (int32_t)Z_LVAL_P(zl4PublicExponentSize);
		if (!SBGetByteArrayFromZVal(zaAlgID, &aiAlgID TSRMLS_CC)) RETURN_FALSE;
		_err = SBRSA_DecodePublicKey(piBuffer.data, (int32_t)l4Size, piPublicModulus.data, &l4PublicModulusSizeRaw, piPublicExponent.data, &l4PublicExponentSizeRaw, aiAlgID.data, &aiAlgID.len, (int8_t)bInnerValuesOnly, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaAlgID, &aiAlgID TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(2077103448, 6, aiAlgID.data, &aiAlgID.len) TSRMLS_CC);
			((char *)aiAlgID.data)[aiAlgID.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiAlgID);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreePointerZValInfo(&piBuffer);
		SBFreePointerZValInfo(&piPublicModulus);
		ZVAL_LONG(zl4PublicModulusSize, (long)l4PublicModulusSizeRaw);
		SBFreePointerZValInfo(&piPublicExponent);
		ZVAL_LONG(zl4PublicExponentSize, (long)l4PublicExponentSizeRaw);
		SBSetByteArrayToZVal(&aiAlgID, zaAlgID);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer, &array of byte|string, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRSA, EncodePublicKey)
{
	int32_t l4OutSizeRaw;
	long l4PublicExponentSize;
	long l4PublicModulusSize;
	SBArrayZValInfo aiAlgID;
	SBArrayZValInfo piOutBuffer;
	SBArrayZValInfo piPublicExponent;
	SBArrayZValInfo piPublicModulus;
	zend_bool bInnerValuesOnly;
	zval *zaAlgID;
	zval *zl4OutSize;
	zval *zpOutBuffer;
	zval *zpPublicExponent;
	zval *zpPublicModulus;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzzzb", &zpPublicModulus, &l4PublicModulusSize, &zpPublicExponent, &l4PublicExponentSize, &zaAlgID, &zpOutBuffer, &zl4OutSize, &bInnerValuesOnly) == SUCCESS) && ((Z_TYPE_P(zpPublicModulus) == IS_STRING) || (Z_TYPE_P(zpPublicModulus) == IS_ARRAY) || (Z_TYPE_P(zpPublicModulus) == IS_NULL) || ((Z_TYPE_P(zpPublicModulus) == IS_OBJECT) && (Z_OBJCE_P(zpPublicModulus) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpPublicExponent) == IS_STRING) || (Z_TYPE_P(zpPublicExponent) == IS_ARRAY) || (Z_TYPE_P(zpPublicExponent) == IS_NULL) || ((Z_TYPE_P(zpPublicExponent) == IS_OBJECT) && (Z_OBJCE_P(zpPublicExponent) == TSBPointer_ce_ptr))) && ((IS_STRING == Z_TYPE_P(zaAlgID)) || (IS_ARRAY == Z_TYPE_P(zaAlgID)) || (IS_NULL == Z_TYPE_P(zaAlgID))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpPublicModulus, &piPublicModulus TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpPublicExponent, &piPublicExponent TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgID, &aiAlgID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(SBRSA_EncodePublicKey(piPublicModulus.data, (int32_t)l4PublicModulusSize, piPublicExponent.data, (int32_t)l4PublicExponentSize, aiAlgID.data, aiAlgID.len, piOutBuffer.data, &l4OutSizeRaw, (int8_t)bInnerValuesOnly, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piPublicModulus);
		SBFreePointerZValInfo(&piPublicExponent);
		SBFreeArrayZValInfo(&aiAlgID);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, array of byte|string|NULL, TSBPointer|array of byte|string|NULL, &integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRSA, SignPSS)
{
	int32_t l4SignatureSizeRaw;
	long l4HashAlgorithm;
	long l4HashValueSize;
	long l4KeyBlobSize;
	long l4PrivateExponentSize;
	long l4PublicExponentSize;
	long l4PublicModulusSize;
	long l4SaltSize;
	SBArrayZValInfo piHashValue;
	SBArrayZValInfo piKeyBlob;
	SBArrayZValInfo piPrivateExponent;
	SBArrayZValInfo piPublicExponent;
	SBArrayZValInfo piPublicModulus;
	SBArrayZValInfo piSignature;
	zval *oAntiTimingParams;
	zval *zl4SignatureSize;
	zval *zpHashValue;
	zval *zpKeyBlob;
	zval *zpPrivateExponent;
	zval *zpPublicExponent;
	zval *zpPublicModulus;
	zval *zpSignature;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlllzlzzO!", &zpHashValue, &l4HashValueSize, &l4HashAlgorithm, &l4SaltSize, &zpKeyBlob, &l4KeyBlobSize, &zpSignature, &zl4SignatureSize, &oAntiTimingParams, TElRSAAntiTimingParams_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpHashValue) == IS_STRING) || (Z_TYPE_P(zpHashValue) == IS_ARRAY) || (Z_TYPE_P(zpHashValue) == IS_NULL) || ((Z_TYPE_P(zpHashValue) == IS_OBJECT) && (Z_OBJCE_P(zpHashValue) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpKeyBlob) == IS_STRING) || (Z_TYPE_P(zpKeyBlob) == IS_ARRAY) || (Z_TYPE_P(zpKeyBlob) == IS_NULL) || ((Z_TYPE_P(zpKeyBlob) == IS_OBJECT) && (Z_OBJCE_P(zpKeyBlob) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpSignature) == IS_STRING) || (Z_TYPE_P(zpSignature) == IS_ARRAY) || (Z_TYPE_P(zpSignature) == IS_NULL) || ((Z_TYPE_P(zpSignature) == IS_OBJECT) && (Z_OBJCE_P(zpSignature) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4SignatureSize) && (IS_LONG == Z_TYPE_P(zl4SignatureSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpHashValue, &piHashValue TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpKeyBlob, &piKeyBlob TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpSignature, &piSignature TSRMLS_CC)) RETURN_FALSE;
		l4SignatureSizeRaw = (int32_t)Z_LVAL_P(zl4SignatureSize);
		SBCheckError(SBRSA_SignPSS(piHashValue.data, (int32_t)l4HashValueSize, (int32_t)l4HashAlgorithm, (int32_t)l4SaltSize, piKeyBlob.data, (int32_t)l4KeyBlobSize, piSignature.data, &l4SignatureSizeRaw, SBGetObjectHandle(oAntiTimingParams TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piHashValue);
		SBFreePointerZValInfo(&piKeyBlob);
		SBFreePointerZValInfo(&piSignature);
		ZVAL_LONG(zl4SignatureSize, (long)l4SignatureSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlllzlzlzlzzO!", &zpHashValue, &l4HashValueSize, &l4HashAlgorithm, &l4SaltSize, &zpPublicModulus, &l4PublicModulusSize, &zpPublicExponent, &l4PublicExponentSize, &zpPrivateExponent, &l4PrivateExponentSize, &zpSignature, &zl4SignatureSize, &oAntiTimingParams, TElRSAAntiTimingParams_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpHashValue) == IS_STRING) || (Z_TYPE_P(zpHashValue) == IS_ARRAY) || (Z_TYPE_P(zpHashValue) == IS_NULL) || ((Z_TYPE_P(zpHashValue) == IS_OBJECT) && (Z_OBJCE_P(zpHashValue) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpPublicModulus) == IS_STRING) || (Z_TYPE_P(zpPublicModulus) == IS_ARRAY) || (Z_TYPE_P(zpPublicModulus) == IS_NULL) || ((Z_TYPE_P(zpPublicModulus) == IS_OBJECT) && (Z_OBJCE_P(zpPublicModulus) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpPublicExponent) == IS_STRING) || (Z_TYPE_P(zpPublicExponent) == IS_ARRAY) || (Z_TYPE_P(zpPublicExponent) == IS_NULL) || ((Z_TYPE_P(zpPublicExponent) == IS_OBJECT) && (Z_OBJCE_P(zpPublicExponent) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpPrivateExponent) == IS_STRING) || (Z_TYPE_P(zpPrivateExponent) == IS_ARRAY) || (Z_TYPE_P(zpPrivateExponent) == IS_NULL) || ((Z_TYPE_P(zpPrivateExponent) == IS_OBJECT) && (Z_OBJCE_P(zpPrivateExponent) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpSignature) == IS_STRING) || (Z_TYPE_P(zpSignature) == IS_ARRAY) || (Z_TYPE_P(zpSignature) == IS_NULL) || ((Z_TYPE_P(zpSignature) == IS_OBJECT) && (Z_OBJCE_P(zpSignature) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4SignatureSize) && (IS_LONG == Z_TYPE_P(zl4SignatureSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpHashValue, &piHashValue TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpPublicModulus, &piPublicModulus TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpPublicExponent, &piPublicExponent TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpPrivateExponent, &piPrivateExponent TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpSignature, &piSignature TSRMLS_CC)) RETURN_FALSE;
		l4SignatureSizeRaw = (int32_t)Z_LVAL_P(zl4SignatureSize);
		SBCheckError(SBRSA_SignPSS_1(piHashValue.data, (int32_t)l4HashValueSize, (int32_t)l4HashAlgorithm, (int32_t)l4SaltSize, piPublicModulus.data, (int32_t)l4PublicModulusSize, piPublicExponent.data, (int32_t)l4PublicExponentSize, piPrivateExponent.data, (int32_t)l4PrivateExponentSize, piSignature.data, &l4SignatureSizeRaw, SBGetObjectHandle(oAntiTimingParams TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piHashValue);
		SBFreePointerZValInfo(&piPublicModulus);
		SBFreePointerZValInfo(&piPublicExponent);
		SBFreePointerZValInfo(&piPrivateExponent);
		SBFreePointerZValInfo(&piSignature);
		ZVAL_LONG(zl4SignatureSize, (long)l4SignatureSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, integer, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TElRSAAntiTimingParams) or (TSBPointer|array of byte|string|NULL, integer, integer, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TElRSAAntiTimingParams)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRSA, VerifyPSS)
{
	long l4HashAlgorithm;
	long l4HashValueSize;
	long l4PublicExponentSize;
	long l4PublicModulusSize;
	long l4SaltSize;
	long l4SignatureSize;
	SBArrayZValInfo piHashValue;
	SBArrayZValInfo piPublicExponent;
	SBArrayZValInfo piPublicModulus;
	SBArrayZValInfo piSignature;
	zval *zpHashValue;
	zval *zpPublicExponent;
	zval *zpPublicModulus;
	zval *zpSignature;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlllzlzlzl", &zpHashValue, &l4HashValueSize, &l4HashAlgorithm, &l4SaltSize, &zpPublicModulus, &l4PublicModulusSize, &zpPublicExponent, &l4PublicExponentSize, &zpSignature, &l4SignatureSize) == SUCCESS) && ((Z_TYPE_P(zpHashValue) == IS_STRING) || (Z_TYPE_P(zpHashValue) == IS_ARRAY) || (Z_TYPE_P(zpHashValue) == IS_NULL) || ((Z_TYPE_P(zpHashValue) == IS_OBJECT) && (Z_OBJCE_P(zpHashValue) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpPublicModulus) == IS_STRING) || (Z_TYPE_P(zpPublicModulus) == IS_ARRAY) || (Z_TYPE_P(zpPublicModulus) == IS_NULL) || ((Z_TYPE_P(zpPublicModulus) == IS_OBJECT) && (Z_OBJCE_P(zpPublicModulus) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpPublicExponent) == IS_STRING) || (Z_TYPE_P(zpPublicExponent) == IS_ARRAY) || (Z_TYPE_P(zpPublicExponent) == IS_NULL) || ((Z_TYPE_P(zpPublicExponent) == IS_OBJECT) && (Z_OBJCE_P(zpPublicExponent) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpSignature) == IS_STRING) || (Z_TYPE_P(zpSignature) == IS_ARRAY) || (Z_TYPE_P(zpSignature) == IS_NULL) || ((Z_TYPE_P(zpSignature) == IS_OBJECT) && (Z_OBJCE_P(zpSignature) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpHashValue, &piHashValue TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpPublicModulus, &piPublicModulus TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpPublicExponent, &piPublicExponent TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpSignature, &piSignature TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBRSA_VerifyPSS(piHashValue.data, (int32_t)l4HashValueSize, (int32_t)l4HashAlgorithm, (int32_t)l4SaltSize, piPublicModulus.data, (int32_t)l4PublicModulusSize, piPublicExponent.data, (int32_t)l4PublicExponentSize, piSignature.data, (int32_t)l4SignatureSize, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piHashValue);
		SBFreePointerZValInfo(&piPublicModulus);
		SBFreePointerZValInfo(&piPublicExponent);
		SBFreePointerZValInfo(&piSignature);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, integer, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRSA, PerformExponentiation)
{
	int32_t l4OutSizeRaw;
	long l4BlobSize;
	long l4ExponentSize;
	long l4InSize;
	long l4ModulusSize;
	SBArrayZValInfo piBlob;
	SBArrayZValInfo piExponent;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piModulus;
	SBArrayZValInfo piOutBuffer;
	zval *oAntiTimingParams;
	zval *zl4OutSize;
	zval *zpBlob;
	zval *zpExponent;
	zval *zpInBuffer;
	zval *zpModulus;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzlzzO!", &zpModulus, &l4ModulusSize, &zpExponent, &l4ExponentSize, &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize, &oAntiTimingParams, TElRSAAntiTimingParams_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpModulus) == IS_STRING) || (Z_TYPE_P(zpModulus) == IS_ARRAY) || (Z_TYPE_P(zpModulus) == IS_NULL) || ((Z_TYPE_P(zpModulus) == IS_OBJECT) && (Z_OBJCE_P(zpModulus) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpExponent) == IS_STRING) || (Z_TYPE_P(zpExponent) == IS_ARRAY) || (Z_TYPE_P(zpExponent) == IS_NULL) || ((Z_TYPE_P(zpExponent) == IS_OBJECT) && (Z_OBJCE_P(zpExponent) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpModulus, &piModulus TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpExponent, &piExponent TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(SBRSA_PerformExponentiation(piModulus.data, (int32_t)l4ModulusSize, piExponent.data, (int32_t)l4ExponentSize, piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, SBGetObjectHandle(oAntiTimingParams TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piModulus);
		SBFreePointerZValInfo(&piExponent);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzzO!", &zpBlob, &l4BlobSize, &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize, &oAntiTimingParams, TElRSAAntiTimingParams_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpBlob) == IS_STRING) || (Z_TYPE_P(zpBlob) == IS_ARRAY) || (Z_TYPE_P(zpBlob) == IS_NULL) || ((Z_TYPE_P(zpBlob) == IS_OBJECT) && (Z_OBJCE_P(zpBlob) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBlob, &piBlob TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(SBRSA_PerformExponentiation_1(piBlob.data, (int32_t)l4BlobSize, piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, SBGetObjectHandle(oAntiTimingParams TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBlob);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TElRSAAntiTimingParams) or (TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TElRSAAntiTimingParams)" TSRMLS_CC);
	}
}

