#include "sbzuncompressunit.h"

SB_PHP_METHOD(code, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(code));
		intern->len = sizeof(code);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(code, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(code));
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(code, get_op)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(code, set_op)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(code, get_bits)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 1);
}

SB_PHP_METHOD(code, set_bits)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 1);
}

SB_PHP_METHOD(code, get_val)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 2);
}

SB_PHP_METHOD(code, set_val)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 2);
}

zend_class_entry *code_ce_ptr = NULL;

static zend_function_entry code_methods[] = {
	PHP_ME(code, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(code, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(code, get_op, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(code, set_op, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(code, get_bits, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(code, set_bits, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(code, get_val, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(code, set_val, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_code(TSRMLS_D)
{
	zend_class_entry ce;
	if (code_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "code", code_methods);
	code_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TArrShr, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TArrShr));
		intern->len = sizeof(TArrShr);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TArrShr, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TArrShr));
}

zend_class_entry *TArrShr_ce_ptr = NULL;

static zend_function_entry TArrShr_methods[] = {
	PHP_ME(TArrShr, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TArrShr, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TArrShr(TSRMLS_D)
{
	zend_class_entry ce;
	if (TArrShr_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TArrShr", TArrShr_methods);
	TArrShr_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TArrShr288, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TArrShr288));
		intern->len = sizeof(TArrShr288);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TArrShr288, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TArrShr288));
}

zend_class_entry *TArrShr288_ce_ptr = NULL;

static zend_function_entry TArrShr288_methods[] = {
	PHP_ME(TArrShr288, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TArrShr288, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TArrShr288(TSRMLS_D)
{
	zend_class_entry ce;
	if (TArrShr288_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TArrShr288", TArrShr288_methods);
	TArrShr288_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TArrCds, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TArrCds));
		intern->len = sizeof(TArrCds);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TArrCds, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TArrCds));
}

zend_class_entry *TArrCds_ce_ptr = NULL;

static zend_function_entry TArrCds_methods[] = {
	PHP_ME(TArrCds, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TArrCds, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TArrCds(TSRMLS_D)
{
	zend_class_entry ce;
	if (TArrCds_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TArrCds", TArrCds_methods);
	TArrCds_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TArrCds31, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TArrCds31));
		intern->len = sizeof(TArrCds31);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TArrCds31, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TArrCds31));
}

zend_class_entry *TArrCds31_ce_ptr = NULL;

static zend_function_entry TArrCds31_methods[] = {
	PHP_ME(TArrCds31, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TArrCds31, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TArrCds31(TSRMLS_D)
{
	zend_class_entry ce;
	if (TArrCds31_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TArrCds31", TArrCds31_methods);
	TArrCds31_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TArrCds511, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TArrCds511));
		intern->len = sizeof(TArrCds511);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TArrCds511, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TArrCds511));
}

zend_class_entry *TArrCds511_ce_ptr = NULL;

static zend_function_entry TArrCds511_methods[] = {
	PHP_ME(TArrCds511, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TArrCds511, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TArrCds511(TSRMLS_D)
{
	zend_class_entry ce;
	if (TArrCds511_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TArrCds511", TArrCds511_methods);
	TArrCds511_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *inflate_mode_ce_ptr = NULL;

SB_PHP_METHOD(inflate_state_s, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(inflate_state_s));
		intern->len = sizeof(inflate_state_s);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(inflate_state_s, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(inflate_state_s));
}

SB_PHP_METHOD(inflate_state_s, get_last)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(inflate_state_s, set_last)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(inflate_state_s, get_wrap)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(inflate_state_s, set_wrap)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(inflate_state_s, get_havedict)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(inflate_state_s, set_havedict)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 12);
}

SB_PHP_METHOD(inflate_state_s, get_check)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(inflate_state_s, set_check)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 16);
}

SB_PHP_METHOD(inflate_state_s, get_total)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(inflate_state_s, set_total)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 20);
}

SB_PHP_METHOD(inflate_state_s, get_wbits)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(inflate_state_s, set_wbits)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 24);
}

SB_PHP_METHOD(inflate_state_s, get_wsize)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 28);
}

SB_PHP_METHOD(inflate_state_s, set_wsize)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 28);
}

SB_PHP_METHOD(inflate_state_s, get_whave)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 32);
}

SB_PHP_METHOD(inflate_state_s, set_whave)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 32);
}

SB_PHP_METHOD(inflate_state_s, get_Write)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 36);
}

SB_PHP_METHOD(inflate_state_s, set_Write)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 36);
}

SB_PHP_METHOD(inflate_state_s, get_hold)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 40);
}

SB_PHP_METHOD(inflate_state_s, set_hold)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 40);
}

SB_PHP_METHOD(inflate_state_s, get_bits)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 44);
}

SB_PHP_METHOD(inflate_state_s, set_bits)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 44);
}

SB_PHP_METHOD(inflate_state_s, get_Length)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 48);
}

SB_PHP_METHOD(inflate_state_s, set_Length)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 48);
}

SB_PHP_METHOD(inflate_state_s, get_offset)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 52);
}

SB_PHP_METHOD(inflate_state_s, set_offset)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 52);
}

SB_PHP_METHOD(inflate_state_s, get_extra)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 56);
}

SB_PHP_METHOD(inflate_state_s, set_extra)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 56);
}

SB_PHP_METHOD(inflate_state_s, get_lenbits)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 72);
}

SB_PHP_METHOD(inflate_state_s, set_lenbits)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 72);
}

SB_PHP_METHOD(inflate_state_s, get_distbits)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 76);
}

SB_PHP_METHOD(inflate_state_s, set_distbits)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 76);
}

SB_PHP_METHOD(inflate_state_s, get_ncode)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 80);
}

SB_PHP_METHOD(inflate_state_s, set_ncode)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 80);
}

SB_PHP_METHOD(inflate_state_s, get_nlen)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 84);
}

SB_PHP_METHOD(inflate_state_s, set_nlen)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 84);
}

SB_PHP_METHOD(inflate_state_s, get_ndist)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 88);
}

SB_PHP_METHOD(inflate_state_s, set_ndist)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 88);
}

SB_PHP_METHOD(inflate_state_s, get_have)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 92);
}

SB_PHP_METHOD(inflate_state_s, set_have)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 92);
}

zend_class_entry *inflate_state_s_ce_ptr = NULL;

static zend_function_entry inflate_state_s_methods[] = {
	PHP_ME(inflate_state_s, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(inflate_state_s, get_last, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, set_last, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, get_wrap, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, set_wrap, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, get_havedict, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, set_havedict, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, get_check, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, set_check, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, get_total, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, set_total, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, get_wbits, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, set_wbits, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, get_wsize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, set_wsize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, get_whave, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, set_whave, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, get_Write, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, set_Write, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, get_hold, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, set_hold, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, get_bits, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, set_bits, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, get_Length, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, set_Length, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, get_offset, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, set_offset, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, get_extra, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, set_extra, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, get_lenbits, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, set_lenbits, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, get_distbits, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, set_distbits, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, get_ncode, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, set_ncode, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, get_nlen, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, set_nlen, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, get_ndist, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, set_ndist, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, get_have, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(inflate_state_s, set_have, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_inflate_state_s(TSRMLS_D)
{
	zend_class_entry ce;
	if (inflate_state_s_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "inflate_state_s", inflate_state_s_methods);
	inflate_state_s_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBZUncompressUnit, inflateReset)
{
	zval *oz;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oz, TZStreamRec_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oz))
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBZUncompressUnit_inflateReset((TZStreamRec *)SBGetStructPointer(oz TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&TZStreamRec)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBZUncompressUnit, inflateInit_)
{
	long l4stream_size;
	SBArrayZValInfo aiversion;
	zval *oz;
	zval *zaversion;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozl", &oz, TZStreamRec_ce_ptr, &zaversion, &l4stream_size) == SUCCESS) && PZVAL_IS_REF(oz) && ((IS_STRING == Z_TYPE_P(zaversion)) || (IS_ARRAY == Z_TYPE_P(zaversion)) || (IS_NULL == Z_TYPE_P(zaversion))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaversion, &aiversion TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBZUncompressUnit_inflateInit_((TZStreamRec *)SBGetStructPointer(oz TSRMLS_CC), aiversion.data, aiversion.len, (int32_t)l4stream_size, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiversion);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&TZStreamRec, array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBZUncompressUnit, inflateInit2_)
{
	long l4stream_size;
	long l4w;
	SBArrayZValInfo aiversion;
	zval *oz;
	zval *zaversion;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Olzl", &oz, TZStreamRec_ce_ptr, &l4w, &zaversion, &l4stream_size) == SUCCESS) && PZVAL_IS_REF(oz) && ((IS_STRING == Z_TYPE_P(zaversion)) || (IS_ARRAY == Z_TYPE_P(zaversion)) || (IS_NULL == Z_TYPE_P(zaversion))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaversion, &aiversion TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBZUncompressUnit_inflateInit2_((TZStreamRec *)SBGetStructPointer(oz TSRMLS_CC), (int32_t)l4w, aiversion.data, aiversion.len, (int32_t)l4stream_size, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiversion);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&TZStreamRec, integer, array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBZUncompressUnit, inflateEnd)
{
	zval *oz;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oz, TZStreamRec_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oz))
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBZUncompressUnit_inflateEnd((TZStreamRec *)SBGetStructPointer(oz TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&TZStreamRec)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBZUncompressUnit, inflate)
{
	long l4f;
	zval *oz;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ol", &oz, TZStreamRec_ce_ptr, &l4f) == SUCCESS) && PZVAL_IS_REF(oz))
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBZUncompressUnit_inflate((TZStreamRec *)SBGetStructPointer(oz TSRMLS_CC), (int32_t)l4f, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&TZStreamRec, integer)" TSRMLS_CC);
	}
}

void Register_SBZUncompressUnit_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBZUncompressUnit, MANY, SB_MANY, SB_MANY);
	SB_REGISTER_LONG_CONSTANT(SBZUncompressUnit, DEF_WBITS, SB_DEF_WBITS, SB_DEF_WBITS);
	SB_REGISTER_LONG_CONSTANT(SBZUncompressUnit, BMAX, SB_BMAX, SB_BMAX);
}

void Register_SBZUncompressUnit_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "inflate_mode", NULL);
	inflate_mode_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	inflate_mode_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(inflate_mode_ce_ptr, "HEAD", 0)
	SB_DECLARE_CLASS_LONG_CONST(inflate_mode_ce_ptr, "DICTID", 1)
	SB_DECLARE_CLASS_LONG_CONST(inflate_mode_ce_ptr, "DICT", 2)
	SB_DECLARE_CLASS_LONG_CONST(inflate_mode_ce_ptr, "TYPEB", 3)
	SB_DECLARE_CLASS_LONG_CONST(inflate_mode_ce_ptr, "TYPEDO", 4)
	SB_DECLARE_CLASS_LONG_CONST(inflate_mode_ce_ptr, "STORED", 5)
	SB_DECLARE_CLASS_LONG_CONST(inflate_mode_ce_ptr, "COPY", 6)
	SB_DECLARE_CLASS_LONG_CONST(inflate_mode_ce_ptr, "TABLE", 7)
	SB_DECLARE_CLASS_LONG_CONST(inflate_mode_ce_ptr, "LENLENS", 8)
	SB_DECLARE_CLASS_LONG_CONST(inflate_mode_ce_ptr, "CODELENS", 9)
	SB_DECLARE_CLASS_LONG_CONST(inflate_mode_ce_ptr, "LEN", 10)
	SB_DECLARE_CLASS_LONG_CONST(inflate_mode_ce_ptr, "LENEXT", 11)
	SB_DECLARE_CLASS_LONG_CONST(inflate_mode_ce_ptr, "DIST", 12)
	SB_DECLARE_CLASS_LONG_CONST(inflate_mode_ce_ptr, "DISTEXT", 13)
	SB_DECLARE_CLASS_LONG_CONST(inflate_mode_ce_ptr, "MATCH", 14)
	SB_DECLARE_CLASS_LONG_CONST(inflate_mode_ce_ptr, "LIT", 15)
	SB_DECLARE_CLASS_LONG_CONST(inflate_mode_ce_ptr, "CHECK", 16)
	SB_DECLARE_CLASS_LONG_CONST(inflate_mode_ce_ptr, "DONE", 17)
	SB_DECLARE_CLASS_LONG_CONST(inflate_mode_ce_ptr, "BAD", 18)
	SB_DECLARE_CLASS_LONG_CONST(inflate_mode_ce_ptr, "MEM", 19)
	SB_DECLARE_CLASS_LONG_CONST(inflate_mode_ce_ptr, "SYNC", 20)
}

