#ifndef __INC_CSBIGFIVE
#define __INC_CSBIGFIVE

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbchsconvbase.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
typedef TElClassHandle TPlBigFiveHandle;

#ifdef SB_USE_CLASS_TPLBIGFIVE
SB_IMPORT uint32_t SB_APIENTRY TPlBigFive_GetCategory(TPlBigFiveHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TPlBigFive_GetDescription(TPlBigFiveHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TPlBigFive_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TPlBigFive_Create(TPlTableCharsetHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TPlBigFive_CreateForFinalize(TPlTableCharsetHandle * OutResult);
#endif /* SB_USE_CLASS_TPLBIGFIVE */

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TPlBigFive_ce_ptr;

void Register_TPlBigFive(TSRMLS_D);

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_CSBIGFIVE */

