#ifndef __INC_CSHKSCS
#define __INC_CSHKSCS

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbchsconvbase.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
typedef TElClassHandle TPlHKSCSDataHandle;

#ifdef SB_USE_CLASS_TPLHKSCSDATA
SB_IMPORT uint32_t SB_APIENTRY TPlHKSCSData_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TPlHKSCSData_Create(TPlTableCharsetHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TPlHKSCSData_CreateForFinalize(TPlTableCharsetHandle * OutResult);
#endif /* SB_USE_CLASS_TPLHKSCSDATA */

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TPlHKSCSData_ce_ptr;

void Register_TPlHKSCSData(TSRMLS_D);

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_CSHKSCS */

